#include "common.h"
#include "ArchiverAISH.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"


CArchiverAISH::CArchiverAISH()
{
//	TRACE("CArchiverAISH()\n");
	RequiredVersion=4;
	DllName=_T("AISH32.DLL");
	Prefix=_T("Aish");
	LoadLevel=LOAD_DLL_MINIMUM;
}

CArchiverAISH::~CArchiverAISH()
{
//	TRACE("~CArchiverAISH()\n");
	FreeDLL();
}

bool CArchiverAISH::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE Type,int)
{
	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);


	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString ParamOrg;//R}hC p[^ obt@

	Config.LoadConfig(CONFIG_AISH);
	switch(Type){
	case PARAMETER_ISH:
		switch(Config.AISH.EncodeType){
		case ISH_SHIFT_JIS:
			ParamOrg+=_T("-s ");
			break;
		case ISH_JIS7:
			ParamOrg+=_T("-7 ");
			break;
		case ISH_JIS8:
			ParamOrg+=_T("-8 ");
			break;
		case ISH_NON_KANA_SHIFT_JIS:
			ParamOrg+=_T("-n ");
			break;
		}
		break;
	case PARAMETER_UUE:
		ParamOrg+=_T("-u ");
		if(Config.AISH.UUEncodeChecksum){
			ParamOrg+=_T("-c ");
		}
		break;
	}
	ParamOrg+=_T("-o ");	//o̓t@Cw

	//----------------------
	// ԂɃt@C
	//----------------------
	//ꎞo͐t@CXg
	std::list<CString> TemporaryFileList;

	std::list<CString>::iterator ite;
	int Ret=0;
	CString Log;
	for(ite=ParamList.begin();ite!=ParamList.end();ite++){
		//==========================
		// e|t@C擾
		//==========================

		TCHAR TempFileName[_MAX_PATH+1];
		FILL_ZERO(TempFileName);
		if(!UtilGetTemporaryFileName(TempFileName,_T("ish"))){
			Log+=_T("LhaForge : Failed to get temporary file.\r\n");
			Ret=-1;
			break;
		}
		ASSERT(0!=_tcslen(TempFileName));
		TemporaryFileList.push_back(TempFileName);

		CString Param=ParamOrg;
		Param+=_T("\"");
		Param+=TempFileName;
		Param+=_T("\" \".\\");
		Param+=*ite;
		Param+=_T("\"");

		ASSERT(!Param.IsEmpty());
		TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

		TRACE("ArchiveHandlerĂяo\n");
		TCHAR LogBuffer[LOG_BUFFER_SIZE];
		FILL_ZERO(LogBuffer);
		Ret=ArchiveHandler(NULL,Param,LogBuffer,LOG_BUFFER_SIZE-1);
		Log+=LogBuffer;
		Log+=_T("\r\n");
		if(Ret)break;
	}

	bool bDeleteOutput=false;	//o͐t@C폜Kv邩ǂ
	if(!Ret){
		Log+=_T("LhaForge is Appending files...\r\n");

		HANDLE hArcFile=CreateFile(ArcFileName,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hArcFile){
			Log+=_T("Error : Failed to open ");
			Log+=ArcFileName;
			Log+=_T(" for output.\r\n");
			Ret=-1;
		}
		else{
			std::list<CString>::iterator ite=TemporaryFileList.begin();
			const std::list<CString>::iterator end=TemporaryFileList.end();
			//e|t@C
			for(;ite!=end;ite++){
				HANDLE hFile=CreateFile(*ite,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
				int res=UtilAppendFile(hArcFile,hFile);
				if(0!=res){
					if(res<0){	//݃G[
						Log+=_T("\r\nError : Failed to write file ");
						Log+=ArcFileName;
						Log+=_T(".\r\n");
					}
					else{	//ǂݍ݃G[
						Log+=_T("\r\nError : Failed to read temporary file.\r\n");
					}
					Ret=-1;
					bDeleteOutput=true;
					break;
				}
				CloseHandle(hFile);
				Log+=_T("o");
			}
			CloseHandle(hArcFile);
			if(!Ret){
				Log+=_T(":done\r\n");
			}
			if(bDeleteOutput){
				DeleteFile(ArcFileName);
			}
		}
	}

	//ge|t@C͏
	{
		std::list<CString>::iterator ite=TemporaryFileList.begin();
		const std::list<CString>::iterator end=TemporaryFileList.end();
		for(;ite!=end;ite++){
			DeleteFile(*ite);
		}
	}

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

bool CArchiverAISH::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^͂Ȃ
	if(Config.Common.Extract.ForceOverwrite){
		//ftHg͋㏑
	}
	else{
		Param+=_T("-f -h ");
/*	-f	łɓ̓WJt@C݂ĂꍇAʃt@Cɂ
		Ďo܂Bt@C̍ŌɊgq .00 .99 ܂B

	-h	-f IvVgpAt@C̍Ōɂł͂Ȃ擪 XX 
		ċʂ܂B̊gqۑꍇɎg܂B
*/
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

/*	//o͐w͂łȂ̂ŁAJgfBNgɓfo悤ɂ
łɏo͐悪JgɂȂĂƌėǂ
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");*/

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

bool CArchiverAISH::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &,CString &BaseDir)
{
	bInFolder=false;
	return true;
//	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,_T("*.*"),_T('\\'),0);
}

//ish/uuet@CɃt@Cȏ܂܂邩ǂ
bool CArchiverAISH::HasFiles(LPCTSTR ArcFileName)
{
	if(!IsOK()){
		ASSERT(!"Load DLL first!!!");
		return false;
	}

	CString Param;//R}hC p[^ obt@
	Param+=_T("-l ");

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	CString Log;
	try{
		int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
		Log.ReleaseBuffer();
		if(Ret)return false;
	}catch(...){
		return false;
	}

	//O
	Log.Replace(_T("\r\n"),_T("\n"));
	int Index=Log.Find(_T('\n'),0);
	int CopyFrom=0;
	while(true){
		if(-1==Index){
			if(Log.IsEmpty())return false;
			else return true;
		}
		//s̐؂o
		if(Index==CopyFrom||Index+1==CopyFrom){
			CopyFrom=Index+1;
			Index=Log.Find(_T('\n'),Index+1);
			continue;
		}
		return true;
	}
}

BOOL CArchiverAISH::CheckArchive(LPCSTR _szFileName)
{
//	TRACE("AISH CheckArchive()\n");
	if(!ArchiverCheckArchive){
		ASSERT(ArchiverCheckArchive);
		return false;
	}
	if(!ArchiverCheckArchive(_szFileName,0))return FALSE;

	//AISH()CheckArchive̓t@C݂̑mFďI邾Ȃ̂ŁA蔻𐳊mɂ邽߂
	//A[JCuɃt@C܂܂Ă邱ƂmF
	if(!HasFiles(_szFileName))return FALSE;
	return TRUE;
}

bool CArchiverAISH::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}

//ȉ̃R[hisȟ͏o邪AMȂߍ̗pȂ
//DEL bool CArchiverAISH::TestArchive(LPCSTR ArcFileName)
//DEL {
//DEL 	TRACE("TestArchive() called.\n");
//DEL 	ASSERT(IsOK());
//DEL 	if(!IsOK()){
//DEL 		return false;
//DEL 	}
//DEL 
//DEL 	//ۂɓWJăeXg
//DEL 	CString Param=_T(
//DEL 		"-o NUL "		//ۂɓWJ邪At@C͕ۑȂ
//DEL 
//DEL 		"\""
//DEL 	);
//DEL 	Param+=ArcFileName;
//DEL 	Param+=_T("\"");
//DEL 
//DEL 	//t@COɒǉ
//DEL 	CString Log=ArcFileName;
//DEL 	Log+=_T("\r\n\r\n");
//DEL 	//ǉ
//DEL 	Log+=_T(
//DEL 		"Status Examples:\r\n"
//DEL 		"o : OK\r\n"
//DEL 		"e : NG\r\n\r\n"
//DEL 
//DEL 		"----------\r\n"
//DEL 		);
//DEL 
//DEL 	CString Temp;
//DEL 	ArchiveHandler(NULL,Param,Temp.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
//DEL 	Temp.ReleaseBuffer();
//DEL 
//DEL 	Log+=Temp;
//DEL 
//DEL 	//O\
//DEL 	CLogDialog LogDlg;
//DEL 	LogDlg.SetData(Log);
//DEL 	LogDlg.DoModal();
//DEL 	return true;
//DEL }
