#include "common.h"
#include "ArchiverB2E.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"
#include <mbctype.h>


CArchiverB2E::CArchiverB2E():
	B2ESetScriptDirectory(NULL),
	B2EScriptGetCount(NULL),
	B2EScriptGetAbility(NULL),
	B2EScriptGetCompressType(NULL),
	B2EScriptGetCompressMethod(NULL),
	B2EScriptGetDefaultCompressMethod(NULL),
	B2EScriptGetExtractorIndex(NULL)
{
//	TRACE("CArchiverB2E()\n");
	RequiredVersion=4;
	DllName=_T("B2E32.DLL");
	Prefix=_T("B2E");
}

CArchiverB2E::~CArchiverB2E()
{
//	TRACE("~CArchiverB2E()\n");
	FreeDLL();
}

LOAD_RESULT CArchiverB2E::LoadDLL(CConfigManager &Config,bool bSilent)
{
	FreeDLL();

	//NX̃\bhĂ
	LOAD_RESULT res=CArchiverDLL::LoadDLL(Config,bSilent);
	if(LOAD_RESULT_OK!=res){
		return res;
	}

	//ƎAPIQ
	B2ESetScriptDirectory=(B2ESETSCRIPTDIRECTORY)GetProcAddress(hInstDLL,_T("B2ESetScriptDirectory"));
	if(NULL==B2ESetScriptDirectory){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2ESetScriptDirectory"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCount=(B2ESCRIPTGETCOUNT)GetProcAddress(hInstDLL,_T("B2EScriptGetCount"));
	if(NULL==B2EScriptGetCount){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetCount"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetAbility=(B2ESCRIPTGETABILITY)GetProcAddress(hInstDLL,_T("B2EScriptGetAbility"));
	if(NULL==B2EScriptGetAbility){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetAbility"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCompressType=(B2ESCRIPTGETCOMPRESSTYPE)GetProcAddress(hInstDLL,_T("B2EScriptGetCompressType"));
	if(NULL==B2EScriptGetCompressType){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetCompressType"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetCompressMethod=(B2ESCRIPTGETCOMPRESSMETHOD)GetProcAddress(hInstDLL,_T("B2EScriptGetCompressMethod"));
	if(NULL==B2EScriptGetCompressMethod){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetCompressMethod"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetDefaultCompressMethod=(B2ESCRIPTGETDEFAULTCOMPRESSMETHOD)GetProcAddress(hInstDLL,_T("B2EScriptGetDefaultCompressMethod"));
	if(NULL==B2EScriptGetDefaultCompressMethod){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetDefaultCompressMethod"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	B2EScriptGetExtractorIndex=(B2ESCRIPTGETEXTRACTORINDEX)GetProcAddress(hInstDLL,_T("B2EScriptGetExtractorIndex"));
	if(NULL==B2EScriptGetExtractorIndex){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,_T("B2EScriptGetExtractorIndex"));
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	// [h
	//===================
	// ݒ
	Config.LoadConfig(CONFIG_B2E);
	if(_tcslen(Config.B2E.ScriptDirectory)>0&&PathIsDirectory(Config.B2E.ScriptDirectory)){
		B2ESetScriptDirectory(Config.B2E.ScriptDirectory);
	}

	return LOAD_RESULT_OK;
}

void CArchiverB2E::FreeDLL()
{
	if(hInstDLL){
		B2ESetScriptDirectory=NULL;
		B2EScriptGetCount=NULL;
		B2EScriptGetAbility=NULL;
		B2EScriptGetCompressType=NULL;
		B2EScriptGetCompressMethod=NULL;
		B2EScriptGetDefaultCompressMethod=NULL;
		B2EScriptGetExtractorIndex=NULL;
		CArchiverDLL::FreeDLL();
	}
}

bool CArchiverB2E::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE,int Options)
{
	ASSERT(!"This Code Cannot be called");
	return false;
}

bool CArchiverB2E::B2ECompress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,LPCTSTR lpszFormat,LPCTSTR lpszMethod,bool bSFX)
{
	if(!IsOK()||!lpszFormat){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("b2e")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE("X|Xt@Cւ̏\n");
		//kt@C
		WriteResponceFile(hFile,ArcFileName);

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//---kp[^
	//k`
	Param =_T("\"-c");
	Param+=lpszFormat;
	Param+=_T("\" ");

	//k\bh
	if(lpszMethod&&_tcslen(lpszMethod)>0){
		Param+=_T("\"-m");
		Param+=lpszMethod;
		Param+=_T("\" ");
	}

	//ȉ
	if(bSFX){
		Param+=_T("-s ");
	}

	//X|Xt@Cw
	Param+=_T("\"-@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);

	//---s
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		{
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	}
	return 0==Ret;
}

bool CArchiverB2E::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	if(!bSafeArchive){
		//sȃpX΁As邩ǂmF
		//ApX`FbNs\ȂƂɂ͂̌xoȂB
		CString msg;
		msg.Format(IDS_ASK_CONTINUE_EXTRACT,ArcFileName);
		if(IDYES!=MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)){
			return false;
		}
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"-e "	//
	);
	//㏑ɂ͖Ή

	//o͐w
	Param+=_T("\"-o");
	Param+=OutputDir;
	Param+=_T("\" ");

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//X|Xt@CɃt@CGXP[vsŏށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverB2E::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,fname,_tcslen(fname)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}


//=========================================================
// B2EGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverB2E::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	if(!IsOK()){
		return false;
	}
/*	UINT uIndex=B2EScriptGetExtractorIndex(ArcFileName);
	if(uIndex==0xFFFFFFFF)return false;	//Ή`G[

	WORD wAbility;
	if(!B2EScriptGetAbility(uIndex,&wAbility))return false;
	if(!(wAbility&B2EABILITY_LIST))return false;	//łȂ*/

	//------
	//łȂƂɂ́AExamineArchive̎|񍐂Ă̂łKv͂Ȃ

	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,0,BaseDir);
}

bool CArchiverB2E::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("b2e")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"-e "			//
		"-g "			//pX𖳌
	);
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"-o");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"-@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverB2E::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}

bool CArchiverB2E::QueryExtractSpecifiedOnlySupported(LPCTSTR ArcFileName)
{
	UINT uIndex=B2EScriptGetExtractorIndex(ArcFileName);
	if(uIndex==0xFFFFFFFF)return false;	//Ή`G[

	WORD wAbility;
	if(!B2EScriptGetAbility(uIndex,&wAbility))return false;
	if(wAbility&B2EABILITY_MELT_EACH)return true;	//ʉ𓀂łȂ
	return false;
}

bool CArchiverB2E::EnumCompressB2EScript(std::vector<B2ESCRIPTINFO> &ScriptInfoArray)
{
	ScriptInfoArray.clear();

	//XNvg̐擾
	const UINT uScriptCount=B2EScriptGetCount();

	if(uScriptCount==-1)return false;	//G[

	for(UINT uIndex=0;uIndex<uScriptCount;uIndex++){
		B2ESCRIPTINFO Info;
		Info.uIndex=uIndex;

		//\͂擾
		B2EScriptGetAbility(uIndex,&Info.wAbility);

		if(Info.wAbility&B2EABILITY_COMPRESS){	//---k\͂
			//k`擾
			B2EScriptGetCompressType(uIndex,Info.szFormat,_MAX_PATH);
			//k\bh擾
			{
				int i=0;
				TCHAR Buffer[_MAX_PATH+1]={0};
				while(B2EScriptGetCompressMethod(uIndex,i,Buffer,_MAX_PATH)){
					Info.MethodArray.push_back(Buffer);
					i++;
				}
			}

			//ftHgk\bhԍ擾
			Info.nDefaultMethod=B2EScriptGetDefaultCompressMethod(uIndex);
			//---ǉ
			ScriptInfoArray.push_back(Info);
		}
	}
	return true;
}
