#include "common.h"
#include "ArchiverBGA.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"
#include <mbctype.h>


CArchiverBGA::CArchiverBGA()
{
//	TRACE("CArchiverBGA()\n");
	LoadLevel=LOAD_DLL_SIMPLE_INSPECTION;
	RequiredVersion=37;
	DllName=_T("Bga32.dll");
	Prefix=_T("Bga");
	FindParam=_T("*.*");
}

CArchiverBGA::~CArchiverBGA()
{ 
//	TRACE("~CArchiverBGA()\n");
	FreeDLL();
}

bool CArchiverBGA::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE Type,int Options)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("bga")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//============================================
	// ȉ𓀃t@Cpe|t@C擾
	//============================================
	TCHAR SFXTemporaryFileName[_MAX_PATH+1];
	FILL_ZERO(SFXTemporaryFileName);
	bool bSFX=(0!=(Options&COMPRESS_SFX));
	if(bSFX){
		//2iK쐬
		if(!UtilGetTemporaryFileName(SFXTemporaryFileName,_T("sfx")))return false;
		ASSERT(0!=_tcslen(SFXTemporaryFileName));
	}

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE("X|Xt@Cւ̏\n");
		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=_T(
		"a "		//k
		"-a "		//SΏ
	);
	Config.LoadConfig(CONFIG_BGA);
	CString level;
	switch(Type){
	case PARAMETER_GZA:
		Param+=_T("-m1 ");
		level.Format(_T("-l%d "),Config.BGA.GZALevel);
		Param+=level;
		break;
	case PARAMETER_BZA:
		Param+=_T("-m2 ");
		level.Format(_T("-l%d "),Config.BGA.BZALevel);
		Param+=level;
		break;
	}

	//o͐t@Cw
	if(bSFX){
		Param+=_T("\"");
		Param+=SFXTemporaryFileName;
		Param+=_T("\" ");
	}
	else{
		Param+=_T("\"");
		Param+=ArcFileName;
		Param+=_T("\" ");
	}

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	if(!bSFX||0!=Ret){
		if(bSFX){
			DeleteFile(SFXTemporaryFileName);
		}
		switch(Config.Common.LogViewEvent){
		case LOGVIEW_ON_ERROR:
			if(Ret){
				CLogDialog LogDlg;
				LogDlg.SetData(Log);
				LogDlg.DoModal();
			}
			break;
		case LOGVIEW_ALWAYS:
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
			break;
		}

		return 0==Ret;
	}

	//====================
	// ȉ𓀏ɂɕϊ
	//====================
	//ϊp[^
	Param=_T(
		"s "		//ϊ
	);

	Param+=_T("\"");
	Param+=SFXTemporaryFileName;	//ϊt@C
	Param+=_T("\" ");

	//------------------------------------------------------------------------------------------
	//:
	// ȉ𓀃t@C̃t@C̓e|t@C̊gq.exeɕς̂ɂȂĂ
	//------------------------------------------------------------------------------------------

	//o͐tH_(e|tH_)w
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);
	_tcsncpy(Buffer,SFXTemporaryFileName,_MAX_PATH);
	PathRemoveFileSpec(Buffer);
	PathAddBackslash(Buffer);
	Param+=_T("\"");
	Param+=Buffer;
	Param+=_T("\" ");


	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter(SFX):%s\n",Param);

	TRACE("SFXpArchiveHandlerĂяo\n");
	TCHAR LogSFX[LOG_BUFFER_SIZE];
	FILL_ZERO(LogSFX);
	Ret=ArchiveHandler(NULL,Param,LogSFX,LOG_BUFFER_SIZE-1);

	DeleteFile(SFXTemporaryFileName);
	if(!Ret){	//I
		//ϊ̎ȉ𓀃t@Co
		PathRemoveExtension(SFXTemporaryFileName);
		PathAddExtension(SFXTemporaryFileName,_T(".exe"));
		MoveFile(SFXTemporaryFileName,ArcFileName);
	}

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		{
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	}
	return 0==Ret;
}

bool CArchiverBGA::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}
	if(!bSafeArchive){
		CString msg;
		msg.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"x "		//pXt
		"-a "		//S
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-o ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//X|Xt@CɃt@CށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverBGA::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);

	_tcsncpy(Buffer,fname,_MAX_PATH);
	PathQuoteSpaces(Buffer);

	TRACE(Buffer);
	TRACE("\n");

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}


//=========================================================
// BgaGetFileName()̏o͌ʂɁAi[ꂽt@CpX
//Ă邩ǂʂAdtH_쐬h
// SmFs
//=========================================================
bool CArchiverBGA::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,-1,BaseDir);
}

bool CArchiverBGA::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("bga")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"x "			//
		"-a "			//S
		"-j "			//pX
	);
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");


	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverBGA::DeleteFileFromArchive(LPCTSTR ArcFileName,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("bga")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//폜Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//폜p[^
	Param+=_T(
		"d "		//폜
		"-i "		//mFȂ
	);
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverBGA::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}
