#include "common.h"
#include "ArchiverUNARJ.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"
#include <mbctype.h>

CArchiverUNARJ::CArchiverUNARJ()
{
//	TRACE("CArchiverUNARJ()\n");
	InspectMode=0x00000002L;//M_REGARDLESS_INIT_FILE:WXg̐ݒ𖳎B
//	Separator=_T('\\');
	RequiredVersion=63;
	DllName=_T("UNARJ32J.DLL");
	Prefix=_T("Unarj");
}

CArchiverUNARJ::~CArchiverUNARJ()
{
//	TRACE("~CArchiverUNARJ()\n");
	FreeDLL();
}

bool CArchiverUNARJ::Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int)
{
	//ARJ͉𓀂̂
	ASSERT(false);
	return false;
}

//bSafeArchive͖
bool CArchiverUNARJ::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"x "			//
		"-++ "			//UNARJ32.DLL̃WXg̐ݒ𖳎
		"-htm+ "		//TEhg
		"-htp7 "		//sȃpX
		"-htc+ "		//WJłȂt@C̐Ԃ
		"-hte+ "		//㏑I[vG[
		"-jyc "			//tH_쐬̊mFLZ
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-jyo ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//=========================================================
// UnarjGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverUNARJ::ExamineArchive(LPCTSTR ArcFileName,bool bSkipDir,bool &bInFolder,bool &,CString &BaseDir)
{
	if(bSkipDir){
		TRACE("dtH_\n");
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,bInFolder,BaseDir);
}

bool CArchiverUNARJ::InspectArchiveGetWriteTime(FILETIME &FileTime)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	//gŊ֐Ŏ擾
	if(ArchiverGetWriteTimeEx){
		FILETIME TempTime;
		if(!ArchiverGetWriteTimeEx(m_hInspectArchive,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
	//ʏŊ֐Ŏ擾
	else if(ArchiverGetWriteTime){
		DWORD UnixTime=ArchiverGetWriteTime(m_hInspectArchive);
		if(-1==UnixTime){
			return false;
		}
		//time_tFileTime֕ϊ
		LONGLONG ll = Int32x32To64(UnixTime, 10000000) + 116444736000000000;
		FileTime.dwLowDateTime = (DWORD) ll;
		FileTime.dwHighDateTime = (DWORD)(ll >>32);
		return true;
	}
	else{
		//INDIVIDUALINFO玞擾
		FILETIME TempTime;
		if(!DosDateTimeToFileTime(m_IndividualInfo.wDate,m_IndividualInfo.wTime,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
}

//X|Xt@CɃt@CGXP[vsŏށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverUNARJ::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+4];
	FILL_ZERO(Buffer);

	//t@C̐擪'-'Ȃ-hb(t@C)Ƃ
	if(_MBC_SINGLE==_mbsbtype((const unsigned char*)fname,0)&&_T('-')==fname[0]){
		_sntprintf(Buffer,_MAX_PATH+3,_T("-hb%s"),fname);
	}
	else{
		_tcsncpy(Buffer,fname,_MAX_PATH);
	}
	PathQuoteSpaces(Buffer);

	TRACE(Buffer);
	TRACE("\n");

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}

bool CArchiverUNARJ::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("arj")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"e "			//pX
		"-r- "			//ċAȂ
		"-++ "			//UNARJ32.DLL̃WXg̐ݒ𖳎
		"-htm+ "		//TEhg
		"-htp7 "		//sȃpX
		"-htc+ "		//WJłȂt@C̐Ԃ
		"-hte+ "		//㏑I[vG[
		"-jyc "			//tH_쐬̊mFLZ
	);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"!");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNARJ::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}

	//tR}hɂeXgĂ
	CString Param=_T(
		"t "			//eXg
		"-++ "			//UNARJ32.DLL̃WXg̐ݒ𖳎

		"\""
	);
	Param+=ArcFileName;
	Param+=_T("\"");

	CString Log;
	ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//O\
	CLogDialog LogDlg;
	LogDlg.SetData(Log);
	LogDlg.DoModal();
	return true;
}
