#include "common.h"
#include "ArchiverUNBEL.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"


CArchiverUNBEL::CArchiverUNBEL()
{
//	TRACE("CArchiverUNBEL()\n");
	RequiredVersion=45;
	DllName=_T("Unbel32.DLL");
	Prefix=_T("Unbel");
	LoadLevel=LOAD_DLL_MINIMUM;
//	LoadLevel=LOAD_DLL_SIMPLE_INSPECTION;
}

CArchiverUNBEL::~CArchiverUNBEL()
{
//	TRACE("~CArchiverUNBEL()\n");
	FreeDLL();
}

LOAD_RESULT CArchiverUNBEL::LoadDLL(CConfigManager &Config,bool bSilent)
{
	FreeDLL();
	LOAD_RESULT res=CArchiverDLL::LoadDLL(Config,bSilent);
	if(LOAD_RESULT_OK!=res){
		return res;
	}

	CString FunctionName=Prefix;
	FunctionName+=_T("OpenArchive");
	ArchiverOpenArchive=(COMMON_ARCHIVER_OPENARCHIVE)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverOpenArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	FunctionName=Prefix;
	FunctionName+=_T("CloseArchive");
	ArchiverCloseArchive=(COMMON_ARCHIVER_CLOSEARCHIVE)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverCloseArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindFirst
	FunctionName=Prefix;
	FunctionName+=_T("FindFirst");
	ArchiverFindFirst=(COMMON_ARCHIVER_FINDFIRST)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverFindFirst){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//t@C擾
	FunctionName=Prefix;
	FunctionName+=_T("GetFileName");
	ArchiverGetFileName=(COMMON_ARCHIVER_GETFILENAME)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileName){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	return LOAD_RESULT_OK;
}

bool CArchiverUNBEL::Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int)
{
	//BEL͉𓀂̂
	ASSERT(false);
	return false;
}

bool CArchiverUNBEL::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}
	if(!bSafeArchive){
		CString msg;
		msg.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^͂Ȃ
//	if(Config.Common.Extract.ForceOverwrite){
		//㏑͂łȂ
//	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//=========================================================
// Belon`̓t@Ci[łȂA
// t@C͊gq3݂̂ێĂȂ
// ADTV͋NB
//=========================================================
bool CArchiverUNBEL::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	bInFolder=false;
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName)){
		CString msg;
		msg.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	CString Buffer;
	InspectArchiveNext();		//Pt@Ĉ݊i[
	InspectArchiveGetFileName(Buffer);
	InspectArchiveEnd();

	Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
	TRACE("%s\n",Buffer);

	if(-1!=Buffer.Find(_T("../"))){
		bSafeArchive=false;
	}
	else{
		bSafeArchive=true;
	}
	return true;
//	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,_T("*.*"),_T('\\'),0);
}

bool CArchiverUNBEL::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString>&)
{
	return false;
}

bool CArchiverUNBEL::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}
