#include "common.h"
#include "ArchiverUNGCA.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"


CArchiverUNGCA::CArchiverUNGCA()
{
//	TRACE("CArchiverUNGCA()\n");
//	Separator=_T('\\');
	RequiredVersion=11;
	RequiredSubVersion=2;
	DllName=_T("UnGCA32.DLL");
	Prefix=_T("UnGCA");
}

CArchiverUNGCA::~CArchiverUNGCA()
{
//	TRACE("~CArchiverUNGCA()\n");
	FreeDLL();
}

bool CArchiverUNGCA::Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int)
{
	//GCA͉𓀂̂
	ASSERT(false);
	return false;
}

bool CArchiverUNGCA::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool bSafeArchive,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}
	if(!bSafeArchive){
		CString msg;
		msg.Format(IDS_ERROR_DANGEROUS_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"e "			//
		"-sx1 "			//i_CAO\
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-yx0 ");
	}
	else{
		Param+=_T("-yx1 ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//=========================================================
// UnGCAGetFileName()̏o͌ʂɁAi[ꂽt@CpX
//Ă邩ǂʂAdtH_쐬h
// SmFs
//=========================================================
bool CArchiverUNGCA::ExamineArchive(LPCTSTR ArcFileName,bool,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	return _ExamineArchive(ArcFileName,bInFolder,bSafeArchive,0,BaseDir);
}

BOOL CArchiverUNGCA::CheckArchive(LPCSTR _szFileName)
{
	if(!ArchiverCheckArchive){
		ASSERT(ArchiverCheckArchive);
		return false;
	}
	return ArchiverCheckArchive(_szFileName,16);	//CHECKARCHIVE_ALL
}

bool CArchiverUNGCA::InspectArchiveGetWriteTime(FILETIME &FileTime)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	//gŊ֐Ŏ擾
	if(ArchiverGetWriteTimeEx){
		FILETIME TempTime;
		if(!ArchiverGetWriteTimeEx(m_hInspectArchive,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
	//ʏŊ֐Ŏ擾
	else if(ArchiverGetWriteTime){
		DWORD UnixTime=ArchiverGetWriteTime(m_hInspectArchive);
		if(-1==UnixTime){
			return false;
		}
		//time_tFileTime֕ϊ
		LONGLONG ll = Int32x32To64(UnixTime, 10000000) + 116444736000000000;
		FileTime.dwLowDateTime = (DWORD) ll;
		FileTime.dwHighDateTime = (DWORD)(ll >>32);
		return true;
	}
	else{
		//INDIVIDUALINFO玞擾
		FILETIME TempTime;
		if(!DosDateTimeToFileTime(m_IndividualInfo.wDate,m_IndividualInfo.wTime,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
}

void CArchiverUNGCA::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);

	_tcsncpy(Buffer,fname,_MAX_PATH);
	PathQuoteSpaces(Buffer);

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}

bool CArchiverUNGCA::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("gca")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"ex "		//wt@C
		"-sx1 "		//i_CAO\
		"-yx1 "		//㏑mF
	);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNGCA::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}
