#include "common.h"
#include "ArchiverUNHKI.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"

CArchiverUNHKI::CArchiverUNHKI()
{
//	TRACE("CArchiverUNHKI()\n");
//	Separator=_T('\\');
	RequiredVersion=2;
	RequiredSubVersion=85;
	DllName=_T("UnHki32.DLL");
	Prefix=_T("UnHki");
}

CArchiverUNHKI::~CArchiverUNHKI()
{
//	TRACE("~CArchiverUNHKI()\n");
	FreeDLL();
}

bool CArchiverUNHKI::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE,int Options)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("hki")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//============================================
	// ȉ𓀃t@Cpe|t@C擾
	//============================================
	TCHAR SFXTemporaryFileName[_MAX_PATH+1];
	FILL_ZERO(SFXTemporaryFileName);
	bool bSFX=(0!=(Options&COMPRESS_SFX));
	if(bSFX){
		//2iK쐬
		if(!UtilGetTemporaryFileName(SFXTemporaryFileName,_T("sfx")))return false;
		ASSERT(0!=_tcslen(SFXTemporaryFileName));
	}

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE("X|Xt@Cւ̏\n");

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=_T(
		"a "	//k
		"-a1 "	//ۑ
		"-r0 "	//ċAI
		"-jf0 "	//[gL폜
	);
	Config.LoadConfig(CONFIG_HKI);
	//pX[h
	if(Options&COMPRESS_PASSWORD){
		Param+=_T("-mp ");
		switch(Config.HKI.EncryptAlgorithm){
		case HKI_ENCRYPT_NONE:
			Param+=_T("-me0 ");
			break;
		case HKI_ENCRYPT_RIJNDAEL128:
			Param+=_T("-me1 ");
			break;
		case HKI_ENCRYPT_RIJNDAEL256:
			Param+=_T("-me2 ");
			break;
		case HKI_ENCRYPT_SINGLE_DES:
			Param+=_T("-me3 ");
			break;
		case HKI_ENCRYPT_TRIPLE_DES:
			Param+=_T("-me4 ");
			break;
		case HKI_ENCRYPT_BLOWFISH448:
			Param+=_T("-me5 ");
			break;
		case HKI_ENCRYPT_TWOFISH128:
			Param+=_T("-me6 ");
			break;
		case HKI_ENCRYPT_TWOFISH256:
			Param+=_T("-me7 ");
			break;
		case HKI_ENCRYPT_SQUARE:
			Param+=_T("-me8 ");
			break;
		}
	}

	//kx
	switch(Config.HKI.CompressLevel){
	case HKI_COMPRESS_LEVEL_NONE:
		Param+=_T("-ml0 ");
		break;
	case HKI_COMPRESS_LEVEL_FAST:
		Param+=_T("-ml1 ");
		break;
	case HKI_COMPRESS_LEVEL_NORMAL:
		Param+=_T("-ml2 ");
		break;
	case HKI_COMPRESS_LEVEL_HIGH:
		Param+=_T("-ml3 ");
		break;
	}

	//kt@C̐ݒ
	if(bSFX){
		Param+=_T("\"");
		Param+=SFXTemporaryFileName;
		Param+=_T("\" ");
	}
	else{
		Param+=_T("\"");
		Param+=ArcFileName;
		Param+=_T("\" ");
	}
 
	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	if(!bSFX||0!=Ret){
		if(bSFX){
			DeleteFile(SFXTemporaryFileName);
		}
		switch(Config.Common.LogViewEvent){
		case LOGVIEW_ON_ERROR:
			if(Ret){
				CLogDialog LogDlg;
				LogDlg.SetData(Log);
				LogDlg.DoModal();
			}
			break;
		case LOGVIEW_ALWAYS:
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
			break;
		}

		return 0==Ret;
	}

	//====================
	// ȉ𓀏ɂɕϊ
	//====================
	//ϊp[^
	Param=_T("s ");		//ϊ

	//SFXW[pX
	TCHAR SFXModulePath[_MAX_PATH+1];
	FILL_ZERO(SFXModulePath);
	LPTSTR lptemp;
	if(!SearchPath(NULL,_T("HKI.SFX"),NULL,_MAX_PATH,SFXModulePath,&lptemp)){
		CString msg;
		msg.Format(IDS_ERROR_SFX_MODULE_NOT_FOUND,_T("HKI.SFX"));
		DeleteFile(SFXTemporaryFileName);
		ErrorMessage(msg);
		return false;
	}
	PathQuoteSpaces(SFXModulePath);
	Param+=_T("-mx");
	Param+=SFXModulePath;
	Param+=_T(" ");

	Param+=("-gr\"");	//ϊt@C
	Param+=ArcFileName;
	Param+=_T("\" \"");
	Param+=SFXTemporaryFileName;	//ϊt@C
	Param+=_T("\" ");


	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter(SFX):%s\n",Param);

	TRACE("SFXpArchiveHandlerĂяo\n");
	TCHAR LogSFX[LOG_BUFFER_SIZE];
	FILL_ZERO(LogSFX);
	Ret=ArchiveHandler(NULL,Param,LogSFX,LOG_BUFFER_SIZE-1);

	DeleteFile(SFXTemporaryFileName);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		{
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	}
	return 0==Ret;
}

//bSafeArchive͖
bool CArchiverUNHKI::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"x "			//
		"-a1 "			//ۑ
//		"-r1 "			//ċAI
		"-x1 "			//pXێ
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-gf1 ");
	}
	else{
		Param+=_T("-gf0 ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//X|Xt@CɃt@CށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverUNHKI::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
/*	TCHAR Buffer[_MAX_PATH+4];
	FILL_ZERO(Buffer);

	//t@C̐擪'-'Ȃ-zi(t@C)Ƃ
	if(_MBC_SINGLE==_mbsbtype((const unsigned char*)fname,0)&&_T('-')==fname[0]){
		_sntprintf(Buffer,_MAX_PATH+3,_T("-zi%s"),fname);
	}
	else{
		_tcsncpy(Buffer,fname,_MAX_PATH);
	}

*/

	DWORD dwWritten=0;
	//t@Co
//	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);
	WriteFile(hFile,fname,_tcslen(fname)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}


//=========================================================
// UnHkiGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverUNHKI::ExamineArchive(LPCTSTR ArcFileName,bool bSkipDir,bool &bInFolder,bool &bSafeArchive,CString &BaseDir)
{
	if(bSkipDir){
		TRACE("dtH_\n");
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,bInFolder,BaseDir);
}

BOOL CArchiverUNHKI::CheckArchive(LPCSTR _szFileName)
{
	if(!ArchiverCheckArchive){
		ASSERT(ArchiverCheckArchive);
		return false;
	}
	return ArchiverCheckArchive(_szFileName,0);	//CHECKARCHIVE_RAPID
}

bool CArchiverUNHKI::InspectArchiveGetWriteTime(FILETIME &FileTime)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	//gŊ֐Ŏ擾
	if(ArchiverGetWriteTimeEx){
		if(!ArchiverGetWriteTimeEx(m_hInspectArchive,&FileTime))return false;
		return true;
	}
	else{
		//INDIVIDUALINFO玞擾
		FILETIME TempTime;
		if(!DosDateTimeToFileTime(m_IndividualInfo.wDate,m_IndividualInfo.wTime,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
}

bool CArchiverUNHKI::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("hki")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"e "			//pX
		"-a1 "			//ۑ
//		"-r1 "			//ċAI
//		"-x1 "			//pXێ
		"-gf0 "			//㏑mF
	);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	//o͐fBNg쐬Ă
	if(!MakeSureDirectoryPathExists(OutputDir)){
		CString msg;
		msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,OutputDir);
		ErrorMessage(msg);
		return false;
	}

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNHKI::DeleteFileFromArchive(LPCTSTR ArcFileName,std::list<CString>& FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("hki")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//폜Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//폜p[^
	Param+=_T(
		"d "		//폜
	);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNHKI::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}

	//tR}hɂeXgĂ
	CString Param=_T(
		"t "			//eXg
		"-mt2 "			//[h:SCRC`FbN(CHECKARCHIVE_FULLCRC)

		"\""
	);
	Param+=ArcFileName;
	Param+=_T("\"");

	//t@COɒǉ
	CString Log=ArcFileName;
	Log+=_T("\r\n\r\n");
	int nRet=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	Log+=_T("\r\n");
	if(0==nRet){
		Log+=CString(MAKEINTRESOURCE(IDS_TESTARCHIVE_RESULT_OK));
	}
	else{
		Log+=CString(MAKEINTRESOURCE(IDS_TESTARCHIVE_RESULT_NG));
	}

	//O\
	CLogDialog LogDlg;
	LogDlg.SetData(Log);
	LogDlg.DoModal();
	return true;
}
