#include "common.h"
#include "ArchiverUNLHA.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"
#include <mbctype.h>


CArchiverUNLHA::CArchiverUNLHA()
{
//	TRACE("CArchiverUNLHA()\n");
	InspectMode=0x00000002L;	//M_REGARDLESS_INIT_FILE:WXg̒l
	RequiredVersion=202;
	DllName=_T("UNLHA32.DLL");
	Prefix=_T("Unlha");
}

CArchiverUNLHA::~CArchiverUNLHA()
{
//	TRACE("~CArchiverUNLHA()\n");
	FreeDLL();
}

bool CArchiverUNLHA::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE,int Options)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//============================================
	// ȉ𓀃t@Cpe|t@C擾
	//============================================
	TCHAR SFXTemporaryFileName[_MAX_PATH+1];
	FILL_ZERO(SFXTemporaryFileName);
	bool bSFX=(0!=(Options&COMPRESS_SFX));
	if(bSFX){
		//2iK쐬
		if(!UtilGetTemporaryFileName(SFXTemporaryFileName,_T("sfx")))return false;
		ASSERT(0!=_tcslen(SFXTemporaryFileName));
	}

	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		TRACE("X|Xt@Cւ̏\n");
		//kt@C
		if(bSFX){
			//e|t@C擾_ŋt@C邪A
			//ꂪG[̌ƂȂ̂ŏB
			//̏@ł̓e|t@C肳鋰
			DeleteFile(SFXTemporaryFileName);
			WriteResponceFile(hFile,SFXTemporaryFileName);
		}
		else{
			WriteResponceFile(hFile,ArcFileName);
		}

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=_T(
		"a "		//k
		"-d1 "		//tH_ƁESt@CΏ
		"-+1 "		//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jf0 "		//[gL폜
		"-jso1 "	//SH_DENYNO ł̃I[vsȂ
		"-jsm1 "	//TEhg
	);
	Config.LoadConfig(CONFIG_LZH);
	switch(Config.LZH.CompressType){
	case LZH_COMPRESS_LH5:
		Param+=_T("-jm2 ");
		break;
	case LZH_COMPRESS_LH0:
		Param+=_T("-jm0 ");
		break;
	case LZH_COMPRESS_LH1:
		Param+=_T("-jm1 ");
		break;
	case LZH_COMPRESS_LH6:
		Param+=_T("-jm3 ");
		break;
	case LZH_COMPRESS_LH7:
		Param+=_T("-jm4 ");
		break;
	}

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	if(!bSFX||0!=Ret){
		if(bSFX){
			DeleteFile(SFXTemporaryFileName);
		}
		switch(Config.Common.LogViewEvent){
		case LOGVIEW_ON_ERROR:
			if(Ret){
				CLogDialog LogDlg;
				LogDlg.SetData(Log);
				LogDlg.DoModal();
			}
			break;
		case LOGVIEW_ALWAYS:
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
			break;
		}

		return 0==Ret;
	}

	//====================
	// ȉ𓀏ɂɕϊ
	//====================
	//ϊp[^
	Param=_T(
		"s "		//ϊ
		"-d1 "		//tH_ƁESt@CΏ
		"-+1 "		//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jf0 "		//[gL폜
		"-jso1 "	//SH_DENYNO ł̃I[vsȂ
		"-jsm1 "	//TEhg
	);

	if(Config.LZH.ConfigSFX){
		Param+=_T("-gw3 ");	//ݒtWinSFX32M
	}
	else{
		Param+=_T("-gw4 ");	//ݒȂWinSFX32M
	}

	Param+=_T("\"");
	Param+=SFXTemporaryFileName;	//ϊt@C
	Param+=_T("\" ");

	//----------
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);
	_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
	PathRemoveFileSpec(Buffer);
	PathAddBackslash(Buffer);

	Param+=_T(" \"");
	Param+=Buffer;		//o͐pX
	Param+=_T("\" ");

	//----------
	Param+=("\"-gr");	//ϊt@C

	FILL_ZERO(Buffer);
	_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
	PathStripPath(Buffer);
	Param+=Buffer;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter(SFX):%s\n",Param);

	TRACE("SFXpArchiveHandlerĂяo\n");
	TCHAR LogSFX[LOG_BUFFER_SIZE];
	FILL_ZERO(LogSFX);
	Ret=ArchiveHandler(NULL,Param,LogSFX,LOG_BUFFER_SIZE-1);

	DeleteFile(SFXTemporaryFileName);

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		{
			CString Buf=Log;
			Buf+=LogSFX;
			CLogDialog LogDlg;
			LogDlg.SetData(Buf);
			LogDlg.DoModal();
		}
		break;
	}
	return 0==Ret;
}

//bSafeArchive͖
bool CArchiverUNLHA::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"e "			//
		"-x1 "			//pXL
		"-jyc "			//tH_쐬̊mFLZ
		"-a1 "			//t@C̑WJ
		"-c1 "			//^CX^vs
		"-+1 "			//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jf0 "			//[gL폜
		"-jso1 "		//SH_DENYNO ł̃I[vsȂ
		"-jsm1 "		//TEhg
		"-jsp7 "		//sȃpX
		"-jsc "			//WJłȂt@C̐Ԃ
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-jyo ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//X|Xt@CɃt@CGXP[vsŏށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverUNLHA::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+4];
	FILL_ZERO(Buffer);

	//t@C̐擪'-'Ȃ-gb(t@C)Ƃ
	if(_MBC_SINGLE==_mbsbtype((const unsigned char*)fname,0)&&_T('-')==fname[0]){
		_sntprintf(Buffer,_MAX_PATH+3,_T("-gb%s"),fname);
	}
	else{
		_tcsncpy(Buffer,fname,_MAX_PATH);
	}
	PathQuoteSpaces(Buffer);

//	TRACE(Buffer);
//	TRACE("\n");

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}


//=========================================================
// UnlhaGetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverUNLHA::ExamineArchive(LPCTSTR ArcFileName,bool bSkipDir,bool &bInFolder,bool &,CString &BaseDir)
{
	if(bSkipDir){
		TRACE("dtH_\n");
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,bInFolder,BaseDir);
}

bool CArchiverUNLHA::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"e "			//
		"-x0 "			//pX𖳌
		"-p1 "			//SpXōv
		"-jyc "			//tH_쐬̊mFLZ
		"-a2 "			//t@C̑WJ
		"-c1 "			//^CX^vs
		"-+1 "			//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jf0 "			//[gL폜
		"-jso1 "		//SH_DENYNO ł̃I[vsȂ
		"-jsm1 "		//TEhg
		"-jsp7 "		//sȃpX
		"-jsc "			//WJłȂt@C̐Ԃ
	);
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNLHA::DeleteFileFromArchive(LPCTSTR ArcFileName,std::list<CString>& FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("lzh")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//폜Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			//fBNg/菜
			if(_MBC_SINGLE==_mbsbtype((const unsigned char*)(LPCTSTR)*ite,(*ite).GetLength()-1)){
				if(/*Separator*/_T('/')==(*ite)[(*ite).GetLength()-1]){
					(*ite).Delete((*ite).GetLength()-1);
				}
			}
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//폜p[^
	Param+=_T(
		"d "			//폜
		"-r0 "			//ċA[h(ftHg)
		"-p1 "			//SpXōv
		"-+1 "			//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jso1 "		//SH_DENYNO ł̃I[vsȂ
		"-jsm1 "		//TEhg
		"-d "			//fBNg̊i[
	);
	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("@\"");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverUNLHA::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}

	//tR}hɂeXgĂ
	CString Param=_T(
		"t "			//eXg
		"-+1 "			//UNLHA32.DLL̃WXg̐ݒ𖳎
		"-jso1 "		//SH_DENYNO ł̃I[vsȂ

		"\""
	);
	Param+=ArcFileName;
	Param+=_T("\"");

	CString Log;
	ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//O\
	CLogDialog LogDlg;
	LogDlg.SetData(Log);
	LogDlg.DoModal();
	return true;
}
