#include "common.h"
#include "ArchiverYZ1.h"
#include "../util.h"
#include "../ConfigCode/config.h"
#include "../resource.h"

CArchiverYZ1::CArchiverYZ1()
{
//	TRACE("CArchiverYZ1()\n");
	InspectMode=0x00400000L;	//M_ERROR_MESSAGE_ON
//	Separator=_T('\\');
	RequiredVersion=27;
	DllName=_T("YZ1.DLL");
	Prefix=_T("Yz1");
}

CArchiverYZ1::~CArchiverYZ1()
{
//	TRACE("~CArchiverYZ1()\n");
	FreeDLL();
}

bool CArchiverYZ1::Compress(LPCTSTR ArcFileName,std::list<CString> &ParamList,CConfigManager &Config,const PARAMETER_TYPE,int Options)
{
	if(!IsOK()){
		return false;
	}

	ASSERT(0!=_tcslen(ArcFileName));
	TRACE("ArcFileName=%s\n",ArcFileName);

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("yz1")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));


	//==========================================
	// X|Xt@CɃA[JCu
	// kΏۃt@CL
	//==========================================
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite;
		for(ite=ParamList.begin();ite!=ParamList.end();ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//kp[^
	Param+=_T(
		"c "		//k
		"-r2 "		//fBNgċA[h
		"-x1 "		//fBNgi[
		"-+ "		//YZ1.DLL̃WXg̐ݒ𖳎
		"-ea1 "		//pXC
	);
	if(Options&COMPRESS_SFX){	//ȉ
		Param+=_T("-s ");
	}
	Config.LoadConfig(CONFIG_YZ1);
	if(Options&COMPRESS_PASSWORD){
		Param+=_T("-p ");
	}
	else if(Options&COMPRESS_PUBLIC_PASSWORD){
		Param+=_T("-P ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	TCHAR Log[LOG_BUFFER_SIZE];
	FILL_ZERO(Log);
	int Ret=ArchiveHandler(NULL,Param,Log,LOG_BUFFER_SIZE-1);

	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	//G[Oo
	if(0!=Ret){
		switch(Config.Common.LogViewEvent){
		case LOGVIEW_ON_ERROR:
			if(Ret){
				CLogDialog LogDlg;
				LogDlg.SetData(Log);
				LogDlg.DoModal();
			}
			break;
		case LOGVIEW_ALWAYS:
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
			break;
		}
	}
	return 0==Ret;
}

//bSafeArchive͖
bool CArchiverYZ1::Extract(LPCTSTR ArcFileName,CConfigManager &Config,bool,LPCTSTR OutputDir)
{
	if(!IsOK()){
		return false;
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	TRACE("DLLɓnIvV̐ݒ\n");

	CString Param;//R}hC p[^ obt@

	//𓀃p[^
	Param+=_T(
		"x "			//
		"-x1 "			//pXL
		"-+ "			//YZ1.DLL̃WXg̐ݒ𖳎
		"-ea1 "			//sȃpXǂ邩
	);
	if(Config.Common.Extract.ForceOverwrite){
		//㏑
		Param+=_T("-c1 ");
	}
	else{
		Param+=_T("-c2 ");
	}

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐w
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\"");

	ASSERT(!Param.IsEmpty());
	TRACE("ArchiveHandler Commandline Parameter:%s\n",Param);

	TRACE("ArchiveHandlerĂяo\n");
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();

	//G[Oo
	switch(Config.Common.LogViewEvent){
	case LOGVIEW_ON_ERROR:
		if(Ret){
			CLogDialog LogDlg;
			LogDlg.SetData(Log);
			LogDlg.DoModal();
		}
		break;
	case LOGVIEW_ALWAYS:
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
		break;
	}

	return 0==Ret;
}

//X|Xt@CɃt@CށB
//Lȃt@CnhNULLłȂt@CnƁB
void CArchiverYZ1::WriteResponceFile(HANDLE hFile,LPCTSTR fname)
{
	TCHAR Buffer[_MAX_PATH+1];
	FILL_ZERO(Buffer);

	_tcsncpy(Buffer,fname,_MAX_PATH);
	PathQuoteSpaces(Buffer);

	DWORD dwWritten=0;
	//t@Co
	WriteFile(hFile,Buffer,_tcslen(Buffer)*sizeof(TCHAR),&dwWritten,NULL);

	//t@C؂邽߂̉s
	TCHAR CRLF[]=_T("\r\n");
	WriteFile(hFile,&CRLF,_tcslen(CRLF)*sizeof(TCHAR),&dwWritten,NULL);
}


//=========================================================
// Yz1GetFileName()̏o͌ʂɁAi[ꂽt@CpX
// Ă邩ǂʂAdtH_쐬h
//=========================================================
bool CArchiverYZ1::ExamineArchive(LPCTSTR ArcFileName,bool bSkipDir,bool &bInFolder,bool &,CString &BaseDir)
{
	if(bSkipDir){
		TRACE("dtH_\n");
		return true;
	}
	return _ExamineArchiveFast(ArcFileName,bInFolder,BaseDir);
}

bool CArchiverYZ1::ExtractSpecifiedOnly(LPCTSTR ArcFileName,LPCTSTR OutputDir,std::list<CString> &FileList)
{
	if(!IsOK()){
		return false;
	}

	//==============================================
	// X|Xt@Cpe|t@C擾
	//==============================================
	TCHAR ResponceFileName[_MAX_PATH+1];
	FILL_ZERO(ResponceFileName);
	if(!UtilGetTemporaryFileName(ResponceFileName,_T("yz1")))return false;
	ASSERT(0!=_tcslen(ResponceFileName));

	//𓀑Ώۃt@CX|Xt@Cɏo
	{
		HANDLE hFile=CreateFile(ResponceFileName,GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile)
		{
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_TEMPORARY_FILE_ACCESS)));
			return false;
		}

		std::list<CString>::iterator ite=FileList.begin();
		const std::list<CString>::iterator end=FileList.end();
		for(;ite!=end;ite++){
			WriteResponceFile(hFile,*ite);
		}
		CloseHandle(hFile);
	}

	//===========================
	// DLLɓnIvV̐ݒ
	//===========================
	CString Param;

	//𓀃p[^
	Param+=_T(
		"x "		//
		"-x0 "		//pX𖳌
//		"-+ "		//YZ1.DLL̃WXg̐ݒ𖳎
		"-ea1 "		//sȃpXǂ邩
		"-c2 "		//㏑mF
		"-z1 "		//SpXňv
	);

	//A[JCut@Cw
	Param+=_T("\"");
	Param+=ArcFileName;
	Param+=_T("\" ");

	//o͐tH_
	Param+=_T("\"");
	Param+=OutputDir;
	Param+=_T("\" ");

	//X|Xt@Cw
	Param+=_T("\"@");
	Param+=ResponceFileName;
	Param+=_T("\"");

	TRACE("ArchiveHandlerĂяo\nCommandline Parameter:%s\n",Param);
	CString Log;
	int Ret=ArchiveHandler(NULL,Param,Log.GetBuffer(LOG_BUFFER_SIZE),LOG_BUFFER_SIZE-1);
	Log.ReleaseBuffer();
	//gX|Xt@C͏
	DeleteFile(ResponceFileName);

	if(Ret){
		CLogDialog LogDlg;
		LogDlg.SetData(Log);
		LogDlg.DoModal();
	}
	return 0==Ret;
}

bool CArchiverYZ1::TestArchive(LPCSTR ArcFileName)
{
	TRACE("TestArchive() called.\n");
/*	ASSERT(IsOK());
	if(!IsOK()){
		return false;
	}*/

	//eXg͎ĂȂ
	CString Msg;
	Msg.Format(IDS_TESTARCHIVE_UNAVAILABLE,ArcFileName,GetName());

	ErrorMessage(Msg);
	return false;
}
