#include "common.h"
#include "arc_interface.h"
#include "../util.h"

CArchiverDLL::CArchiverDLL():
//	Separator(_T('/')),
	m_hInspectArchive(NULL),
	m_bInspectFirstTime(false),
	InspectMode(0),
	RequiredVersion(0),
	RequiredSubVersion(0),
	LoadLevel(LOAD_DLL_STANDARD),
	FindParam(_T("*")),
	hInstDLL(NULL),
	ArchiveHandler(NULL),
	ArchiverGetVersion(NULL),
	ArchiverGetSubVersion(NULL),
	ArchiverCheckArchive(NULL),
	ArchiverGetFileCount(NULL),
	ArchiverQueryFunctionList(NULL),
	ArchiverGetFileName(NULL),
	ArchiverOpenArchive(NULL),
	ArchiverCloseArchive(NULL),
	ArchiverFindFirst(NULL),
	ArchiverFindNext(NULL),
	ArchiverGetAttribute(NULL),
	ArchiverGetOriginalSizeEx(NULL),
	ArchiverGetCompressedSizeEx(NULL),
	ArchiverGetWriteTime(NULL),
	ArchiverGetWriteTimeEx(NULL),
	ArchiverGetMethod(NULL)
{
}

WORD CArchiverDLL::GetVersion()
{
	if(!ArchiverGetVersion){
		ASSERT(ArchiverGetVersion);
		return 0;
	}
	return ArchiverGetVersion();
}

WORD CArchiverDLL::GetSubVersion()
{
	if(!ArchiverGetSubVersion){
//		ASSERT(ArchiverGetSubVersion);
		return 0;
	}
	return ArchiverGetSubVersion();
}

bool CArchiverDLL::GetVersionString(CString &String)
{
	if(!hInstDLL||!ArchiverGetVersion){
		String.LoadString(IDS_MESSAGE_DLL_NOT_AVAILABLE);
		return false;
	}
	TCHAR Buffer[32]={0};
//	FILL_ZERO(Buffer);
	if(!ArchiverGetSubVersion){
		sprintf(Buffer,_T("Ver.%.2f"),ArchiverGetVersion()/100.0f);
	}
	else{
		sprintf(Buffer,_T("Ver.%.2f.%.2f"),ArchiverGetVersion()/100.0f,ArchiverGetSubVersion()/100.0f);
	}
	String=Buffer;
	return true;
}

BOOL CArchiverDLL::CheckArchive(LPCSTR _szFileName)
{
	if(!ArchiverCheckArchive){
		ASSERT(ArchiverCheckArchive);
		return false;
	}
	return ArchiverCheckArchive(_szFileName,1);	//CHECKARCHIVE_BASIC
}

int CArchiverDLL::GetFileCount(LPCTSTR _szFileName)
{
	if(!ArchiverGetFileCount){
		return -1;
	}
	return ArchiverGetFileCount(_szFileName);
}

bool CArchiverDLL::_ExamineArchive(LPCTSTR ArcFileName,bool &bInFolder,bool &bSafeArchive,const int MaxRepeat,CString &BaseDir)
{
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName)){
		CString msg;
		msg.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	bInFolder=true;
	bool bSureDir=false;	//BaseDirɓĂ镶񂪊mɃtH_łȂtrue
	TRACE("========\n");

	while(InspectArchiveNext()){
		CString Buffer;
		InspectArchiveGetFileName(Buffer);
		Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
		TRACE("%s\n",Buffer);

		/*
		Separator('/' or '\')͊i[t@C̐擪ɂ܂܂ĂĂׂł̂ŁA
		i[t@C̐擪ɂSeparatorĂtH_Ɋi[ꂽԂƂ͌ȂȂB
		SeparatorMaxRepeat葽ƕsƂ
		AMaxRepeat-1̂Ƃ̓G[Ƃ͂Ȃ
		*/
		const int Length=Buffer.GetLength();
		for(int StartIndex=0;StartIndex<Length;StartIndex++){
			//擪'/'Ƃ΂Ă
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)(LPCTSTR)Buffer,StartIndex)){
				if(_T('/')!=Buffer[StartIndex])break;
			}
			else{	//SpȂ'/'ł͂Ȃ
				break;
			}
			if(-1!=MaxRepeat){
				if(StartIndex>=MaxRepeat){	//'/'MaxRepeatȏ㑱ꍇ
					//댯ȃt@Cƕ̂ŊčI
					InspectArchiveEnd();
					bSafeArchive=false;
					bInFolder=false;
					return true;
				}
			}
		}
		if((-1!=Buffer.Find(_T("../"),StartIndex))||	//΃pXw肪΁A͈Sȃt@Cł͂Ȃ
			(-1!=Buffer.Find(_T(':'),StartIndex))){	//hCu΁A͈Sȃt@Cł͂Ȃ
			//댯ȃt@Cƕ̂ŊčI
			InspectArchiveEnd();
			bSafeArchive=false;
			bInFolder=false;
			return true;
		}

		//͓dfBNg
		//łɓdfBNg肪tĂꍇ͈Ŝ݂ɓO

		int FoundIndex=0;
		while(bInFolder){
			FoundIndex=Buffer.Find(_T('/'),StartIndex);
			if(-1==FoundIndex){	//'/'i[t@C̐擪ȊOɊ܂܂Ȃꍇ
				if(!BaseDir.IsEmpty()&&BaseDir==Buffer){
					bSureDir=true;	//BaseDirtH_łƊmFꂽ
					break;
				}
				else if(BaseDir.IsEmpty()){
					//tH_̌'/'tȂA[JCo
					//̂ŏɏoĂƂ́AtH_Ɖ肷
					BaseDir=Buffer;
					bSureDir=false;
					break;
				}
			//	else{	͌Â@
			//		bInFolder=false;
			//		break;
			//	}
			}
			CString Dir=Buffer.Mid(StartIndex,FoundIndex-StartIndex);	//SeparatoȓO܂ł̕(fBNgɑ)𔲂oĂ
			//܂łׂ̒DirEmptył͂ȂƂۏ؂Ă
			//܂A댯ł͂ȂƂĂ
			TRACE("Base=%s,Dir=%s\n",BaseDir,Dir);

			if(_T('.')==Dir){	//./΃fBNgwƂĂ͖
				StartIndex=FoundIndex+1;
				continue;
			}
			if(BaseDir.IsEmpty()){
				BaseDir=Dir;
				bSureDir=true;
			}
			else if(BaseDir!=Dir){
				bInFolder=false;
			}
			else bSureDir=true;	//BaseDirfBNgƊmFꂽ
			break;
		}
	}
	TRACE("========\n");

	InspectArchiveEnd();
	bSafeArchive=true;

	//tH_ɓĂ悤ł͂邪AfBNgƉ肳ꂽ̏ꍇ
	if(bInFolder&&!bSureDir)bInFolder=false;
	return true;
}

bool CArchiverDLL::_ExamineArchiveFast(LPCTSTR ArcFileName,bool &bInFolder,CString &BaseDir)
{
	//sȃpXt@C͑SDLLΏĂĂƍl̂ŁASẴA[JCu͈SłƂ

	TRACE("---_ExamineArchiveFast() called.\n");
	if(!IsOK()){
		return false;
	}

	if(!InspectArchiveBegin(ArcFileName)){
		CString msg;
		msg.Format(IDS_ERROR_OPEN_ARCHIVE,ArcFileName);
		ErrorMessage(msg);
		return false;
	}

	bool bSureDir=false;	//BaseDirɓĂ镶񂪊mɃtH_łȂtrue
	bInFolder=true;
	TRACE("========\n");
	while(InspectArchiveNext()){
		CString Buffer;
		InspectArchiveGetFileName(Buffer);
		Buffer.Replace(_T('\\'),_T('/'));		//pX؂蕶̒u
		TRACE("%s\n",Buffer);

		/*
		Separator͊i[t@C̐擪ɂ܂܂ĂĂׂł̂ŁA
		i[t@C̐擪ɂ/ĂtH_Ɋi[ꂽԂƂ͌ȂȂB
		*/
		const int Length=Buffer.GetLength();
		for(int StartIndex=0;StartIndex<Length;StartIndex++){
			//擪SeparatorƂ΂Ă
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)(LPCTSTR)Buffer,StartIndex)){
				if(/*Separator*/_T('/')!=Buffer[StartIndex])break;
			}
			else{	//SpȂSeparatorł͂Ȃ
				break;
			}
		}

		int FoundIndex=0;
		while(bInFolder){
			FoundIndex=Buffer.Find(_T('/'),StartIndex);
			if(-1==FoundIndex){	//'/'i[t@C̐擪ȊOɊ܂܂Ȃꍇ
				if(!BaseDir.IsEmpty()&&BaseDir==Buffer){
					bSureDir=true;	//BaseDirtH_łƊmFꂽ
					break;
				}
				else if(BaseDir.IsEmpty()){
					//tH_̌'/'tȂA[JCo
					//̂ŏɏoĂƂ́AtH_Ɖ肷
					BaseDir=Buffer;
					bSureDir=false;
					break;
				}
			//	else{	͌Â@
			//		bInFolder=false;
			//		break;
			//	}
			}
			CString Dir=Buffer.Mid(StartIndex,FoundIndex-StartIndex);	//SeparatoȓO܂ł̕(fBNgɑ)𔲂oĂ
			//܂łׂ̒DirEmptył͂ȂƂۏ؂Ă
			//܂A댯ł͂ȂƂĂ
			TRACE("Base=%s,Dir=%s\n",BaseDir,Dir);

			if(_T('.')==Dir){	//./΃fBNgwƂĂ͖
				StartIndex=FoundIndex+1;
				continue;
			}
			if(BaseDir.IsEmpty()){
				BaseDir=Dir;
				bSureDir=true;
			}
			else if(BaseDir!=Dir){
				bInFolder=false;
			}
			else bSureDir=true;	//BaseDirfBNgƊmFꂽ
			break;
		}
	}
	TRACE("========\n");

	InspectArchiveEnd();
	//tH_ɓĂ悤ł͂邪AfBNgƉ肳ꂽ̏ꍇ
	if(bInFolder&&!bSureDir)bInFolder=false;
	return true;
}

void CArchiverDLL::FreeDLL()
{
	ASSERT(NULL==m_hInspectArchive);
	ArchiveHandler				=NULL;
	ArchiverGetVersion			=NULL;
	ArchiverGetSubVersion		=NULL;
	ArchiverCheckArchive		=NULL;
	ArchiverGetFileCount		=NULL;
	ArchiverGetFileName			=NULL;
	ArchiverQueryFunctionList	=NULL;
	ArchiverOpenArchive			=NULL;
	ArchiverCloseArchive		=NULL;
	ArchiverFindFirst			=NULL;
	ArchiverFindNext			=NULL;
	ArchiverGetAttribute		=NULL;
	ArchiverGetOriginalSizeEx	=NULL;
	ArchiverGetCompressedSizeEx	=NULL;
	ArchiverGetWriteTime		=NULL;
	ArchiverGetWriteTimeEx		=NULL;
	ArchiverGetMethod			=NULL;

	if(hInstDLL){
		FreeLibrary(hInstDLL);
		hInstDLL=NULL;
	}
}

LOAD_RESULT CArchiverDLL::LoadDLL(CConfigManager&,bool bSilent)
{
	FreeDLL();

	if(NULL==(hInstDLL=LoadLibrary(DllName)))
	{
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_LOAD,DllName);
			ErrorMessage(msg);
		}
		return LOAD_RESULT_NOT_FOUND;
	}

	ArchiveHandler=(COMMON_ARCHIVER_HANDLER)GetProcAddress(hInstDLL,Prefix);
	if(NULL==ArchiveHandler){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,Prefix);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	CString FunctionName=Prefix;
	FunctionName+=_T("GetVersion");
	ArchiverGetVersion=(COMMON_ARCHIVER_GETVERSION)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverGetVersion){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//Tuo[W̎擾łDLL͌Ă
	FunctionName=Prefix;
	FunctionName+=_T("GetSubVersion");
	ArchiverGetSubVersion=(COMMON_ARCHIVER_GETVERSION)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverGetSubVersion){
	//[hɎsĂG[Ƃ͂Ȃ
		TRACE("Failed to Load Function %s\n",FunctionName);
	}
	//-------------------------
	// DLLo[W̃`FbN
	//-------------------------
	if((ArchiverGetVersion()<RequiredVersion)){
		//W[o[WႢ
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_TOO_OLD,DllName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_TOO_OLD;
	}else if((ArchiverGetVersion()==RequiredVersion)&&(NULL!=ArchiverGetSubVersion)&&(ArchiverGetSubVersion()<RequiredSubVersion)){
		//}Ci[o[WႢ
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_TOO_OLD,DllName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_TOO_OLD;
	}

	FunctionName=Prefix;
	FunctionName+=_T("CheckArchive");
	ArchiverCheckArchive=(COMMON_ARCHIVER_CHECKARCHIVE)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverCheckArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//XacRett.dllAish32.dllT|[gĂȂ
	FunctionName=Prefix;
	FunctionName+=_T("GetFileCount");
	ArchiverGetFileCount=(COMMON_ARCHIVER_GETFILECOUNT)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileCount){
	//[hɎsĂG[Ƃ͂Ȃ
		TRACE("Failed to Load Function %s\n",FunctionName);
	}

	if(LOAD_DLL_MINIMUM==LoadLevel){
		TRACE("Minimum Function Set Load\n");
		return LOAD_RESULT_OK;
	}

	//------------
	// ǉ֐Q
	//------------
	FunctionName=Prefix;
	FunctionName+=_T("QueryFunctionList");
	ArchiverQueryFunctionList=(COMMON_ARCHIVER_QUERYFUNCTIONLIST)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverQueryFunctionList){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	FunctionName=Prefix;
	FunctionName+=_T("OpenArchive");
	if(!ArchiverQueryFunctionList(23)){//23:???OpenArchive
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverOpenArchive=(COMMON_ARCHIVER_OPENARCHIVE)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverOpenArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	FunctionName=Prefix;
	FunctionName+=_T("CloseArchive");
	if(!ArchiverQueryFunctionList(24)){//24:???CloseArchive
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverCloseArchive=(COMMON_ARCHIVER_CLOSEARCHIVE)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverCloseArchive){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindFirst
	FunctionName=Prefix;
	FunctionName+=_T("FindFirst");
	if(!ArchiverQueryFunctionList(25)){//25:???FindFirst
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverFindFirst=(COMMON_ARCHIVER_FINDFIRST)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverFindFirst){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//FindNext
	FunctionName=Prefix;
	FunctionName+=_T("FindNext");
	if(!ArchiverQueryFunctionList(26)){//26:???FindNext
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverFindNext=(COMMON_ARCHIVER_FINDNEXT)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverFindNext){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	if(LOAD_DLL_SIMPLE_INSPECTION==LoadLevel){
		TRACE("Simple Inspection Set Load\n");
		return LOAD_RESULT_OK;
	}

	//t@C擾
	FunctionName=Prefix;
	FunctionName+=_T("GetFileName");
	if(!ArchiverQueryFunctionList(57)){//57:???GetFileName
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_UNAVAILABLE_API,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}
	ArchiverGetFileName=(COMMON_ARCHIVER_GETFILENAME)GetProcAddress(hInstDLL,FunctionName);
	if(NULL==ArchiverGetFileName){
		if(!bSilent){
			CString msg;
			msg.Format(IDS_ERROR_DLL_FUNCTION_GET,DllName,FunctionName);
			ErrorMessage(msg);
		}
		FreeDLL();
		return LOAD_RESULT_INVALID;
	}

	//t@C擾
	FunctionName=Prefix;
	FunctionName+=_T("GetAttribute");
	//CAB32.DLLłCabGetAttribute()CabQueryFunctionList()ŗpsƕ񍐂邪
	//ۂ͗p\ł邽߁AΏǗÖ@Iɂ𖳌ɂB
/*	if(!ArchiverQueryFunctionList(64)){//64:???GetAttribute
		TRACE("Function %s is not Available\n",FunctionName);
	}
	else{*/
		ArchiverGetAttribute=(COMMON_ARCHIVER_GETATTRIBUTE)GetProcAddress(hInstDLL,FunctionName);
		if(NULL==ArchiverGetAttribute){
			TRACE("Failed to Load Function %s\n",FunctionName);
		}
//	}

	//t@CTCY擾(kO)
	FunctionName=Prefix;
	FunctionName+=_T("GetOriginalSizeEx");
	if(!ArchiverQueryFunctionList(85)){//85:???GetOriginalSizeEx
		TRACE("Function %s is not Available\n",FunctionName);
	}
	else{
		ArchiverGetOriginalSizeEx=(COMMON_ARCHIVER_GETORIGINALSIZEEX)GetProcAddress(hInstDLL,FunctionName);
		if(NULL==ArchiverGetOriginalSizeEx){
			TRACE("Failed to Load Function %s\n",FunctionName);
		}
	}

	//t@CTCY擾(k)
	FunctionName=Prefix;
	FunctionName+=_T("GetCompressedSizeEx");
	if(!ArchiverQueryFunctionList(86)){//86:???GetCompressedSizeEx
		TRACE("Function %s is not Available\n",FunctionName);
	}
	else{
		ArchiverGetCompressedSizeEx=(COMMON_ARCHIVER_GETORIGINALSIZEEX)GetProcAddress(hInstDLL,FunctionName);
		if(NULL==ArchiverGetCompressedSizeEx){
			TRACE("Failed to Load Function %s\n",FunctionName);
		}
	}

	//t@C擾(g)
	FunctionName=Prefix;
	FunctionName+=_T("GetWriteTimeEx");
	if(!ArchiverQueryFunctionList(70)){//70:???GetWriteTimeEx
		TRACE("Function %s is not Available\n",FunctionName);
	}
	else{
		ArchiverGetWriteTimeEx=(COMMON_ARCHIVER_GETWRITETIMEEX)GetProcAddress(hInstDLL,FunctionName);
		if(NULL==ArchiverGetWriteTimeEx){
			TRACE("Failed to Load Function %s\n",FunctionName);
		}
	}
	//t@C擾(ʏ;głgȂƂ̂)
	if(NULL==ArchiverGetWriteTimeEx){
		FunctionName=Prefix;
		FunctionName+=_T("GetWriteTime");
		if(!ArchiverQueryFunctionList(67)){//67:???GetWriteTime
			TRACE("Function %s is not Available\n",FunctionName);
		}
		else{
			ArchiverGetWriteTime=(COMMON_ARCHIVER_GETWRITETIME)GetProcAddress(hInstDLL,FunctionName);
			if(NULL==ArchiverGetWriteTime){
				TRACE("Failed to Load Function %s\n",FunctionName);
			}
		}
	}

	//t@Ck\bh擾
	FunctionName=Prefix;
	FunctionName+=_T("GetMethod");
	if(!ArchiverQueryFunctionList(66)){//66:???GetMethod
		TRACE("Function %s is not Available\n",FunctionName);
	}
	else{
		ArchiverGetMethod=(COMMON_ARCHIVER_GETMETHOD)GetProcAddress(hInstDLL,FunctionName);
		if(NULL==ArchiverGetMethod){
			TRACE("Failed to Load Function %s\n",FunctionName);
		}
	}


	if(LOAD_DLL_STANDARD==LoadLevel){
		TRACE("Standard Function Set Load\n");
		return LOAD_RESULT_OK;
	}

	ASSERT(!"Unknown Load Set!!!");
	return LOAD_RESULT_INVALID;
}

bool CArchiverDLL::InspectArchiveBegin(LPCTSTR ArcFileName)
{
	TRACE("CArchiverDLL::InspectArchiveBegin()\n");
	ASSERT(ArchiverOpenArchive);
	if(!ArchiverOpenArchive){
		return false;
	}
	if(m_hInspectArchive){
		ASSERT(!"Close the Archive First!!!\n");
		return false;
	}
	m_hInspectArchive=ArchiverOpenArchive(NULL,ArcFileName,InspectMode);
	if(!m_hInspectArchive){
		TRACE("Failed to Open Archive\n");
		return false;
	}
	m_bInspectFirstTime=true;

	FILL_ZERO(m_IndividualInfo);
	return true;
}

bool CArchiverDLL::InspectArchiveEnd()
{
	ASSERT(ArchiverCloseArchive);
	if(!ArchiverCloseArchive){
		return false;
	}
	if(!m_hInspectArchive){
		ASSERT(!"The Archive is Already Closed!!!\n");
		return false;
	}
	ArchiverCloseArchive(m_hInspectArchive);
	m_hInspectArchive=NULL;
	return true;
}

bool CArchiverDLL::InspectArchiveGetFileName(CString &FileName)
{
	if(ArchiverGetFileName){
		if(!m_hInspectArchive){
			ASSERT(!"Open an Archive First!!!\n");
			return false;
		}
		FileName.Empty();
		ArchiverGetFileName(m_hInspectArchive,FileName.GetBuffer(FNAME_MAX32*2+1),FNAME_MAX32*2);
		FileName.ReleaseBuffer();
		return true;
	}
	else{
		ASSERT(LOAD_DLL_STANDARD!=LoadLevel);
		if(!m_hInspectArchive){
			ASSERT(!"Open an Archive First!!!\n");
			return false;
		}
		FileName=m_IndividualInfo.szFileName;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveNext()
{
	ASSERT(ArchiverFindFirst);
	ASSERT(ArchiverFindNext);
	if(!ArchiverFindFirst||!ArchiverFindNext){
		return false;
	}
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	FILL_ZERO(m_IndividualInfo);
	bool bRet;
	if(m_bInspectFirstTime){
		m_bInspectFirstTime=false;
		bRet=(0==ArchiverFindFirst(m_hInspectArchive,FindParam,&m_IndividualInfo));
	}
	else{
		bRet=(0==ArchiverFindNext(m_hInspectArchive,&m_IndividualInfo));
	}

	return bRet;
}

int CArchiverDLL::InspectArchiveGetAttribute()
{
//	ASSERT(ArchiverGetAttribute);
	//ΉĂȂDLL(CAB32.dllȂ)łNULLɂȂĂ
	if(!ArchiverGetAttribute){
		return -1;
	}
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}

	return ArchiverGetAttribute(m_hInspectArchive);
}

bool CArchiverDLL::InspectArchiveGetOriginalFileSize(LARGE_INTEGER &FileSize)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetOriginalSizeEx){
		return (FALSE!=ArchiverGetOriginalSizeEx(m_hInspectArchive,&FileSize));
	}
	else{
		//APIɂt@CTCY擾Ɏŝō\̂̃f[^𗘗p
		if(-1==m_IndividualInfo.dwOriginalSize)return false;
		FileSize.HighPart=0;
		FileSize.LowPart=m_IndividualInfo.dwOriginalSize;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveGetCompressedFileSize(LARGE_INTEGER &FileSize)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	if(ArchiverGetCompressedSizeEx){
		return (FALSE!=ArchiverGetCompressedSizeEx(m_hInspectArchive,&FileSize));
	}
	else{
		//APIɂt@CTCY擾Ɏŝō\̂̃f[^𗘗p
		if(-1==m_IndividualInfo.dwCompressedSize)return false;
		FileSize.HighPart=0;
		FileSize.LowPart=m_IndividualInfo.dwCompressedSize;
		return true;
	}
}

bool CArchiverDLL::InspectArchiveGetWriteTime(FILETIME &FileTime)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}
	//gŊ֐Ŏ擾
	if(ArchiverGetWriteTimeEx){
		if(!ArchiverGetWriteTimeEx(m_hInspectArchive,&FileTime))return false;
		return true;
	}
	//ʏŊ֐Ŏ擾
	else if(ArchiverGetWriteTime){
		DWORD UnixTime=ArchiverGetWriteTime(m_hInspectArchive);
		if(-1==UnixTime){
			return false;
		}
		//time_tFileTime֕ϊ
		LONGLONG ll = Int32x32To64(UnixTime, 10000000) + 116444736000000000;
		FileTime.dwLowDateTime = (DWORD) ll;
		FileTime.dwHighDateTime = (DWORD)(ll >>32);
		return true;
	}
	else{
		//INDIVIDUALINFO玞擾
		FILETIME TempTime;
		if(!DosDateTimeToFileTime(m_IndividualInfo.wDate,m_IndividualInfo.wTime,&TempTime))return false;
		if(!LocalFileTimeToFileTime(&TempTime,&FileTime))return false;
		return true;
	}
}

//ɓt@CCRC擾
DWORD CArchiverDLL::InspectArchiveGetCRC()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}
	return m_IndividualInfo.dwCRC;
}

//ɓt@Ck擾
WORD CArchiverDLL::InspectArchiveGetRatio()
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return -1;
	}

	return m_IndividualInfo.wRatio;
}

//ɓt@Ci[[h擾
bool CArchiverDLL::InspectArchiveGetMethodString(CString &strMethod)
{
	if(!m_hInspectArchive){
		ASSERT(!"Open an Archive First!!!\n");
		return false;
	}

	TCHAR szBuffer[32]={0};

	if(ArchiverGetMethod){
		if(0!=ArchiverGetMethod(m_hInspectArchive,szBuffer,31)){
			//\̂擾
			strncpy(szBuffer,m_IndividualInfo.szMode,8);
		}
	}
	else{
		//\̂擾
		strncpy(szBuffer,m_IndividualInfo.szMode,8);
	}

	//i[
	strMethod=szBuffer;
	return true;
}
