#include "common.h"
#include "Association.h"
#include "util.h"
#include <vector>

#ifndef __UNINSTALLER__

//֘At쐬
bool AssocSetAssociation(const ASSOCINFO& AssocInfo)
{
	TRACE("AssocSetAsscociation()\n---");
	TRACE("Ext=%s\n",AssocInfo.Ext);
//	TRACE("FileType=%s\n",AssocInfo.FileType);
	TRACE("IconFile=%s\nIndex=%d\n",AssocInfo.IconFile,AssocInfo.IconIndex);
	TRACE("ShellOpenCommand=%s\n---\n",AssocInfo.ShellOpenCommand);

	HKEY hKey;
	LONG Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, AssocInfo.Ext, NULL,KEY_ALL_ACCESS,&hKey);
	DWORD dwDust;
	if(ERROR_SUCCESS!=Ret){
		//L[I[voȂꍇ
		Ret = ::RegCreateKeyEx(HKEY_CLASSES_ROOT, AssocInfo.Ext, NULL, NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL, &hKey,&dwDust);
		if(ERROR_SUCCESS!=Ret){
			//L[쐬oȂꍇ
			TRACE("AssocSetAssociation():Failed to Create Key %s\n",AssocInfo.Ext);
			return false;
		}
	}
	//gqɑΉFileTypeݒ
	CString FileType=ASSOC_PREFIX;
	{
		CString ExtBuffer=AssocInfo.Ext;
		ExtBuffer.Delete(0);
		ExtBuffer.MakeUpper();
		FileType+=ExtBuffer;
	}

	DWORD dwWrite=(FileType.GetLength()+1)*sizeof(TCHAR);
	TCHAR *Buffer=new TCHAR[FileType.GetLength()+1];
	_tcsncpy(Buffer,FileType,FileType.GetLength()+1);
	Ret = ::RegSetValueEx(hKey, NULL, NULL, REG_SZ, (BYTE*)Buffer,dwWrite);
	delete [] Buffer;
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocSetAssociation():Failed to Set FileType\n");
		::RegCloseKey(hKey);
		return false;
	}

	//OrgFileType
	if(AssocInfo.OrgFileType.IsEmpty()){
		::RegDeleteValue(hKey, _T("LhaForgeOrgFileType"));
	}
	else{
		dwWrite=(AssocInfo.OrgFileType.GetLength()+1)*sizeof(TCHAR);
		Buffer=new TCHAR[AssocInfo.OrgFileType.GetLength()+1];
		_tcsncpy(Buffer,AssocInfo.OrgFileType,AssocInfo.OrgFileType.GetLength()+1);
		Ret = ::RegSetValueEx(hKey, _T("LhaForgeOrgFileType"), NULL, REG_SZ, (BYTE*)Buffer,dwWrite);
		delete [] Buffer;
		if(ERROR_SUCCESS!=Ret){
			TRACE("AssocSetAssociation():Failed to Set OrgFileType\n");
			::RegCloseKey(hKey);
			return false;
		}
	}
	::RegCloseKey(hKey);

	//----------------------------------
	// FileType̍쐬ƃACRݒ
	//----------------------------------
	CString KeyNameBuffer=FileType;
	KeyNameBuffer+=_T("\\DefaultIcon");
	Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL, KEY_ALL_ACCESS,&hKey);
	if(ERROR_SUCCESS!=Ret){
		Ret = ::RegCreateKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL, NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL, &hKey,&dwDust);
		if(ERROR_SUCCESS!=Ret){
			TRACE("AssocSetAssociation():Failed to Create %s\n",KeyNameBuffer);
			return false;
		}
	}

	CString IconFile;
	IconFile.Format(_T("%s,%d"),AssocInfo.IconFile,AssocInfo.IconIndex);
	dwWrite=(IconFile.GetLength()+1)*sizeof(TCHAR);
	Buffer=new TCHAR[IconFile.GetLength()+1];
	_tcsncpy(Buffer,IconFile,IconFile.GetLength()+1);
	Ret = ::RegSetValueEx(hKey, NULL, NULL, REG_SZ, (BYTE*)Buffer,dwWrite);
	delete [] Buffer;
	::RegCloseKey(hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocSetAssociation():Failed to Set IconInfo\n");
		return false;
	}

	//----------------------------
	// Shell\OpeñR}hݒ
	//----------------------------
	KeyNameBuffer=FileType;
	KeyNameBuffer+=_T("\\shell\\open\\command");
	Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL,KEY_ALL_ACCESS,&hKey);
	if(ERROR_SUCCESS!=Ret){
		Ret = ::RegCreateKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL, NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL, &hKey,&dwDust);
		if(ERROR_SUCCESS!=Ret){
			TRACE("AssocSetAssociation():Failed to Create %s\n",KeyNameBuffer);
			return false;
		}
	}

	dwWrite=(AssocInfo.ShellOpenCommand.GetLength()+1)*sizeof(TCHAR);
	Buffer=new TCHAR[AssocInfo.ShellOpenCommand.GetLength()+1];
	_tcsncpy(Buffer,AssocInfo.ShellOpenCommand,AssocInfo.ShellOpenCommand.GetLength()+1);
	Ret = ::RegSetValueEx(hKey, NULL, NULL, REG_SZ, (BYTE*)Buffer,dwWrite);
	delete [] Buffer;
	::RegCloseKey(hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocSetAssociation():Failed to Set ShellOpenCommand\n");
		return false;
	}

	return true;
}
#endif //__UNINSTALLER__

//֘At폜
bool AssocDeleteAssociation(LPCTSTR Ext)
{
	TRACE("AssocDeleteAsscociation()---\n");
	TRACE("Ext=%s\n",Ext);

	CString FileType=ASSOC_PREFIX;
	{
		CString ExtBuffer=Ext;
		ExtBuffer.Delete(0);
		ExtBuffer.MakeUpper();
		FileType+=ExtBuffer;
	}
	AssocRecursiveDeleteKey(HKEY_CLASSES_ROOT,FileType);
	TRACE("%s Deleted.\n",FileType);

	//.???JĒ
	HKEY hKey;
	LONG Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, Ext, NULL, KEY_ALL_ACCESS, &hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocDeleteAssociation():Failed to Open %s\n",Ext);
		return false;
	}
	TRACE("AssocDeleteAssociation():Succeeded to Open %s\n",Ext);

	//LhaForgeOrgFileTypeǂݏo΁AĂFileType܂݂Ȃ畜
	//FileType݂AƂȂĂΖAǂ̏ꍇɂLhaForgeOrgFileType͏B
	std::vector<BYTE> Buffer;
	DWORD dwRead=0;
	::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL,&dwRead);
	TRACE("AssocDeleteAssociation():Query dwRead done\n");
	Buffer.assign(dwRead+1,0);
	Ret = ::RegQueryValueEx(hKey, NULL, NULL, NULL, &Buffer.at(0),&dwRead);
	TRACE("AssocDeleteAssociation():Query Value done\n");
	CString TextBuffer=(TCHAR*)&Buffer.at(0);
	if(0!=TextBuffer.Left(_tcslen(ASSOC_PREFIX)).CompareNoCase(ASSOC_PREFIX)){
		//֘At̕łȂ΁ALhaForgeOrgFileTypeĐÂɋ
		::RegDeleteValue(hKey,_T("LhaForgeOrgFileType"));
		::RegCloseKey(hKey);
		TRACE("LhaForgeOrgFileType Deleted.\n");
		return true;
	}
	::RegQueryValueEx(hKey, _T("LhaForgeOrgFileType"), NULL, NULL, NULL,&dwRead);
	TRACE("AssocDeleteAssociation():Query LhaForgeOrgFileType dwRead done\n");
	Buffer.assign(dwRead+1,0);
	Ret = ::RegQueryValueEx(hKey, _T("LhaForgeOrgFileType"), NULL, NULL, &Buffer.at(0),&dwRead);
	TRACE("AssocDeleteAssociation():Query LhaForgeOrgFileType done\n");
	TextBuffer=(TCHAR*)&Buffer.at(0);
	if(ERROR_SUCCESS!=Ret||TextBuffer.IsEmpty()){
		//݂ȂƌȂ
		TRACE("AssocDeleteAssociation():Failed to Get OrgFileType\n");
	}
	else{
		if(AssocRegExistKey(HKEY_CLASSES_ROOT,TextBuffer)){
			TRACE("AssocDeleteAssociation():%s exists\n",TextBuffer);
			Ret=::RegSetValueEx(hKey, NULL, NULL, REG_SZ, &Buffer.at(0),dwRead);
			if(ERROR_SUCCESS!=Ret){
				TRACE("AssocDeleteAssociation():Failed to Set Old FileType\n",TextBuffer);
			}
		}
		::RegDeleteValue(hKey,_T("LhaForgeOrgFileType"));
		TRACE("LhaForgeOrgFileType Deleted.\n");
		::RegCloseKey(hKey);
		return true;
	}
	::RegDeleteValue(hKey,NULL);

	DWORD dwKeyCount=0;
	Ret=::RegQueryInfoKey(hKey,NULL,NULL,NULL,&dwKeyCount,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
	if(ERROR_SUCCESS==Ret&&0==dwKeyCount){
		AssocRecursiveDeleteKey(HKEY_CLASSES_ROOT,Ext);
		TRACE("HKEY_CLASSES_ROOT\\%s Deleted.\n",Ext);
	}
	::RegCloseKey(hKey);

	return false;
}

#ifndef __UNINSTALLER__
//֘At擾
//Ext̏ɁAFileTypeƂIconɂĒׂ
bool AssocGetAssociation(ASSOCINFO &AssocInfo)
{
	if(AssocInfo.Ext.IsEmpty()){
		TRACE("AssocGetAssociation():Ext is Empty\n");
		return false;
	}
	HKEY hKey;
	LONG Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, AssocInfo.Ext, NULL, KEY_READ, &hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocGetAssociation():Failed to Open '%s'\n",AssocInfo.Ext);
		return false;
	}
	//gqœꂷ
	AssocInfo.Ext.MakeLower();
	//gqɑΉFileType擾
//	DWORD ValueType;
	std::vector<BYTE> Buffer;
	DWORD dwRead=0;
	::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL,&dwRead);
	Buffer.assign(dwRead+1,0);
	Ret = ::RegQueryValueEx(hKey, NULL, NULL, NULL, &Buffer.at(0),&dwRead);
	if(ERROR_SUCCESS!=Ret){
		::RegCloseKey(hKey);
		TRACE("AssocGetAssociation():Failed to Get FileType\n");
		return false;
	}
	CString FileType=(TCHAR*)&Buffer.at(0);

	//IWiFileType
	/*
	1.FileTypeƂAOrgFIleType=.???\OrgFileType(NULLɂȂ肤)
	2.FileTypeLhaForgeArchive_*ȊO̎AOrgFileType=.???\(Default)
	3.FileTypeLhaForgeArchive_*̂ƂAOrgFileType=.???\OrgFileType
	*/
	//1.3.̂Ƃ
	if(0==FileType.Left(_tcslen(ASSOC_PREFIX)).CompareNoCase(ASSOC_PREFIX)){
		AssocInfo.bOrgStatus=true;
	}
	else{
		AssocInfo.bOrgStatus=false;
	}
	if(FileType.IsEmpty()||(0==FileType.Left(_tcslen(ASSOC_PREFIX)).CompareNoCase(ASSOC_PREFIX))){
		::RegQueryValueEx(hKey, _T("LhaForgeOrgFileType"), NULL, NULL, NULL,&dwRead);
		Buffer.assign(dwRead+1,0);
		Ret = ::RegQueryValueEx(hKey, _T("LhaForgeOrgFileType"), NULL, NULL, &Buffer.at(0),&dwRead);
		::RegCloseKey(hKey);
		if(ERROR_SUCCESS!=Ret){
			AssocInfo.OrgFileType.Empty();
			TRACE("AssocGetAssociation():Failed to Get OrgFileType\n");
		}
		else{
			AssocInfo.OrgFileType=(TCHAR*)&Buffer.at(0);
		}
	}
	else{	//2.̂Ƃ
		AssocInfo.OrgFileType=FileType;
		::RegCloseKey(hKey);
	}

	//------------------------------
	// FileTypeACR擾
	//------------------------------
	CString KeyNameBuffer=FileType;
	KeyNameBuffer+=_T("\\DefaultIcon");
	Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL, KEY_READ, &hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocGetAssociation('%s'):Failed to Open '%s' for Default Icon\n",AssocInfo.Ext,KeyNameBuffer);
		return false;
	}

	dwRead=0;
	::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL,&dwRead);
	Buffer.assign(dwRead+1,0);
	Ret = ::RegQueryValueEx(hKey, NULL, NULL, NULL, &Buffer.at(0),&dwRead);
	::RegCloseKey(hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocGetAssociation():Failed to Get IconInfo\n");
		return false;
	}
	//ACR̎擾
	AssocInfo.IconFile=(TCHAR*)&Buffer.at(0);
	AssocInfo.IconIndex=PathParseIconLocation(AssocInfo.IconFile.GetBuffer(_MAX_PATH*2));
	AssocInfo.IconFile.ReleaseBuffer();
	TRACE("***%d:::%s\n",AssocInfo.IconIndex,AssocInfo.IconFile);

	AssocInfo.OrgIconFile=AssocInfo.IconFile;
	AssocInfo.OrgIconIndex=AssocInfo.IconIndex;

	//----------------------------
	// Shell\OpeñR}hǂ
	//----------------------------
	if(!AssocInfo.bOrgStatus){
		//֘AtĂȂ
		return true;
	}
	KeyNameBuffer=FileType;
	KeyNameBuffer+=_T("\\shell\\open\\command");
	Ret = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, KeyNameBuffer, NULL, KEY_READ, &hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocGetAssociation():Failed to Open '%s' for Open Command\n",KeyNameBuffer);
		return false;
	}

	dwRead=0;
	::RegQueryValueEx(hKey, NULL, NULL, NULL, NULL,&dwRead);
	Buffer.assign(dwRead+1,0);
	Ret = ::RegQueryValueEx(hKey, NULL, NULL, /*&ValueType*/NULL, &Buffer.at(0),&dwRead);
	::RegCloseKey(hKey);
	if(ERROR_SUCCESS!=Ret){
		TRACE("AssocGetAssociation():Failed to Get ShellOpenCommand\n");
		return false;
	}
	AssocInfo.ShellOpenCommand=(TCHAR*)&Buffer.at(0);

	return true;
}
#endif //__UNINSTALLER__

// ċNIWXg폜
bool AssocRecursiveDeleteKey(HKEY hParentKey,LPCTSTR KeyName)
{
	HKEY		hChildKey;
	LONG		Ret;
	DWORD		dwSize;
	TCHAR		Buffer[256];

	// Open the child.
	Ret = ::RegOpenKeyEx(hParentKey, KeyName, 0, KEY_ALL_ACCESS, &hChildKey);
	if(ERROR_SUCCESS != Ret){
		return false;
	}

	// Enumerate all of the decendents of this child.
	dwSize = 256;
	while(S_OK==::RegEnumKeyEx(hChildKey, 0, Buffer, &dwSize, NULL, NULL, NULL, NULL)){
		// Delete the decendents of this child.
		Ret = AssocRecursiveDeleteKey(hChildKey, Buffer);
		if(!Ret){
			// Cleanup before exiting.
			::RegCloseKey(hChildKey);
			return false;
		}
		dwSize = 256;
	}

	// Close the child.
	::RegCloseKey(hChildKey);

	// Delete this child.
	return ERROR_SUCCESS==RegDeleteKey(hParentKey, KeyName);
}

bool AssocRegExistKey(HKEY hParentKey,LPCTSTR KeyName)
{
	DWORD		dwSize;
	TCHAR		Buffer[256];

	// Enumerate all of the decendents of this child.
	dwSize = 256;
	int i=0;
	while(S_OK==::RegEnumKeyEx(hParentKey, i, Buffer, &dwSize, NULL, NULL, NULL, NULL)){
		TRACE("%d is %s\n",i,Buffer);
		if(0==_tcsncmp(Buffer,KeyName,256)){
			return true;
		}
		dwSize = 256;
		i++;
	}

	return false;
}
