#pragma once
#include "../common.h"
#include "../util.h"
#include "../FileListWindow/dirtree.h"
#include "../FileListWindow/MenuCommand.h"

//----------
// ݒǗ
//----------
//INIt@C
const LPCTSTR INI_FILE_NAME=_T("LhaForge.ini");
const LPCTSTR CALDIX_INI_FILE_NAME=_T("LFCaldix.ini");

//ݒ`
enum CONFIG_TYPE{
	CONFIG_LZH,
	CONFIG_ZIP,
	CONFIG_CAB,
	CONFIG_7Z,
	CONFIG_TAR,
	CONFIG_JACK,
	CONFIG_BH,	//o[WŕۑꂽpX[h폜Kv̂ŎcĂ
	CONFIG_YZ1,	//o[WŕۑꂽpX[h폜Kv̂ŎcĂ
	CONFIG_HKI,
	CONFIG_BGA,
	CONFIG_AISH,
	CONFIG_XACRETT,
	CONFIG_B2E,
	CONFIG_COMMON,
	CONFIG_OPENACTION,
	CONFIG_SHELL_EXT,
	CONFIG_UPDATE,
	CONFIG_FILELISTWINDOW,
	CONFIG_LOAD_ALL,	//ݒt@C̓ǂݍ݂͂̑Õp[^܂
	CONFIG_MAX_NUM
};

enum COMPRESS_TO{
	COMPRESS_TO_DESKTOP,
	COMPRESS_TO_SAME_DIR,
	COMPRESS_TO_SPECIFIC_DIR,
	COMPRESS_TO_ALWAYS_ASK_WHERE,
	COMPRESS_TO_MAX_NUM
};

enum EXTRACT_TO{
	EXTRACT_TO_DESKTOP,
	EXTRACT_TO_SAME_DIR,
	EXTRACT_TO_SPECIFIC_DIR,
	EXTRACT_TO_ALWAYS_ASK_WHERE,
	EXTRACT_TO_MAX_NUM
};

enum LOSTDIR{
	LOSTDIR_ASK_TO_CREATE,
	LOSTDIR_FORCE_CREATE,
	LOSTDIR_ERROR,
	LOSTDIR_MAX_NUM
};

enum LOGVIEW{
	LOGVIEW_ON_ERROR,
	LOGVIEW_ALWAYS,
	LOGVIEW_NEVER,
	LOGVIEW_MAX_NUM
};

/*enum SHELLEXT{
	SHELLEXT_SHELL_COMPRESS,
	SHELLEXT_SHELL_EXTRACT,
	SHELLEXT_DRAG_COMPRESS,
	SHELLEXT_DRAG_EXTRACT,
	SHELLEXT_MAX_NUM
};*/

enum OPENACTION{
	OPENACTION_EXTRACT,
	OPENACTION_LIST,
	OPENACTION_TEST,
	OPENACTION_ASK,
	OPENACTION_MAX_NUM
};

enum CREATE_OUTPUT_DIR{
	CREATE_OUTPUT_DIR_ALWAYS,
	CREATE_OUTPUT_DIR_SINGLE,
	CREATE_OUTPUT_DIR_NEVER,
	CREATE_OUTPUT_DIR_MAX_NUM
};

enum LZH_COMPRESS_TYPE{
	LZH_COMPRESS_LH5,
	LZH_COMPRESS_LH0,
	LZH_COMPRESS_LH1,
	LZH_COMPRESS_LH6,
	LZH_COMPRESS_LH7,
	LZH_COMPRESS_TYPE_MAX_NUM
};

enum ZIP_COMPRESS_TYPE{
	ZIP_COMPRESS_DEFLATE,
	ZIP_COMPRESS_DEFLATE64,
	ZIP_COMPRESS_BZIP2,
	ZIP_COMPRESS_COPY,
	ZIP_COMPRESS_TYPE_MAX_NUM
};

enum ZIP_COMPRESS_LEVEL{
	ZIP_COMPRESS_LEVEL5,
	ZIP_COMPRESS_LEVEL0,
	ZIP_COMPRESS_LEVEL9,
	ZIP_COMPRESS_LEVEL_MAX_NUM
};

enum CAB_COMPRESS_TYPE{
	CAB_COMPRESS_MSZIP,
	CAB_COMPRESS_LZX,
	CAB_COMPRESS_PLAIN,
//	CAB_COMPRESS_QUANTUM,
	CAB_COMPRESS_TYPE_MAX_NUM
};

enum SEVEN_ZIP_COMPRESS_TYPE{
	SEVEN_ZIP_COMPRESS_LZMA,
	SEVEN_ZIP_COMPRESS_PPMD,
	SEVEN_ZIP_COMPRESS_BZIP2,
	SEVEN_ZIP_COMPRESS_DEFLATE,
	SEVEN_ZIP_COMPRESS_COPY,
	SEVEN_ZIP_COMPRESS_TYPE_MAX_NUM
};

enum SEVEN_ZIP_COMPRESS_LEVEL{
	SEVEN_ZIP_COMPRESS_LEVEL5,
	SEVEN_ZIP_COMPRESS_LEVEL0,
	SEVEN_ZIP_COMPRESS_LEVEL1,
	SEVEN_ZIP_COMPRESS_LEVEL7,
	SEVEN_ZIP_COMPRESS_LEVEL9,
	SEVEN_ZIP_COMPRESS_LEVEL_MAX_NUM
};

enum SEVEN_ZIP_LZMA_MODE{
	SEVEN_ZIP_LZMA_MODE1,
	SEVEN_ZIP_LZMA_MODE0,
	SEVEN_ZIP_LZMA_MODE2,
	SEVEN_ZIP_LZMA_MODE_MAX_NUM
};

enum HKI_COMPRESS_LEVEL{
	HKI_COMPRESS_LEVEL_NORMAL,
	HKI_COMPRESS_LEVEL_NONE,
	HKI_COMPRESS_LEVEL_FAST,
	HKI_COMPRESS_LEVEL_HIGH,
	HKI_COMPRESS_LEVEL_MAX_NUM
};

enum HKI_ENCRYPT_ALGORITHM{
	HKI_ENCRYPT_NONE,
	HKI_ENCRYPT_RIJNDAEL128,
	HKI_ENCRYPT_RIJNDAEL256,
	HKI_ENCRYPT_SINGLE_DES,
	HKI_ENCRYPT_TRIPLE_DES,
	HKI_ENCRYPT_BLOWFISH448,
	HKI_ENCRYPT_TWOFISH128,
	HKI_ENCRYPT_TWOFISH256,
	HKI_ENCRYPT_SQUARE,
	HKI_ENCRYPT_ALGORITHM_MAX_NUM
};

enum ISH_ENCODE_TYPE{
	ISH_SHIFT_JIS,
	ISH_JIS7,
	ISH_JIS8,
	ISH_NON_KANA_SHIFT_JIS,
	ISH_ENCODE_TYPE_MAX_NUM
};

const int CAB_LZX_LOWEST=15,					CAB_LZX_HIGHEST=21;
const int ZIP_DEFLATE_MEMORY_SIZE_LOWEST=3,		ZIP_DEFLATE_MEMORY_SIZE_HIGHEST=255;
const int ZIP_DEFLATE_PASS_NUMBER_LOWEST=1,		ZIP_DEFLATE_PASS_NUMBER_HIGHEST=4;
const int SEVEN_ZIP_PPMD_MODEL_SIZE_LOWEST=2,	SEVEN_ZIP_PPMD_MODEL_SIZE_HIGHEST=32;
const int GZIP_COMPRESS_LEVEL_LOWEST=1,			GZIP_COMPRESS_LEVEL_HIGHEST=9;
const int BZIP2_COMPRESS_LEVEL_LOWEST=1,		BZIP2_COMPRESS_LEVEL_HIGHEST=9;
const int GZA_COMPRESS_LEVEL_LOWEST=1,			GZA_COMPRESS_LEVEL_HIGHEST=9;
const int BZA_COMPRESS_LEVEL_LOWEST=1,			BZA_COMPRESS_LEVEL_HIGHEST=9;


//====================================
// ݒǗNX
//====================================

class CConfigManager
{
protected:
	TCHAR IniPath[_MAX_PATH+1];
	TCHAR CaldixIniPath[_MAX_PATH+1];
	bool m_bUserCommon;	//[U[Ԃŋʂ̐ݒgꍇtrue
public:
	CConfigManager();
	virtual ~CConfigManager();
	bool LoadConfig(CONFIG_TYPE);
	bool SaveConfig(CONFIG_TYPE);
	LPCTSTR GetCaldixIniPath(){return CaldixIniPath;}
	bool IsUserCommon(){return m_bUserCommon;}	//[U[ԋʐݒH
	//ʐݒ
	struct{
		struct{
			COMPRESS_TO OutputDirType;
			TCHAR OutputDir[_MAX_PATH+1];
			BOOL OpenDir;
			BOOL SpecifyOutputFilename;
			BOOL LimitCompressFileCount;
			int MaxCompressFileCount;
		}Compress;

		struct{
			EXTRACT_TO OutputDirType;
			TCHAR OutputDir[_MAX_PATH+1];
			BOOL OpenDir;
			CREATE_OUTPUT_DIR CreateDir;
			BOOL ForceOverwrite;
			BOOL RemoveSymbolAndNumber;
			BOOL CreateNoFolderIfSingleFileOnly;
			BOOL LimitExtractFileCount;
			int MaxExtractFileCount;
			BOOL DeleteArchiveAfterExtract;	//ɉ𓀂łkt@C폜
			BOOL MoveToRecycleBin;			//𓀌t@CݔɈړ
			BOOL DeleteNoConfirm;			//mFɍ폜/ݔɈړ
		}Extract;

		BOOL WarnNetwork;
		BOOL WarnRemovable;
		LOSTDIR OnDirNotFound;
		LOGVIEW LogViewEvent;

		struct{
			TCHAR FilerPath[_MAX_PATH+1];
			TCHAR Param[_MAX_PATH+1];
			BOOL UseFiler;
		}Filer;
	}Common;
	//----------------
	struct{	//֘AtŊJꍇ(/m)̃ftHg
		OPENACTION OpenAction;
		OPENACTION OpenAction_Shift;
		OPENACTION OpenAction_Ctrl;
	}OpenAction;
	//----------------
	struct{
		BOOL ShellMenuCompress;
		BOOL ShellMenuExtract;
		BOOL ShellMenuList;
		BOOL ShellMenuTest;
		BOOL ShellMenuUnderSubMenu;
		BOOL DragMenuCompress;
		BOOL DragMenuExtract;
		BOOL DragMenuUnderSubMenu;
		BOOL ForceExtraMenu;
		BOOL UseCustomMenu;
	}ShellExt;
	//----------------
	struct{
		BOOL AskUpdate;				//IɃAbvf[gmF邩
		int Interval;				//Abvf[g̎
		time_t LastTime;			//ŏIAbvf[gmF
		TCHAR szDLLPath[_MAX_PATH+1];	//DLLCXg[ꂽꏊ
	}Update;
	//----------------
	struct tagFileListWindow{
		int Width;					//EBhE̕
		int Height;					//EBhE̍
		int TreeWidth;				//c[r[̕

		int SortColumn;				//ǂ̃JŃ\[g邩
		BOOL SortDescending;		//\[g̏E~
		int ListStyle;				//Xgr[̌`

		BOOL StoreSetting;			//EBhE̐ݒۑ

		int WindowPos_x;			//EBhE̍W(x)
		int WindowPos_y;			//EBhE̍W(y)
		BOOL StoreWindowPosition;	//EBhËʒuۑ

		BOOL IgnoreMeaninglessPath;	//󔒂.݂̂̃pXw͖
		FILELISTMODE FileListMode;	//t@C\̊Kw[h
		BOOL ExpandTree;			//NɃc[r[WJĂ
		BOOL DisplayFileSizeInByte;	//oCgPʂŃt@CTCY\L
		int ColumnOrderArray[FILEINFO_MAX_NUM];	//Xgr[J̕я

		struct tagOpenAssoc{
			CString Accept;
			CString Deny;
		}OpenAssoc;

		std::vector<CMenuCommandItem> MenuCommandArray;	//uvOŊJṽR}h
	}FileListWindow;
	//----------------
	struct{
		LZH_COMPRESS_TYPE CompressType;
		BOOL ConfigSFX;
	}LZH;
	//----------------
	struct{
		ZIP_COMPRESS_TYPE CompressType;
		ZIP_COMPRESS_LEVEL CompressLevel;
		//ȉA㋉ݒ
		BOOL SpecifyDeflateMemorySize;
		int DeflateMemorySize;
		BOOL SpecifyDeflatePassNumber;
		int DeflatePassNumber;
	}ZIP;
	//----------------
	struct{
		CAB_COMPRESS_TYPE CompressType;
		int LZX_Level;
	}CAB;
	//----------------
	struct{
		BOOL UsePreset;
		SEVEN_ZIP_COMPRESS_TYPE CompressType;
		SEVEN_ZIP_COMPRESS_LEVEL CompressLevel;
		SEVEN_ZIP_LZMA_MODE LZMA_Mode;
		BOOL LZMA_MultiThread;
		BOOL SolidMode;
		BOOL HeaderCompression;
		BOOL FullHeaderCompression;
		BOOL HeaderEncryption;
		//ȉA㋉ݒ;̐ݒ͔fȂȂ
		BOOL SpecifyPPMdModelSize;
		int PPMdModelSize;
	}SEVEN_ZIP;
	//----------------
	struct{
		int GzipCompressLevel;
		int Bzip2CompressLevel;
	}TAR;
	//----------------
	struct{
		BOOL SpecifyVolumeSizeAtCompress;
		int VolumeSize;
	}JACK;
	//----------------
/*	struct{
		BH_COMPRESS_TYPE CompressType;
	}BH;*/
	//----------------
	struct{
		HKI_COMPRESS_LEVEL CompressLevel;
		HKI_ENCRYPT_ALGORITHM EncryptAlgorithm;
	}HKI;
	//----------------
	struct{
		int BZALevel;
		int GZALevel;
	}BGA;
	//----------------
	struct{
		ISH_ENCODE_TYPE EncodeType;
		BOOL UUEncodeChecksum;
	}AISH;
	//----------------
	struct tagXACRETT{
		BOOL EnableDLL;
		BOOL EnableShellMenu;
		CString Extensions;
		tagXACRETT():EnableDLL(FALSE),EnableShellMenu(FALSE){}
	}XACRETT;
	//----------------
	struct tagB2E{
		BOOL EnableDLL;
		BOOL EnableShellMenu;
		TCHAR ScriptDirectory[_MAX_PATH+1];
		CString Extensions;
		BOOL Priority;	//B2EXacRett.dllD悳ȂTRUE
		tagB2E():EnableDLL(FALSE),Priority(FALSE),EnableShellMenu(FALSE){}
	}B2E;
};

