#include "common.h"
#include "config_assoc.h"

#define ICONINDEX_EXTERNAL_SINGLE	21

//ASTYPE=TAR,LZH,etc.
//EXT=.lzh,.tar,etc.
#define LOAD_ASSOC_AND_SET_ICON(TYPE,EXT,INDEX,INDEX2)	{\
	AssocSettings[ASSOC_##TYPE].DefaultIconIndex=INDEX;\
	AssocSettings[ASSOC_##TYPE].DefaultIconIndex_Ex=INDEX2;\
	AssocSettings[ASSOC_##TYPE].Picture_Icon=GetDlgItem(IDC_STATIC_ASSOCIATION_##TYPE);\
	AssocSettings[ASSOC_##TYPE].Button_SetIcon=GetDlgItem(IDC_BUTTON_CHANGE_ICON_##TYPE);\
	AssocSettings[ASSOC_##TYPE].Check_SetAssoc=GetDlgItem(IDC_CHECK_ASSOCIATION_##TYPE);\
	AssocSettings[ASSOC_##TYPE].AssocInfo.Ext=EXT;\
	AssocSettings[ASSOC_##TYPE].Check_SetAssoc.SetCheck(FALSE);\
	if(AssocGetAssociation(AssocSettings[ASSOC_##TYPE].AssocInfo)){\
		AssocSettings[ASSOC_##TYPE].SetIconFromAssoc(Icon_SystemDefault);/*֘At񂩂ACR擾*/\
		AssocSettings[ASSOC_##TYPE].CheckAssociation(ShellOpenCommand_Desired);	/*֘At񂪐ǂ`FbN*/\
		if(!AssocSettings[ASSOC_##TYPE].AssocInfo.bOrgStatus){\
			AssocSettings[ASSOC_##TYPE].Button_SetIcon.EnableWindow(false);\
			AssocSettings[ASSOC_##TYPE].Check_SetAssoc.SetCheck(FALSE);\
		}\
		else{\
			AssocSettings[ASSOC_##TYPE].Check_SetAssoc.SetCheck(TRUE);\
		}\
	}\
	else{\
		AssocSettings[ASSOC_##TYPE].Picture_Icon.SetIcon(Icon_SystemDefault);\
		AssocSettings[ASSOC_##TYPE].Button_SetIcon.EnableWindow(false);\
	}\
}

//--------------------------------------------

//sN`{bNXɃACRw
LRESULT CConfigAssociationPage::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	// ֘AtShellOpenCommandZo
	{
		FILL_ZERO(ShellOpenCommand_Desired);
		GetModuleFileName(GetModuleHandle(NULL), ShellOpenCommand_Desired, _MAX_PATH);	//{̂̃pX擾
		PathQuoteSpaces(ShellOpenCommand_Desired);
		_tcscat(ShellOpenCommand_Desired,_T(" /m \"%1\""));	//p[^
		TRACE("ShellOpenCommand_Desired=%s\n",ShellOpenCommand_Desired);
	}

	// VXeftHgACR擾
	if(Icon_SystemDefault.IsNull()){
		TCHAR Path[_MAX_PATH+1];
		FILL_ZERO(Path);
		GetSystemDirectory(Path,_MAX_PATH);
		PathAppend(Path,_T("shell32.dll"));
		Icon_SystemDefault.ExtractIcon(Path,0);
	}

	// ֘At`FbN
	LOAD_ASSOC_AND_SET_ICON(LZH,	_T(".lzh"),	0,	0);
	LOAD_ASSOC_AND_SET_ICON(LZS,	_T(".lzs"),	0,	22);
	LOAD_ASSOC_AND_SET_ICON(LHA,	_T(".lha"),	0,	23);
	LOAD_ASSOC_AND_SET_ICON(ZIP,	_T(".zip"),	1,	1);
	LOAD_ASSOC_AND_SET_ICON(JAR,	_T(".jar"),	2,	2);
	LOAD_ASSOC_AND_SET_ICON(CAB,	_T(".cab"),	3,	3);
	LOAD_ASSOC_AND_SET_ICON(7Z,		_T(".7z"),	4,	4);
	LOAD_ASSOC_AND_SET_ICON(ARJ,	_T(".arj"),	14,	14);
	LOAD_ASSOC_AND_SET_ICON(RAR,	_T(".rar"),	5,	5);
	LOAD_ASSOC_AND_SET_ICON(JAK,	_T(".jak"),	10,	10);
	LOAD_ASSOC_AND_SET_ICON(GCA,	_T(".gca"),	6,	6);
	LOAD_ASSOC_AND_SET_ICON(IMP,	_T(".imp"),	17,	17);
	LOAD_ASSOC_AND_SET_ICON(ACE,	_T(".ace"),	13,	13);
	LOAD_ASSOC_AND_SET_ICON(YZ1,	_T(".yz1"),	12,	12);
	LOAD_ASSOC_AND_SET_ICON(HKI,	_T(".hki"),	11,	11);
	LOAD_ASSOC_AND_SET_ICON(BZA,	_T(".bza"),	15,	15);
	LOAD_ASSOC_AND_SET_ICON(GZA,	_T(".gza"),	16,	16);
	LOAD_ASSOC_AND_SET_ICON(ISH,	_T(".ish"),	18,	18);
	LOAD_ASSOC_AND_SET_ICON(UUE,	_T(".uue"),	19,	19);
	LOAD_ASSOC_AND_SET_ICON(BEL,	_T(".bel"),	20,	20);

	LOAD_ASSOC_AND_SET_ICON(TAR,	_T(".tar"),	7,	24);
	LOAD_ASSOC_AND_SET_ICON(GZ,		_T(".gz"),	7,	25);
	LOAD_ASSOC_AND_SET_ICON(TGZ,	_T(".tgz"),	7,	26);
	LOAD_ASSOC_AND_SET_ICON(BZ2,	_T(".bz2"),	7,	27);
	LOAD_ASSOC_AND_SET_ICON(TBZ,	_T(".tbz"),	7,	28);
	LOAD_ASSOC_AND_SET_ICON(Z,		_T(".z"),	7,	29);
	LOAD_ASSOC_AND_SET_ICON(TAZ,	_T(".taz"),	7,	30);
	LOAD_ASSOC_AND_SET_ICON(CPIO,	_T(".cpio"),7,	31);
	LOAD_ASSOC_AND_SET_ICON(A,		_T(".a"),	7,	32);
	LOAD_ASSOC_AND_SET_ICON(LIB,	_T(".lib"),	9,	9);
	LOAD_ASSOC_AND_SET_ICON(RPM,	_T(".rpm"),	8,	33);
	LOAD_ASSOC_AND_SET_ICON(DEB,	_T(".deb"),	8,	34);
	return TRUE;
}


LRESULT CConfigAssociationPage::OnCheckAssoc(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		for(int i=0;i<ASSOC_TYPE_MAX_NUM;i++){
			if(hWndCtl==AssocSettings[i].Check_SetAssoc){
				BOOL bEnabled=AssocSettings[i].Check_SetAssoc.GetCheck();
				AssocSettings[i].Button_SetIcon.EnableWindow(bEnabled);
				if(!bEnabled){
					AssocSettings[i].SetIconFromAssoc(Icon_SystemDefault);
				}
				break;
			}
		}
	}
	return 0;
}


LRESULT CConfigAssociationPage::OnChangeIcon(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED==wNotifyCode){
		for(int i=0;i<ASSOC_TYPE_MAX_NUM;i++){
			if(hWndCtl==AssocSettings[i].Button_SetIcon){
				CIconSelectDialog isd(AssocSettings[i].AssocInfo);
				if(IDOK==isd.DoModal()){
					TRACE("IconFile=%s\n",AssocSettings[i].AssocInfo.IconFile);
					AssocSettings[i].SetIcon(AssocSettings[i].AssocInfo.IconFile,AssocSettings[i].AssocInfo.IconIndex);
					AssocSettings[i].bChanged=true;
				}
				break;
			}
		}
	}
	return 0;
}

LRESULT CConfigAssociationPage::OnSetAssoc(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(BN_CLICKED!=wNotifyCode){
		return 0;
	}

	TCHAR ResourcePath[_MAX_PATH+1];	//ACRt@C
	int IconIndex=-1;
	if(IDC_BUTTON_ASSOC_SET_DEFAULT_ICON==wID||IDC_BUTTON_ASSOC_SET_DEFAULT_ICON_SINGLE==wID){
		//--------------
		// WACR
		//--------------
		FILL_ZERO(ResourcePath);
		GetModuleFileName(GetModuleHandle(NULL), ResourcePath, _MAX_PATH);	//{̂̃pX擾
		//EXẼpXDLL̃t@CgݗĂ
		PathRemoveFileSpec(ResourcePath);
		PathAppend(ResourcePath,CString(MAKEINTRESOURCE(IDS_ICON_FILE_NAME_DEFAULT)));
	}
	else if(IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON==wID||IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON_SINGLE==wID){
		//------------------------------------
		// ÕACRt@CZbg
		//------------------------------------

		//ACRI(ftHg͕WACR)
		ASSOCINFO ac;
		CIconSelectDialog isd(ac);
		if(IDOK!=isd.DoModal()){
			return 0;
		}
		TRACE("IconFile=%s\n",ac.IconFile);
		_tcsncpy(ResourcePath,ac.IconFile,_MAX_PATH);
		IconIndex=ac.IconIndex;
		if(IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON_SINGLE==wID&&-1==IconIndex){
			//ACRIĂȂ
			return 0;
		}
	}
	for(int i=0;i<ASSOC_TYPE_MAX_NUM;i++){
		switch(wID){
		case IDC_BUTTON_ASSOC_CHECK_ALL:
			AssocSettings[i].Button_SetIcon.EnableWindow(TRUE);
			AssocSettings[i].Check_SetAssoc.SetCheck(TRUE);
			break;
		case IDC_BUTTON_ASSOC_UNCHECK_ALL:
			AssocSettings[i].Button_SetIcon.EnableWindow(FALSE);
			AssocSettings[i].Check_SetAssoc.SetCheck(FALSE);
			AssocSettings[i].SetIconFromAssoc(Icon_SystemDefault);
			break;
		case IDC_BUTTON_ASSOC_SET_DEFAULT_ICON:	//FALLTHROUGH
		case IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON:
			//SĕWACR/SĊOACR
			{
				int IconCount=(int)ExtractIcon(GetModuleHandle(NULL),ResourcePath,-1);
				const bool bExtraIcon=(IconCount>=35);	//ACR̐35葽ΑSĎʂ^CṽACRƂƂɂȂ
				if(AssocSettings[i].Check_SetAssoc.GetCheck()){
					AssocSettings[i].AssocInfo.IconIndex=bExtraIcon?AssocSettings[i].DefaultIconIndex_Ex:AssocSettings[i].DefaultIconIndex;
					AssocSettings[i].AssocInfo.IconFile=ResourcePath;
					AssocSettings[i].SetIcon(AssocSettings[i].AssocInfo.IconFile,AssocSettings[i].AssocInfo.IconIndex);
					AssocSettings[i].bChanged=true;
				}
			}
			break;
		case IDC_BUTTON_ASSOC_SET_DEFAULT_ICON_SINGLE:
			//SĕWPACR
			if(AssocSettings[i].Check_SetAssoc.GetCheck()){
				AssocSettings[i].AssocInfo.IconIndex=ICONINDEX_EXTERNAL_SINGLE;
				AssocSettings[i].AssocInfo.IconFile=ResourcePath;
				AssocSettings[i].SetIcon(AssocSettings[i].AssocInfo.IconFile,AssocSettings[i].AssocInfo.IconIndex);
				AssocSettings[i].bChanged=true;
			}
			break;
		case IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON_SINGLE:
			//SĊOPACR
			if(AssocSettings[i].Check_SetAssoc.GetCheck()){
				AssocSettings[i].AssocInfo.IconIndex=IconIndex;
				AssocSettings[i].AssocInfo.IconFile=ResourcePath;
				AssocSettings[i].SetIcon(AssocSettings[i].AssocInfo.IconFile,AssocSettings[i].AssocInfo.IconIndex);
				AssocSettings[i].bChanged=true;
			}
			break;
		}
	}
	return 0;
}

LRESULT CConfigAssociationPage::OnApply()
{
	bool bRegChanged=false;
	for(int i=0;i<ASSOC_TYPE_MAX_NUM;i++){
		//WXgύX̕Kvꍇ
		bool Checked=(0!=AssocSettings[i].Check_SetAssoc.GetCheck());
		if((AssocSettings[i].AssocInfo.bOrgStatus^Checked)||AssocSettings[i].bChanged){
			bRegChanged=true;
			if(AssocSettings[i].AssocInfo.bOrgStatus&&!Checked){
				//Delete
				AssocDeleteAssociation(AssocSettings[i].AssocInfo.Ext);
			}
			else{
				//Set
				AssocSettings[i].AssocInfo.ShellOpenCommand=ShellOpenCommand_Desired;
				AssocSetAssociation(AssocSettings[i].AssocInfo);
			}
		}
	}
	if(bRegChanged){
		SHChangeNotify(SHCNE_ASSOCCHANGED,SHCNF_FLUSH,NULL,NULL);	//֘At̕ύXVFɒʒm
	}
	return TRUE;
}


//==================================================================================

CIconSelectDialog::CIconSelectDialog(ASSOCINFO &ai)
{
	AssocInfo=&ai;
	if(AssocInfo->IconFile.IsEmpty()){
		TCHAR ResourcePath[_MAX_PATH+1];
		FILL_ZERO(ResourcePath);
		GetModuleFileName(GetModuleHandle(NULL), ResourcePath, _MAX_PATH);	//{̂̃pX擾
		//EXẼpXDLL̃t@CgݗĂ
		PathRemoveFileSpec(ResourcePath);
		PathAppend(ResourcePath,CString(MAKEINTRESOURCE(IDS_ICON_FILE_NAME_DEFAULT)));
		IconPath=ResourcePath;
		TRACE("Set Default Icon Path\n");
	}
	else{
		IconPath=AssocInfo->IconFile;
	}
}

LRESULT CIconSelectDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	ASSERT(AssocInfo);
	CenterWindow();
	ListView=GetDlgItem(IDC_LIST_ICON);
	//DDXAbvf[g
	DoDataExchange(FALSE);

	UpdateIcon();
	ListView.SetItemState(AssocInfo->IconIndex,LVIS_SELECTED,1);

	// _CAOTCY
	DlgResize_Init(true, true, WS_THICKFRAME | WS_CLIPCHILDREN);
	return TRUE;
}

void CIconSelectDialog::OnOK(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	if(!DoDataExchange(TRUE))return;
	AssocInfo->IconFile=IconPath;
	const int ItemCount=ListView.GetItemCount();
	for(int i=0;i<ItemCount;i++){
		if(ListView.GetItemState(i,LVIS_SELECTED)){
			AssocInfo->IconIndex=i;
			break;
		}
	}
	EndDialog(nID);
}

void CIconSelectDialog::OnBrowse(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	TCHAR filter[_MAX_PATH+2];
	FILL_ZERO(filter);
	_tcsncpy(filter,_T("Icon File"),_MAX_PATH);
	int Index=_tcslen(filter)+1;
	_tcsncat(filter+Index,_T("*.dll;*.exe;*.ico;*.ocx;*.cpl;*.vbx;*.scr;*.icl"),_MAX_PATH-Index);

	if(!DoDataExchange(TRUE))return;
	CFileDialog dlg(TRUE, NULL, IconPath, OFN_HIDEREADONLY|OFN_NOCHANGEDIR,filter);
	if(IDCANCEL==dlg.DoModal()){	//LZ
		return;
	}

	IconPath=dlg.m_szFileName;
	DoDataExchange(FALSE);
	UpdateIcon();
}

LRESULT CIconSelectDialog::OnBrowseDefault(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	TCHAR ResourcePath[_MAX_PATH+1];
	FILL_ZERO(ResourcePath);
	GetModuleFileName(GetModuleHandle(NULL), ResourcePath, _MAX_PATH);	//{̂̃pX擾
	//EXẼpXDLL̃t@CgݗĂ
	PathRemoveFileSpec(ResourcePath);
	switch(wID){
	case IDC_BUTTON_BROWSE_DEFAULT_ICON:
		PathAppend(ResourcePath,CString(MAKEINTRESOURCE(IDS_ICON_FILE_NAME_DEFAULT)));
		break;
	case IDC_BUTTON_BROWSE_TEXT_ICON:
		PathAppend(ResourcePath,CString(MAKEINTRESOURCE(IDS_ICON_FILE_NAME_TEXT)));
		break;
	case IDC_BUTTON_BROWSE_CIRCLE_ICON:
		PathAppend(ResourcePath,CString(MAKEINTRESOURCE(IDS_ICON_FILE_NAME_CIRCLE)));
		break;
	default:
		return 0;
	}
	IconPath=ResourcePath;

	DoDataExchange(FALSE);
	UpdateIcon();
	return 0;
}

bool CIconSelectDialog::UpdateIcon()
{
	ListView.DeleteAllItems();
	IconList.Destroy();
	int IconCount=(int)ExtractIcon(GetModuleHandle(NULL),IconPath,-1);
	if(0==IconCount){
		ListView.EnableWindow(false);
		return false;
	}
	ListView.EnableWindow(true);
	IconList.Create(32,32,ILC_COLORDDB | ILC_MASK,IconCount,1);
	for(int i=0;i<IconCount;i++){
		CIcon Icon;
		Icon.ExtractIcon(IconPath,i);
		IconList.AddIcon(Icon);
	}
	ListView.SetImageList(IconList,LVSIL_NORMAL);
	for(i=0;i<IconCount;i++){
		ListView.AddItem(i,0,_T(""),i);
	}
	return true;
}
