#pragma once
#include "../common.h"
#include "../resource.h"
#include "../util.h"
#include <atlddx.h>		// DDX/DDVgp邽
//#include "../Association.h"
#include "./AssocSettings.h"

//====================================
// ֘At
//====================================

enum ASSOC_TYPE{
	ASSOC_LZH,
	ASSOC_LZS,
	ASSOC_LHA,
	ASSOC_ZIP,
	ASSOC_JAR,
	ASSOC_CAB,
	ASSOC_7Z,
	ASSOC_ARJ,
	ASSOC_RAR,
	ASSOC_JAK,
	ASSOC_GCA,
	ASSOC_YZ1,
	ASSOC_IMP,
	ASSOC_ACE,
	ASSOC_HKI,
	ASSOC_BZA,
	ASSOC_GZA,
	ASSOC_ISH,
	ASSOC_UUE,
	ASSOC_BEL,
	ASSOC_TAR,
	ASSOC_GZ,
	ASSOC_TGZ,
	ASSOC_BZ2,
	ASSOC_TBZ,
	ASSOC_Z,
	ASSOC_TAZ,
	ASSOC_CPIO,
	ASSOC_A,
	ASSOC_LIB,
	ASSOC_RPM,
	ASSOC_DEB,
	ASSOC_TYPE_MAX_NUM
};


class CConfigAssociationPage : public CDialogImpl<CConfigAssociationPage>,public CMessageFilter
{
protected:
	ASSOC_SETTINGS AssocSettings[ASSOC_TYPE_MAX_NUM];
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}
	TCHAR ShellOpenCommand_Desired[_MAX_PATH*2+1];	//WIȊ֘AtpX;ƈقȂĂꍇɂ͊֘At̕ύXtOĂĂ

	CIcon Icon_SystemDefault;	//֘AtȂ̃ACR

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_ASSOCIATION };

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigAssociationPage)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_RANGE_HANDLER(IDC_CHECK_ASSOCIATION_LZH,IDC_CHECK_ASSOCIATION_BEL, OnCheckAssoc)
		COMMAND_RANGE_HANDLER(IDC_BUTTON_CHANGE_ICON_LZH,IDC_BUTTON_CHANGE_ICON_BEL, OnChangeIcon)
		COMMAND_RANGE_HANDLER(IDC_BUTTON_ASSOC_CHECK_ALL,IDC_BUTTON_ASSOC_SET_EXTERNAL_ICON_SINGLE, OnSetAssoc)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnCheckAssoc(WORD,WORD,HWND,BOOL&);
	LRESULT OnChangeIcon(WORD,WORD,HWND,BOOL&);
	LRESULT OnSetAssoc(WORD,WORD,HWND,BOOL&);
	LRESULT OnApply();

	CConfigAssociationPage()
	{
		TRACE("CConfigAssociationPage()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};


class CIconSelectDialog : public CDialogImpl<CIconSelectDialog>,public CWinDataExchange<CIconSelectDialog>,public CDialogResize<CIconSelectDialog>
{
protected:
	ASSOCINFO *AssocInfo;
	CIconSelectDialog();
	CImageList	IconList;
	CListViewCtrl ListView;
	CString IconPath;
public:
	enum {IDD = IDD_DIALOG_ICON_SELECT};

	// _CAOTCY}bv
	BEGIN_DLGRESIZE_MAP(CIconSelectDialog)
		DLGRESIZE_CONTROL(IDC_BUTTON_BROWSE_DEFAULT_ICON,	DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_BROWSE_TEXT_ICON,		DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_BROWSE_CIRCLE_ICON,	DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_EDIT_ICON_PATH,				DLSZ_SIZE_X)
		DLGRESIZE_CONTROL(IDC_BUTTON_BROWSE_ICON,			DLSZ_MOVE_X)
		DLGRESIZE_CONTROL(IDC_LIST_ICON,					DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDOK,								DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDCANCEL,							DLSZ_MOVE_X | DLSZ_MOVE_Y)
	END_DLGRESIZE_MAP()

	// DDX}bv
	BEGIN_DDX_MAP(CIconSelectDialog)
		DDX_TEXT(IDC_EDIT_ICON_PATH,IconPath)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CIconSelectDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_BROWSE_ICON, OnBrowse)
		COMMAND_RANGE_HANDLER(IDC_BUTTON_BROWSE_DEFAULT_ICON,IDC_BUTTON_BROWSE_CIRCLE_ICON, OnBrowseDefault)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		CHAIN_MSG_MAP(CDialogResize<CIconSelectDialog>)    // CDialogResizeNXւ̃`F[
	END_MSG_MAP()

	CIconSelectDialog(ASSOCINFO&);
	bool UpdateIcon();

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnBrowse(UINT uNotifyCode, int nID, HWND hWndCtl);
	LRESULT OnBrowseDefault(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl);
	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl){
		EndDialog(nID);
	}
};

