#pragma once
#include "config.h"
#include "../resource.h"
#include <atlddx.h>		// DDX/DDVgp邽

//====================================
// 𓀈ʐݒ
//====================================
class CConfigExtractGeneral : public CDialogImpl<CConfigExtractGeneral>,public CMessageFilter,public CWinDataExchange<CConfigExtractGeneral>
{
protected:
	CConfigManager	&Config;
	CButton Radio_ExtractTo[EXTRACT_TO_MAX_NUM];
	CEdit Edit_ExtractOutputDirPath;
	CButton Button_ExtractToFolder;
	CButton Radio_CreateDir[CREATE_OUTPUT_DIR_MAX_NUM];
	CUpDownCtrl UpDown_MaxExtractFileCount;
	CButton Check_LimitExtractFileCount;
	CButton Check_DeleteFileAfterExtract;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_EXTRACT_GENERAL };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigGeneral)
		DDX_CHECK(IDC_CHECK_REMOVE_SYMBOL_AND_NUMBER, Config.Common.Extract.RemoveSymbolAndNumber)
		DDX_CHECK(IDC_CHECK_OPEN_FOLDER_AFTER_EXTRACT, Config.Common.Extract.OpenDir)
		DDX_CHECK(IDC_CHECK_FORCE_OVERWRITE, Config.Common.Extract.ForceOverwrite)
		DDX_CHECK(IDC_CHECK_CREATE_NO_FOLDER_IF_SINGLE_FILE_ONLY,Config.Common.Extract.CreateNoFolderIfSingleFileOnly)
		DDX_CHECK(IDC_CHECK_LIMIT_EXTRACT_FILECOUNT,Config.Common.Extract.LimitExtractFileCount)
		DDX_CHECK(IDC_CHECK_DELETE_ARCHIVE_AFTER_EXTRACT,Config.Common.Extract.DeleteArchiveAfterExtract)
		DDX_CHECK(IDC_CHECK_MOVETO_RECYCLE_BIN,Config.Common.Extract.MoveToRecycleBin)
		DDX_CHECK(IDC_CHECK_DELETE_ARCHIVE_AFTER_EXTRACT_NOCONFIRM,Config.Common.Extract.DeleteNoConfirm)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigExtractGeneral)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_RANGE_HANDLER(IDC_RADIO_EXTRACT_TO_DESKTOP,IDC_RADIO_EXTRACT_TO_ALWAYS_ASK_WHERE, OnRadioExtractTo)
		COMMAND_RANGE_HANDLER(IDC_RADIO_CREATE_FOLDER,IDC_RADIO_CREATE_NO_FOLDER,OnRadioCreateDirectory)
		COMMAND_ID_HANDLER(IDC_BUTTON_EXTRACT_BROWSE_FOLDER,OnBrowseFolder)
		COMMAND_ID_HANDLER(IDC_CHECK_LIMIT_EXTRACT_FILECOUNT,OnCheckLimitExtractFileCount)
		COMMAND_ID_HANDLER(IDC_CHECK_DELETE_ARCHIVE_AFTER_EXTRACT,OnCheckDeleteArchive)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnRadioExtractTo(WORD,WORD,HWND,BOOL&);
	LRESULT OnRadioCreateDirectory(WORD,WORD,HWND,BOOL&);
	LRESULT OnBrowseFolder(WORD,WORD,HWND,BOOL&);
	LRESULT OnCheckLimitExtractFileCount(WORD,WORD,HWND,BOOL&);
	LRESULT OnCheckDeleteArchive(WORD,WORD,HWND,BOOL&);

	CConfigExtractGeneral(CConfigManager &cfg):
		Config(cfg)
	{
		TRACE("CConfigExtractGeneral()\n");
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}
};

