#include "common.h"
#include "config_filelistwindow.h"
#include "../temporarydirmgr.h"
#include "../LFFolderDialog.h"

//================================
// t@CꗗEBhEݒ
//================================
LRESULT CConfigFileListWindow::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);

	//DDXAbvf[g
	DoDataExchange(FALSE);

	//t@Cꗗ[h
	Radio_FileListMode[FILELIST_TREE]=GetDlgItem(IDC_RADIO_FILELIST_TREE);
	Radio_FileListMode[FILELIST_FLAT]=GetDlgItem(IDC_RADIO_FILELIST_FLAT);
	Radio_FileListMode[FILELIST_FLAT_FILESONLY]=GetDlgItem(IDC_RADIO_FILELIST_FLAT_FILESONLY);

	Radio_FileListMode[Config.FileListWindow.FileListMode].SetCheck(true);

	//uvOŊJvR}h֘A
	m_MenuCommandArray=Config.FileListWindow.MenuCommandArray;

	Edit_Path	=GetDlgItem(IDC_EDIT_FILELIST_USERAPP_PATH);
	Edit_Path.SetLimitText(_MAX_PATH);
	Edit_Param	=GetDlgItem(IDC_EDIT_FILELIST_USERAPP_PARAM);
	Edit_Param.SetLimitText(_MAX_PATH*3);
	Edit_Dir	=GetDlgItem(IDC_EDIT_FILELIST_USERAPP_DIR);
	Edit_Dir.SetLimitText(_MAX_PATH);
	Edit_Caption=GetDlgItem(IDC_EDIT_FILELIST_USERAPP_CAPTION);
	Edit_Caption.SetLimitText(_MAX_PATH);
	List_Command=GetDlgItem(IDC_LIST_FILELIST_USERAPP);

	CRect rect;
	List_Command.GetClientRect(rect);
	List_Command.InsertColumn(0, "",LVCFMT_LEFT,rect.Width());
	List_Command.SetExtendedListViewStyle(List_Command.GetExtendedListViewStyle()|LVS_EX_FULLROWSELECT);
	List_Command.SetItemCount(m_MenuCommandArray.size());

	m_lpMenuCommandItem=NULL;
	return TRUE;
}

LRESULT CConfigFileListWindow::OnApply()
{
//===============================
// ݒConfigManagerɏ߂
//===============================
	//---------------
	// DDXf[^XV
	//---------------
	if(!DoDataExchange(TRUE)){
		return FALSE;
	}
	for(int i=0;i<FILELISTMODE_MAX_NUM;i++){
		if(Radio_FileListMode[i].GetCheck()){
			Config.FileListWindow.FileListMode=(FILELISTMODE)i;
			break;
		}
	}
	//uvOŊJvR}h̍XV
	if(m_lpMenuCommandItem){
		Edit_Path.GetWindowText(m_lpMenuCommandItem->Path,sizeof(m_lpMenuCommandItem->Path)/sizeof(m_lpMenuCommandItem->Path[0])-1);
		Edit_Param.GetWindowText(m_lpMenuCommandItem->Param,sizeof(m_lpMenuCommandItem->Param)/sizeof(m_lpMenuCommandItem->Param[0])-1);
		Edit_Dir.GetWindowText(m_lpMenuCommandItem->Dir,sizeof(m_lpMenuCommandItem->Dir)/sizeof(m_lpMenuCommandItem->Dir[0])-1);
		Edit_Caption.GetWindowText(m_lpMenuCommandItem->Caption,sizeof(m_lpMenuCommandItem->Caption)/sizeof(m_lpMenuCommandItem->Caption[0])-1);
	}
	Config.FileListWindow.MenuCommandArray=m_MenuCommandArray;
	return TRUE;
}

void CConfigFileListWindow::OnClearTemporary(UINT,int,HWND)
{
	//cĂ܂e|fBNg폜
	if(!CTemporaryDirectoryManager::DeleteAllTemporaryDir(_T("lhaf")))MessageBeep(MB_ICONHAND);
}

void CConfigFileListWindow::OnResetExt(UINT,int nID,HWND)
{
	switch(nID){
	case IDC_BUTTON_RESET_OPENASSOC_ACCEPT:
		::SetWindowText(GetDlgItem(IDC_EDIT_OPENASSOC_ACCEPT),CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_ACCEPT)));
		break;
	case IDC_BUTTON_RESET_OPENASSOC_DENY:
		::SetWindowText(GetDlgItem(IDC_EDIT_OPENASSOC_DENY),CString(MAKEINTRESOURCE(IDS_FILELIST_OPENASSOC_DEFAULT_DENY)));
		break;
	}
}

//vȌꏊQ
void CConfigFileListWindow::OnBrowsePath(UINT, int, HWND)
{
	TCHAR filter[_MAX_PATH+2];
	FILL_ZERO(filter);
	_tcsncpy(filter,_T("Program(*.exe;*.com;*.bat;*.cmd)"),_MAX_PATH);
	int Index=_tcslen(filter)+1;
	LPCTSTR lpTemp=_T("*.exe;*.com;*.bat;*.cmd");
	_tcsncat(filter+Index,lpTemp,_MAX_PATH-Index);
	Index+=_tcslen(lpTemp)+1;
	lpTemp=_T("All Files(*.*)");
	_tcsncat(filter+Index,lpTemp,_MAX_PATH-Index);
	Index+=_tcslen(lpTemp)+1;
	_tcsncat(filter+Index,_T("*.*"),_MAX_PATH-Index);

	TCHAR szPath[_MAX_PATH+1];
	Edit_Path.GetWindowText(szPath,_MAX_PATH);
	CFileDialog dlg(TRUE, NULL, szPath, OFN_HIDEREADONLY|OFN_NOCHANGEDIR,filter);
	if(IDCANCEL==dlg.DoModal()){	//LZ
		return;
	}
	Edit_Path.SetWindowText(dlg.m_szFileName);
}

//tH_Q
void CConfigFileListWindow::OnBrowseDir(UINT, int, HWND)
{
	TCHAR szPath[_MAX_PATH+1];
	Edit_Dir.GetWindowText(szPath,_MAX_PATH);
	CLFFolderDialog dlg(NULL,NULL,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
	dlg.SetInitialFolder(szPath);

	if(IDCANCEL==dlg.DoModal()){	//LZ
		return;
	}
	Edit_Dir.SetWindowText(dlg.GetFolderPath());
}

//zXgr[̃ACe擾
LRESULT CConfigFileListWindow::OnGetDispInfo(LPNMHDR pnmh)
{
	LV_DISPINFO* pstLVDInfo=(LV_DISPINFO*)pnmh;

	if(pstLVDInfo->item.iItem<0||pstLVDInfo->item.iItem>=(signed)m_MenuCommandArray.size())return 1;
	CMenuCommandItem &mci=m_MenuCommandArray[pstLVDInfo->item.iItem];

	if(pstLVDInfo->item.mask & LVIF_TEXT){
		_tcsncpy(pstLVDInfo->item.pszText,mci.Caption,pstLVDInfo->item.cchTextMax);
	}
	return 0;
}

//ACeIύX
LRESULT CConfigFileListWindow::OnSelect(LPNMHDR pnmh)
{
	if(m_lpMenuCommandItem){
		Edit_Path.GetWindowText(m_lpMenuCommandItem->Path,sizeof(m_lpMenuCommandItem->Path)/sizeof(m_lpMenuCommandItem->Path[0])-1);
		Edit_Param.GetWindowText(m_lpMenuCommandItem->Param,sizeof(m_lpMenuCommandItem->Param)/sizeof(m_lpMenuCommandItem->Param[0])-1);
		Edit_Dir.GetWindowText(m_lpMenuCommandItem->Dir,sizeof(m_lpMenuCommandItem->Dir)/sizeof(m_lpMenuCommandItem->Dir[0])-1);
		Edit_Caption.GetWindowText(m_lpMenuCommandItem->Caption,sizeof(m_lpMenuCommandItem->Caption)/sizeof(m_lpMenuCommandItem->Caption[0])-1);
	}

	int iItem=List_Command.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1!=iItem&&iItem<(signed)m_MenuCommandArray.size()){
		m_lpMenuCommandItem=&m_MenuCommandArray[iItem];
		Edit_Path.SetWindowText(m_lpMenuCommandItem->Path);
		Edit_Param.SetWindowText(m_lpMenuCommandItem->Param);
		Edit_Dir.SetWindowText(m_lpMenuCommandItem->Dir);
		Edit_Caption.SetWindowText(m_lpMenuCommandItem->Caption);
	}
	return 0;
}

//ڂֈړ
LRESULT CConfigFileListWindow::OnUserAppMoveUp(WORD,WORD,HWND,BOOL&)
{
	int iItem=List_Command.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1==iItem||iItem>=(signed)m_MenuCommandArray.size())return FALSE;
	if(0==iItem){
		MessageBeep(MB_ICONASTERISK);
		return TRUE;
	}
	CMenuCommandItem mci=m_MenuCommandArray[iItem];
	m_MenuCommandArray[iItem]=m_MenuCommandArray[iItem-1];
	m_MenuCommandArray[iItem-1]=mci;
	m_lpMenuCommandItem=&m_MenuCommandArray[iItem-1];
	Edit_Path.SetWindowText(m_lpMenuCommandItem->Path);
	Edit_Param.SetWindowText(m_lpMenuCommandItem->Param);
	Edit_Dir.SetWindowText(m_lpMenuCommandItem->Dir);
	Edit_Caption.SetWindowText(m_lpMenuCommandItem->Caption);

	List_Command.EnsureVisible(iItem-1,FALSE);
	List_Command.SetItemState(iItem-1,LVIS_SELECTED, LVIS_SELECTED);
	return TRUE;
}

//ڂֈړ
LRESULT CConfigFileListWindow::OnUserAppMoveDown(WORD,WORD,HWND,BOOL&)
{
	int iItem=List_Command.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1==iItem||iItem>=(signed)m_MenuCommandArray.size())return FALSE;
	if((signed)m_MenuCommandArray.size()-1==iItem){
		MessageBeep(MB_ICONASTERISK);
		return TRUE;
	}
	CMenuCommandItem mci=m_MenuCommandArray[iItem];
	m_MenuCommandArray[iItem]=m_MenuCommandArray[iItem+1];
	m_MenuCommandArray[iItem+1]=mci;
	m_lpMenuCommandItem=&m_MenuCommandArray[iItem+1];
	Edit_Path.SetWindowText(m_lpMenuCommandItem->Path);
	Edit_Param.SetWindowText(m_lpMenuCommandItem->Param);
	Edit_Dir.SetWindowText(m_lpMenuCommandItem->Dir);
	Edit_Caption.SetWindowText(m_lpMenuCommandItem->Caption);

	List_Command.EnsureVisible(iItem+1,FALSE);
	List_Command.SetItemState(iItem+1,LVIS_SELECTED, LVIS_SELECTED);
	return TRUE;
}

//ڂ̐VK쐬
LRESULT CConfigFileListWindow::OnUserAppNew(WORD,WORD,HWND,BOOL&)
{
	//ڂ̕ۑ
	if(m_lpMenuCommandItem){
		Edit_Path.GetWindowText(m_lpMenuCommandItem->Path,sizeof(m_lpMenuCommandItem->Path)/sizeof(m_lpMenuCommandItem->Path[0])-1);
		Edit_Param.GetWindowText(m_lpMenuCommandItem->Param,sizeof(m_lpMenuCommandItem->Param)/sizeof(m_lpMenuCommandItem->Param[0])-1);
		Edit_Dir.GetWindowText(m_lpMenuCommandItem->Dir,sizeof(m_lpMenuCommandItem->Dir)/sizeof(m_lpMenuCommandItem->Dir[0])-1);
		Edit_Caption.GetWindowText(m_lpMenuCommandItem->Caption,sizeof(m_lpMenuCommandItem->Caption)/sizeof(m_lpMenuCommandItem->Caption[0])-1);
	}

	//Vڂ̐ݒ
	CMenuCommandItem mci={0};
	_tcsncpy(mci.Caption,_T("UserApp"),sizeof(mci.Caption)/sizeof(mci.Caption[0])-1);
	_tcsncpy(mci.Param,_T("%S"),sizeof(mci.Param)/sizeof(mci.Param[0])-1);
	m_MenuCommandArray.push_back(mci);
	int iItem=m_MenuCommandArray.size()-1;
	m_lpMenuCommandItem=&m_MenuCommandArray[iItem];

	Edit_Path.SetWindowText(m_lpMenuCommandItem->Path);
	Edit_Param.SetWindowText(m_lpMenuCommandItem->Param);
	Edit_Dir.SetWindowText(m_lpMenuCommandItem->Dir);
	Edit_Caption.SetWindowText(m_lpMenuCommandItem->Caption);
	List_Command.SetItemCount(m_MenuCommandArray.size());
	List_Command.EnsureVisible(iItem,FALSE);
	List_Command.SetItemState(iItem,LVIS_SELECTED, LVIS_SELECTED);
	return TRUE;
}

//ڂ폜
LRESULT CConfigFileListWindow::OnUserAppDelete(WORD,WORD,HWND,BOOL&)
{
	int iItem=List_Command.GetNextItem(-1,LVNI_ALL|LVNI_SELECTED);
	if(-1==iItem||iItem>=(signed)m_MenuCommandArray.size())return FALSE;
	std::vector<CMenuCommandItem>::iterator ite=m_MenuCommandArray.begin();

	//폜ΏۃACě
	ite+=iItem;
	m_MenuCommandArray.erase(ite);

	List_Command.SetItemCount(m_MenuCommandArray.size());

	if(m_MenuCommandArray.empty()){
		m_lpMenuCommandItem=NULL;
		return TRUE;
	}
	if(iItem!=0)iItem--;
	m_lpMenuCommandItem=&m_MenuCommandArray[iItem];
	Edit_Path.SetWindowText(m_lpMenuCommandItem->Path);
	Edit_Param.SetWindowText(m_lpMenuCommandItem->Param);
	Edit_Dir.SetWindowText(m_lpMenuCommandItem->Dir);
	Edit_Caption.SetWindowText(m_lpMenuCommandItem->Caption);

	List_Command.EnsureVisible(iItem,FALSE);
	List_Command.SetItemState(iItem,LVIS_SELECTED, LVIS_SELECTED);
	return TRUE;
}
