#include "common.h"
#include "configwnd.h"


CConfigDialog::CConfigDialog(CConfigManager &cfg)
	:Config(cfg),
	hActiveDialogWnd(NULL),
	PageGeneral(cfg),
	PageShellExt(cfg),
	PageCompressGeneral(cfg),
	PageExtractGeneral(cfg),
	PageLZH(cfg),
	PageZIP(cfg),
	PageCAB(cfg),
	Page7Z(cfg),
	PageTAR(cfg),
	PageJACK(cfg),
//	PageBH(cfg),
//	PageYZ1(cfg),
//	PageYZ2(Config),
	PageHKI(cfg),
	PageBGA(cfg),
	PageAISH(cfg),
	PageXACRETT(cfg),
	PageB2E(cfg),
	PageDLLUpdate(cfg),
	PageOpenAction(cfg),
	PageFileListWindow(cfg)
{
	TRACE("CConfigDialog()\n");

	//ݒǂݍ
	Config.LoadConfig(CONFIG_LOAD_ALL);
}

LRESULT CConfigDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXICON),::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);

	// ACRݒ
	HICON hIconSmall = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
	SetIcon(hIconSmall, FALSE);

	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
//	StaticFrame.ShowWindow(SW_HIDE);
	ScreenToClient(&rect);

	//XN[Reizu
	ScrollWindow.Create(m_hWnd,rect,NULL,/*WS_TABSTOP|*/WS_CHILD|WS_VISIBLE , WS_EX_CLIENTEDGE|WS_EX_CONTROLPARENT);

	//--------------------
	// c[r[̐ݒ
	//--------------------
	SelectTreeView=GetDlgItem(IDC_TREE_SELECT_PROPPAGE);

#define ADD_PAGE(_DIALOG,_ROOTITEM) {\
	_DIALOG.Create(ScrollWindow);\
	TCHAR Buffer[_MAX_PATH+1]={0};\
	_DIALOG.GetWindowText(Buffer,_MAX_PATH);\
	HTREEITEM hItem=SelectTreeView.InsertItem(Buffer, _ROOTITEM, TVI_LAST);\
	SelectTreeView.SetItemData(hItem,(DWORD)_DIALOG.m_hWnd);\
}

	//--------------------------------
	// _CAȌǉĂ
	//--------------------------------
	ADD_PAGE(PageGeneral,TVI_ROOT);
	ADD_PAGE(PageShellExt,TVI_ROOT);
	ADD_PAGE(PageShortcut,TVI_ROOT);
	ADD_PAGE(PageFileListWindow,TVI_ROOT);
	ADD_PAGE(PageCompressGeneral,TVI_ROOT);
	ADD_PAGE(PageExtractGeneral,TVI_ROOT);
	ADD_PAGE(PageAssociation,TVI_ROOT);
	ADD_PAGE(PageOpenAction,TVI_ROOT);
//	ADD_PAGE(PageAssociation2,TVI_ROOT);
	ADD_PAGE(PageDLLUpdate,TVI_ROOT);
	ADD_PAGE(PageVersion,TVI_ROOT);

	//----------------
	// ȉ͏ڍאݒ
	//----------------
	//c[̐e
	PageDetail.Create(ScrollWindow);
	HTREEITEM hItemDetail;
	{
		TCHAR Buffer[_MAX_PATH+1]={0};
		PageDetail.GetWindowText(Buffer,_MAX_PATH);
		hItemDetail=SelectTreeView.InsertItem(Buffer, TVI_ROOT, TVI_LAST);
	}
	SelectTreeView.SetItemData(hItemDetail,(DWORD)PageDetail.m_hWnd);

	ADD_PAGE(PageLZH,hItemDetail);
	ADD_PAGE(PageZIP,hItemDetail);
	ADD_PAGE(PageCAB,hItemDetail);
	ADD_PAGE(Page7Z,hItemDetail);
	ADD_PAGE(PageTAR,hItemDetail);
	ADD_PAGE(PageJACK,hItemDetail);
//	ADD_PAGE(PageBH,hItemDetail);
//	ADD_PAGE(PageYZ1,TVI_ROOT);
	ADD_PAGE(PageHKI,hItemDetail);
	ADD_PAGE(PageBGA,hItemDetail);
	ADD_PAGE(PageAISH,hItemDetail);
	ADD_PAGE(PageXACRETT,hItemDetail);
	ADD_PAGE(PageB2E,hItemDetail);

	//------------------------
	// ͂߂ɕ\y[W
	//------------------------
	PageGeneral.ShowWindow(SW_SHOW);
	ScrollWindow.SetClient(PageGeneral);
	hActiveDialogWnd=PageGeneral;
	SelectTreeView.SetFocus();

	// _CAOTCY
	DlgResize_Init(true, true, WS_THICKFRAME | WS_CLIPCHILDREN);

	//---[U[ԋʐݒ?
	if(Config.IsUserCommon()){
		//EBhE^Cgݒ
		SetWindowText(CString(MAKEINTRESOURCE(IDS_CAPTION_CONFIG_USERCOMMON)));
	}

	return TRUE;
}

void CConfigDialog::OnOK(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	//e_CAOOnApplyĂ
	bool bRet=true;
	bRet=bRet&&PageGeneral.OnApply();
	bRet=bRet&&PageShellExt.OnApply();
	bRet=bRet&&PageCompressGeneral.OnApply();
	bRet=bRet&&PageExtractGeneral.OnApply();
	bRet=bRet&&PageLZH.OnApply();
	bRet=bRet&&PageZIP.OnApply();
	bRet=bRet&&PageCAB.OnApply();
	bRet=bRet&&Page7Z.OnApply();
	bRet=bRet&&PageTAR.OnApply();
	bRet=bRet&&PageJACK.OnApply();
	bRet=bRet&&PageHKI.OnApply();
	bRet=bRet&&PageBGA.OnApply();
	bRet=bRet&&PageAISH.OnApply();
	bRet=bRet&&PageXACRETT.OnApply();
	bRet=bRet&&PageB2E.OnApply();
	bRet=bRet&&PageDLLUpdate.OnApply();
	bRet=bRet&&PageFileListWindow.OnApply();
	bRet=bRet&&PageAssociation.OnApply();
	bRet=bRet&&PageOpenAction.OnApply();

	if(bRet)EndDialog(nID);
}

void CConfigDialog::OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	EndDialog(nID);
}

LRESULT CConfigDialog::OnTreeSelect(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom==SelectTreeView){
		HTREEITEM hItem=SelectTreeView.GetSelectedItem();
		if(!hItem)return 0;

		HWND hSelectedDialogWnd=(HWND)SelectTreeView.GetItemData(hItem);
		if(NULL!=hSelectedDialogWnd && hSelectedDialogWnd!=hActiveDialogWnd){
			::ShowWindow(hActiveDialogWnd,SW_HIDE);
			::ShowWindow(hSelectedDialogWnd,SW_SHOW);
			ScrollWindow.SetClient(NULL);
			ScrollWindow.SetClient(hSelectedDialogWnd);
			hActiveDialogWnd=hSelectedDialogWnd;
		}
	}
	return 0;
}

void CConfigDialog::OnSize(UINT, CSize&)
{
	SetMsgHandled(false);
	PostMessage(WM_USER_WM_SIZE);
}

LRESULT CConfigDialog::OnUserSize(UINT, WPARAM, LPARAM, BOOL& bHandled)
{
	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
	ScreenToClient(&rect);

	//XN[Reiړ
	ScrollWindow.MoveWindow(&rect);
	return 0;
}
