#include "common.h"
#include "shellmanager.h"
#ifndef __UNINSTALLER__
#include "../resource.h"
#else //__UNINSTALLER__
#include "../uninstall/resource.h"
#endif //__UNINSTALLER__


const int CLSID_STRING_SIZE=(39 + 1);

// {713B479F-6F2B-48e9-B545-5591CCFE398F}
static const GUID CLSID_ShellExt = 
{ 0x713b479f, 0x6f2b, 0x48e9, { 0xb5, 0x45, 0x55, 0x91, 0xcc, 0xfe, 0x39, 0x8f } };

//-------------------------------------------------------------------------
// ShellRegisterServer			gVFo^
//-------------------------------------------------------------------------
bool ShellRegisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary((TCHAR*)LPCTSTR(inDllPath));
	if (theDllH < (HINSTANCE)HINSTANCE_ERROR){
		// ۰ޏo܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,_T("DllRegisterServer"));
	if(lpDllEntryPoint != NULL)	{
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}
	else{
		// DllRegisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,"DllRegisterServer");
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}

//-------------------------------------------------------------------------
// ShellUnregisterServer			gVF
//-------------------------------------------------------------------------
bool ShellUnregisterServer(HWND hWnd,LPCTSTR inDllPath)
{
	// Cu[h
	HINSTANCE theDllH = ::LoadLibrary((TCHAR*)LPCTSTR(inDllPath));
	if (theDllH < (HINSTANCE)HINSTANCE_ERROR){
		// ۰ޏo܂ł
		CString msg;
		msg.Format(IDS_ERROR_DLL_LOAD,inDllPath);
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		return false;
	}

	// Gg[|CgTĎs
	FARPROC	lpDllEntryPoint;
	(FARPROC&)lpDllEntryPoint = ::GetProcAddress(theDllH,_T("DllUnregisterServer"));
	if(lpDllEntryPoint != NULL){
		// o^
		(*lpDllEntryPoint)();
//		MessageBeep(MB_OK);
	}
	else{
		// DllUnregisterServer ܂
		CString msg;
		msg.Format(IDS_ERROR_DLL_FUNCTION_GET,inDllPath,"DllUnregisterServer");
		MessageBox(hWnd,msg,CString(MAKEINTRESOURCE(IDS_MESSAGE_CAPTION)),MB_OK|MB_ICONSTOP);
		::FreeLibrary(theDllH);
		return false;
	}
	::FreeLibrary(theDllH);
	return true;
}

/*-------------------------------------------------------------------------*/
// CLSIDtoMBCS			NXIDSJISɕϊ
/*-------------------------------------------------------------------------*/
void WINAPI CLSIDtoMBCS(REFCLSID inClsid,char* outCLSID,long inSize)
{
	WCHAR	theCLSID[CLSID_STRING_SIZE];

	// NXID𕶎ɕϊB
	StringFromGUID2(inClsid, theCLSID, sizeof(theCLSID));

	// ChSJISɕϊB
	memset(outCLSID, 0, inSize);
	WideCharToMultiByte(CP_ACP, 0, theCLSID, -1, outCLSID, inSize, NULL, NULL);
}

//-------------------------------------------------------------------------
// ShellRegistCheck		gShellݓo^Ă邩`FbN
//-------------------------------------------------------------------------
bool ShellRegistCheck()
{
	const GUID inGUID=CLSID_ShellExt;
	bool Result=false;
	// NXIDAWXgL[쐬
	char theCLSID[CLSID_STRING_SIZE];
	CLSIDtoMBCS(inGUID, theCLSID, sizeof(theCLSID));

	// L[쐬
	char theKey[MAX_PATH];
	sprintf(theKey, "CLSID\\%s", theCLSID);

	// WXgɃL[邩ǂT

	// wL[̃I[v
	HKEY theKeyChildH;
	LONG theRes = ::RegOpenKeyEx(HKEY_CLASSES_ROOT, theKey, 0, /*KEY_ALL_ACCESS*/KEY_READ, &theKeyChildH);
	if(theRes != ERROR_SUCCESS)return Result;

	// 
	char		theBuffer[256];
	DWORD		theSize = 256;
	FILETIME	theTime;
	DWORD		theIdx = 0;
	while(S_OK==::RegEnumKeyEx(theKeyChildH, theIdx, theBuffer, &theSize, NULL, NULL, NULL, &theTime)){
		if(strcmp(theBuffer,"InprocServer32") == 0)	{
			// rSI
			Result = true;
			break;
		}
		theSize = 256;
		theIdx++;
	}

	// Close the child.
	::RegCloseKey(theKeyChildH);

	return Result;
}
