#include "common.h"
#include "ExtractEx.h"
#include "../resource.h"
#include "../util.h"

//Base:fBNg
bool ExtractEx(CArchiverDLL *lpArchiver,LPCTSTR ArcFileName,CDirectoryTree *Base,std::list<CDirectoryTree*>& ItemList,LPCTSTR lpszOutputBaseDir,bool bCollapseDir)
{
	ASSERT(lpArchiver);
	if(!lpArchiver){
		return false;
	}
	//------------------------------------
	// A[JCȗ݂͊Ƀ`FbNς
	//------------------------------------

	//Xgt@CƃfBNg𕪗
	CDirectoryTree *lpFileParent=NULL;	//t@C̐e
	std::list<CString> FileList;	//t@Cp
	std::list<CDirectoryTree*> DirectoryList;	//fBNgp

	{
		std::list<CDirectoryTree*>::iterator ite=ItemList.begin();
		const std::list<CDirectoryTree*>::iterator end=ItemList.end();
		for(;ite!=end;ite++){
			CDirectoryTree* dt=*ite;
			ASSERT(dt);
			if(!dt)continue;

			if(dt->IsDirectory()){
				DirectoryList.push_back(dt);
			}
			else{
				lpFileParent=dt->GetParent();
				FileList.push_back(dt->GetFullPath());
			}
		}
	}
	ASSERT((!FileList.empty())||(!DirectoryList.empty()));

	//----------------
	// t@C
	//----------------
	if(!FileList.empty()){
		CString strOutputDir;
		if(!bCollapseDir)CDirectoryTree::GetDirPathRelative(lpFileParent,Base,strOutputDir);
		strOutputDir.Insert(0,lpszOutputBaseDir);
		lpArchiver->ExtractSpecifiedOnly(ArcFileName,strOutputDir,FileList);
	}

	//--------------------
	// fBNg
	//--------------------
	if(!DirectoryList.empty()){
		std::list<CDirectoryTree*>::iterator ite=DirectoryList.begin();
		const std::list<CDirectoryTree*>::iterator end=DirectoryList.end();
		for(;ite!=end;ite++){
			if(!ExtractSubDirectory(lpArchiver,ArcFileName,bCollapseDir?(*ite)->GetParent():Base,*ite,lpszOutputBaseDir))return false;
		}
	}
	return true;
}

bool ExtractSubDirectory(CArchiverDLL *lpArchiver,LPCTSTR ArcFileName,CDirectoryTree *Base,CDirectoryTree* Dir,LPCTSTR lpszOutputBaseDir)
{
	ASSERT(lpArchiver);
	ASSERT(Dir);
	ASSERT(Dir->IsDirectory());
	if(!lpArchiver||!Dir){
		return false;
	}
	//------------------------------------
	// A[JCȗ݂͊Ƀ`FbNς
	//------------------------------------

	//fBNgƂŕKv邩ǂ
	bool bRestoreEmptyDirectory=false;

	//fBNg̃t@C
	std::list<CString> FileList;	//t@Cp
	std::list<CDirectoryTree*> DirectoryList;	//fBNgp

	{
		//fBNgA[JCuɃGgƂēo^ĂȂo͂
		//->L:o͐ƌ
//		if(_tcslen(Dir->GetFullName())>0){
//			FileList.push_back(Dir->GetFullName());
//		}
		std::vector<CDirectoryTree*>::iterator ite=Dir->GetIterator(true);
		const std::vector<CDirectoryTree*>::iterator end=Dir->GetIterator(false);
		for(;ite!=end;ite++){
			CDirectoryTree* dt=*ite;

			ASSERT(dt);
			if(!dt)continue;

			if(dt->IsDirectory()){
				DirectoryList.push_back(dt);
			}
			else{
				FileList.push_back(dt->GetFullPath());
			}
		}
		if(FileList.empty()&&DirectoryList.empty()){
			//tH_ꍇ
			if(_tcslen(Dir->GetFullPath())<=0){
				//tpXȂ:A[JCuɂ݂͑ȂtH_
				TRACE("Nothing to Extract\n");
				return true;
			}
			else{
				bRestoreEmptyDirectory=true;
			}
		}
		else{
			bRestoreEmptyDirectory=false;
		}
	}

	//--------------------------------------
	// Cꂽo̓fBNgpXZo
	//--------------------------------------
	CString strOutputDir;
	CDirectoryTree::GetDirPathRelative(Dir,Base,strOutputDir);

	//o̓fBNgƌ
	strOutputDir.Insert(0,lpszOutputBaseDir);

	if(strOutputDir.GetLength()>_MAX_PATH){
		//tH_Ȃ肷
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH)));
		return false;
	}
	//----------------------------
	// fBNgGg̍Č
	//----------------------------
	TRACE("OutputDir=%s\n",strOutputDir);
	if(bRestoreEmptyDirectory){
		//fBNgGgƂŕKv
		//fBNg쐬
		TRACE("Created by MakeSureDirectoryPathExists()\n");
		if(!MakeSureDirectoryPathExists(strOutputDir)){
			CString msg;
			msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,strOutputDir);
			ErrorMessage(msg);
			return false;
		}
	}

	//----------------
	// t@C
	//----------------
	if(!FileList.empty()){
		if(!lpArchiver->ExtractSpecifiedOnly(ArcFileName,strOutputDir,FileList))return false;
	}

	//--------------------
	// fBNg
	//--------------------
	if(!DirectoryList.empty()){
		std::list<CDirectoryTree*>::iterator ite=DirectoryList.begin();
		const std::list<CDirectoryTree*>::iterator end=DirectoryList.end();
		for(;ite!=end;ite++){
			if(!ExtractSubDirectory(lpArchiver,ArcFileName,Base,*ite,lpszOutputBaseDir))return false;
		}
	}
	return true;
}
