#include "common.h"
#include "DnD.h"
#include "../../util.h"

bool COLEDnDSource::DragDrop(LPCTSTR ArcFileName,CArchiverDLL *Archiver,std::list<CDirectoryTree*> &ItemList,CDirectoryTree *Base)
{
	if(!r_TempDirManager.ClearSubDir()){
		//e|fBNgɏoȂ
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_CANT_CLEAR_TEMPDIR)));
		return false;
	}

	HANDLE		hObject = NULL;
	FORMATETC	fmt;
	STGMEDIUM	medium;
	DWORD		dwEffect;
	int	ret;
	CDropSource *lpDropSource;
	std::list<CString> FileNameList;

	//DnDΏۃt@C擾
	for(std::list<CDirectoryTree*>::iterator ite=ItemList.begin();ItemList.end()!=ite;ite++){
		CString Buffer=(*ite)->GetName();

		//Kw\𖳎ꗗ̎́ÃR[hŃpXׂăJbg
		Buffer.Replace(_T('/'),_T('\\'));
		if(-1!=Buffer.Find(_T('\\'))){
			//fBNgm[h̖OɃpX؂蕶̂́AKw\𖳎ꗗ̎̂݁B
			//̂Ƃ́ApX؂S΂KvB
			PathStripPath(Buffer.GetBuffer(_MAX_PATH+1));	//ԍŌ̕cāApXJbg
			Buffer.ReleaseBuffer();
			Buffer.Remove(_T('\\'));	//pX؂蕶폜
		}

		Buffer.Insert(0,r_TempDirManager.GetDirPath());
		TRACE("DnD::%s\n",Buffer);
		FileNameList.push_back(Buffer);
	}

	//CDataObject쐬CF_HDROP`̃f[^o^
	CDataObject *lpDataObject = new CDataObject();
	if(!lpDataObject)goto error;
	if(!lpDataObject->allocate(2))goto error;

	//**********************************************************************************
	//* NTnWindows̏ꍇ͎̍sFALSETRUEɂUNICODEłHDROPĂ *
	//**********************************************************************************
	if((hObject = CreateHDrop(FileNameList, UtilIsWindowsNT())) == NULL)goto error;
	CreateMedium(CF_HDROP, hObject, &fmt, &medium);

	if(lpDataObject->SetData(&fmt, &medium, TRUE) != S_OK)goto error;	 //DataObjectɔC

	hObject = NULL;

	lpDropSource = new CDropSource(ItemList,r_TempDirManager.GetDirPath(),Archiver,ArcFileName,Base);
	if(!lpDropSource)goto error;

	ret = DoDragDrop(lpDataObject, lpDropSource, DROPEFFECT_COPY,&dwEffect);
	if(DRAGDROP_S_DROP!=ret&&ret!=DRAGDROP_S_CANCEL){
		//DnDɎs
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_DND_FAILED)));
	}

	//̂ō폜
	//:Windows98ł͂̃^C~Oō폜ƃt@CꂸɃG[ƂȂ
//	UtilDeleteDir(OutputDir);


error:
	if(lpDropSource)lpDropSource->Release();
	if(lpDataObject)lpDataObject->Release();
	if(hObject)GlobalFree(hObject);
	return true;
}

void COLEDnDSource::CreateMedium(CLIPFORMAT cfFormat, HANDLE hObject, FORMATETC *pFormatetc, STGMEDIUM *pmedium)
{
	pFormatetc->cfFormat = cfFormat;
	pFormatetc->dwAspect = DVASPECT_CONTENT;
	pFormatetc->lindex = -1;
	pFormatetc->ptd = NULL;
	pFormatetc->tymed = TYMED_HGLOBAL;

	pmedium->hGlobal = hObject;
	pmedium->tymed = TYMED_HGLOBAL;
	pmedium->pUnkForRelease = NULL;
}

HDROP COLEDnDSource::CreateHDrop(std::list<CString> &FileList, bool fWide)
{
	LPDROPFILES lpDropFile;
	int	wtotal, btotal, wlen;

	std::list<CString>::iterator ite=FileList.begin();
	const std::list<CString>::iterator end=FileList.end();
	//obt@̌vZ
	if(fWide){
		// ChL
		wtotal = 0;
		for(;ite!=end;ite++){
			wtotal += ::MultiByteToWideChar(CP_ACP, 0, *ite, -1, NULL, 0);
		}
		btotal = wtotal * sizeof(wchar_t);
	}else{
		// }`oCg
		btotal = 0;
		for(;ite!=end;ite++){
			btotal += (*ite).GetLength() + 1;
		}
	}

	HDROP hDrop = (HDROP)::GlobalAlloc(GHND,sizeof(DROPFILES) + btotal + 2); //Wide̎lā{Q
	if(!hDrop){
		return NULL;
	}

	lpDropFile = (LPDROPFILES)::GlobalLock(hDrop);
	lpDropFile->pFiles = sizeof(DROPFILES);		// t@C̃Xg܂ł̃ItZbg
	lpDropFile->pt.x = 0;
	lpDropFile->pt.y = 0;
	lpDropFile->fNC = FALSE;
	lpDropFile->fWide = fWide;					// ChL̏ꍇ TRUE

	// \̂̌Ƀt@C̃XgRs[B(t@C\0t@C\0t@C\0\0\0)
	if(fWide){
		// ChL
		wchar_t *buf;

		buf = (wchar_t *)(&lpDropFile[1]);
		for(ite=FileList.begin();ite!=end;ite++){
			wlen = ::MultiByteToWideChar(CP_ACP, 0, *ite, -1, buf, wtotal);
			wtotal -= wlen;
			buf += wlen;
		}
		*buf = 0;
	}else{
		// }`oCg
		char *buf;

		buf = (char *)(&lpDropFile[1]);
		for(ite=FileList.begin();ite!=end;ite++){
			::lstrcpy(buf,*ite);
			buf += (*ite).GetLength() + 1;
		}
		*buf++ = 0;
		*buf = 0;
	}

	::GlobalUnlock(hDrop);

	return	hDrop;
}
