#include "common.h"
#include "TemporaryDirMgr.h"

#include "util.h"

CTemporaryDirectoryManager::CTemporaryDirectoryManager(LPCTSTR lpszPrefix)
	:m_strPrefix(lpszPrefix)
{
	Prepare();
}

CTemporaryDirectoryManager::~CTemporaryDirectoryManager()
{
	Finish();
}

//ꎞo̓tH_m
void CTemporaryDirectoryManager::Prepare()
{
	Finish();
	//%TEMP%\%prefix%0000\filename...
	TCHAR TempPath[_MAX_PATH+1];
	FILL_ZERO(TempPath);
	GetTempPath(_MAX_PATH,TempPath);

	int Count=0;
	while(true){	//ꎞ𓀐m
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		_tcsncpy(Buffer,TempPath,_MAX_PATH);
		CString Name;
		Name.Format(_T("%s%d"),m_strPrefix,Count);
		Count++;

		//݃`FbN
		PathAppend(Buffer,Name);
//		TRACE("%s\n",Buffer);
		if(!PathFileExists(Buffer)){
			PathAddBackslash(Buffer);
			if(!PathIsDirectory(Buffer)){
				if(MakeSureDirectoryPathExists(Buffer)){
					m_strDirPath=Buffer;
					break;
				}
			}
		}
	}
}

bool CTemporaryDirectoryManager::Finish()
{
	//e|fBNg폜(efBNg܂߂)

	if(m_strDirPath.IsEmpty())return false;
	
	//tH_
	if(!UtilDeleteDir(m_strDirPath,true))return false;

	//tH_NA
	m_strDirPath.Empty();
	return true;
}

bool CTemporaryDirectoryManager::ClearSubDir()
{
	//e|fBNg̓e폜(TufBNgê)
	if(m_strDirPath.IsEmpty())return false;

	//g̍폜Ɏs
	if(!UtilDeleteDir(m_strDirPath,false)){
		if(!PathIsDirectory(m_strDirPath)){
			//ΏۃfBNg݂ĂȂ΁AmۂĂ
			if(MakeSureDirectoryPathExists(m_strDirPath))return true;
		}
		return false;
	}
	return true;
}

LPCTSTR CTemporaryDirectoryManager::GetDirPath()
{
	if(m_strDirPath.IsEmpty())return NULL;
	return m_strDirPath;
}

bool CTemporaryDirectoryManager::DeleteAllTemporaryDir(LPCTSTR lpszPrefix)
{
	//%TEMP%\%prefix%0000\filename...
	TCHAR TempPath[_MAX_PATH+1];
	FILL_ZERO(TempPath);
	GetTempPath(_MAX_PATH,TempPath);
	{
		CString strTemp(lpszPrefix);
		strTemp+=_T("*");
		PathAppend(TempPath,strTemp);
	}

	//
	const TCHAR DigitArray[]=_T("0123456789");
	const int DigitArrayLength=sizeof(DigitArray)/sizeof(DigitArray[0]);

	//e|fBNgT
	CFindFile cFindFile;

	BOOL bContinue=cFindFile.FindFile(TempPath);

	bool bRet=true;
	while(bContinue){
		if(cFindFile.IsDirectory()){
			//prefix̌オ݂̂Ȃ폜
			CString strDirName(cFindFile.GetFileName());
			strDirName.Delete(0,_tcslen(lpszPrefix));
			if(!strDirName.IsEmpty()){
				for(int i=0;i<DigitArrayLength;i++){
					strDirName.Remove(DigitArray[i]);
				}

				//폜
				if(strDirName.IsEmpty()){
					bRet=bRet&&UtilDeleteDir(cFindFile.GetFilePath(),true);
				}
			}
		}
		bContinue=cFindFile.FindNextFile();
	}
	return bRet;
}
