#include "common.h"
#include "ArchiverManager.h"
#include "util.h"
#include "ConfigCode/config.h"

//gq𓀂ɎgDLL𐄒
DLL_ID GuessDllIDFromFileName(LPCTSTR ArcFileName,CConfigManager &Config)
{
	TRACE("GuessDllIDFromFileName()\n");
	TRACE("ArcFileName=%s\n",ArcFileName);

	//---B2EXacRettD悷ꍇ
	if(Config.B2E.EnableDLL&&Config.B2E.Priority){
		//B2EɗD悷gq̊mF
		if(UtilPathAcceptSpec(ArcFileName,CString(),Config.B2E.Extensions,false))return DLL_ID_B2E;

		//XacRettɗD悷gq̊mF
		if(Config.XACRETT.EnableDLL){
			if(UtilPathAcceptSpec(ArcFileName,CString(),Config.XACRETT.Extensions,false))return DLL_ID_XACRETT;
		}
	}else{
		//---XacRettB2ED
		//XacRettɗD悷gq̊mF
		if(Config.XACRETT.EnableDLL){
			if(UtilPathAcceptSpec(ArcFileName,CString(),Config.XACRETT.Extensions,false))return DLL_ID_XACRETT;
		}
		//B2EɗD悷gq̊mF
		if(Config.B2E.EnableDLL){
			if(UtilPathAcceptSpec(ArcFileName,CString(),Config.B2E.Extensions,false))return DLL_ID_B2E;
		}
	}

	//gq
	CString strExt=PathFindExtension(ArcFileName);
	strExt.MakeLower();
//	TRACE("strExt=%s\n",strExt);

	//Qƕ\gqr
	for(int i=0;i<ARRAY_EXT_DLLID_COUNT;i++){
		if(Array_ExtDLLID[i].lpszExt==strExt){
			return Array_ExtDLLID[i].DllID;
		}
	}
	return DLL_ID_UNKNOWN;
}

//k^CvDLLID擾
DLL_ID GetDllIDFromParameterType(PARAMETER_TYPE Type)
{
	//Qƕ\獇vPARAMETER_TYPE擾
	for(int i=0;i<ARRAY_PARAMETERTYPE_DLLID_COUNT;i++){
		if(Array_ParameterTypeDLLID[i].ParameterType==Type){
			return Array_ParameterTypeDLLID[i].DllID;
		}
	}
	ASSERT(!"");
	return DLL_ID_UNKNOWN;
}


//---------------------
#define PAIR_DLL_ITEM(name)		std::pair<CArchiverDLL*,DLL_ID>(&Arc##name,DLL_ID_##name)	
CArchiverDLLManager::CArchiverDLLManager()
	:m_lpConfig(NULL)
{
	TRACE("ArchiverDLLManager()\n");
	ArchiverList.push_back(PAIR_DLL_ITEM(TAR));
	ArchiverList.push_back(PAIR_DLL_ITEM(JACK));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNLHA));
	ArchiverList.push_back(PAIR_DLL_ITEM(7ZIP));
	ArchiverList.push_back(PAIR_DLL_ITEM(CAB));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNARJ));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNGCA));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNRAR));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNACE));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNIMP));
//	ArchiverList.push_back(PAIR_DLL_ITEM(BH));		p~
	ArchiverList.push_back(PAIR_DLL_ITEM(YZ1));
//	ArchiverList.push_back(PAIR_DLL_ITEM(PMA));		p~
	ArchiverList.push_back(PAIR_DLL_ITEM(UNHKI));
	ArchiverList.push_back(PAIR_DLL_ITEM(BGA));
	ArchiverList.push_back(PAIR_DLL_ITEM(AISH));
	ArchiverList.push_back(PAIR_DLL_ITEM(UNBEL));
	ArchiverList.push_back(PAIR_DLL_ITEM(XACRETT));
	ArchiverList.push_back(PAIR_DLL_ITEM(B2E));

}

CArchiverDLLManager::~CArchiverDLLManager()
{
	TRACE("~CArchiverDLLManager()\n");
	Final();
}

void CArchiverDLLManager::Final()
{
	//SNA
	TRACE("Freeing dlls...\n");

	Free();
	ArchiverList.clear();
}

void CArchiverDLLManager::Free()
{
	//SJ
	if(ArchiverList.empty())return;
//	std::list<CArchiverDLL*>::iterator ite;
	std::list<std::pair<CArchiverDLL*,DLL_ID> >::iterator ite;
	for(ite=ArchiverList.begin();ite!=ArchiverList.end();ite++){
		(*ite).first->FreeDLL();
	}
}

CArchiverDLL* CArchiverDLLManager::GetArchiver(LPCTSTR ArcFileName,DLL_ID ForceDLL)
{
	ASSERT(m_lpConfig);
	if(!m_lpConfig)return NULL;
	TRACE("CArchiverDLLManager::GetArchiver(LPCTSTR)\n");

	//-----gpDLLw肳Ă
	if(DLL_ID_UNKNOWN!=ForceDLL){
		CArchiverDLL* Archiver=GetArchiver(ForceDLL);	//[hłȂƂɂ̓G[bZ[W
		if(Archiver){
			if(!Archiver->IsOK()){
				Archiver->LoadDLL(*m_lpConfig,true);
			}
			if(Archiver->IsOK()){
				if(Archiver->CheckArchive(ArcFileName)){
					return Archiver;
				}
			}
		}
		return NULL;
	}

	//gqڐ
	DLL_ID Type=GuessDllIDFromFileName(ArcFileName,*m_lpConfig);
	CArchiverDLL* lpGuessedArchiver=GetArchiver(Type,true);
	TRACE("ς݃A[JCoǂ`FbN\n");
	if(lpGuessedArchiver){
		if(!lpGuessedArchiver->IsOK()){
			lpGuessedArchiver->LoadDLL(*m_lpConfig,true);
		}
		if(lpGuessedArchiver->IsOK()){
			if(lpGuessedArchiver->CheckArchive(ArcFileName)){
				TRACE("͓Ă\n");
				return lpGuessedArchiver;
			}
		}
	}
	TRACE("ɂ鐄Jn\n");
	std::list<std::pair<CArchiverDLL*,DLL_ID> >::iterator ite;
	for(ite=ArchiverList.begin();ite!=ArchiverList.end();ite++){
		CArchiverDLL* lpArchiver=(*ite).first;

		ASSERT(lpArchiver);

		if(&ArcXACRETT==lpArchiver){	//XacRett̎gpĂꍇ̂݃[h
			if(!m_lpConfig->XACRETT.EnableDLL)continue;
		}
		else if(&ArcB2E==lpArchiver){	//B2E̎gpĂꍇ̂݃[h
			if(!m_lpConfig->B2E.EnableDLL)continue;
		}
		if(lpGuessedArchiver==lpArchiver)continue;	//ɓKȂƂĂ
		if(!lpArchiver->IsOK()){
			lpArchiver->LoadDLL(*m_lpConfig,true);
		}
		if(lpArchiver->IsWeakCheckArchive()){
			continue;	//tH[}bg`FbNÂ̂łĂɂȂȂ
		}
		if(lpArchiver->IsOK()&&lpArchiver->CheckArchive(ArcFileName)){
			return lpArchiver;	//A[JCunh
		}
	}
	TRACE("DLLɎs\n");
	return NULL;
}

CArchiverDLL* CArchiverDLLManager::GetArchiver(DLL_ID Type,bool bSilent,bool bIgnoreError)
{
	TRACE("CArchiverDLLManager::GetArchiver(DLL_ID)\n");
	ASSERT(m_lpConfig);
	if(!m_lpConfig)return NULL;

	CArchiverDLL* lpArchiver=NULL;
	std::list<std::pair<CArchiverDLL*,DLL_ID> >::iterator ite;
	for(ite=ArchiverList.begin();ite!=ArchiverList.end();ite++){
		if((*ite).second==Type){
			lpArchiver=(*ite).first;
			break;
		}
	}

//	ASSERT(lpArchiver);

	if(lpArchiver){
		if(!lpArchiver->IsOK()){
			lpArchiver->LoadDLL(*m_lpConfig,bSilent);
		}
		if(bIgnoreError||lpArchiver->IsOK()){
			return lpArchiver;
		}
	}
	TRACE("DLLnh擾Ɏs\n");
	return NULL;
}

CArchiverB2E& CArchiverDLLManager::GetB2EHandler()
{
	if(!ArcB2E.IsOK()){
		ArcB2E.LoadDLL(*m_lpConfig,true);
	}
	return ArcB2E;
}

