#pragma once
#include "util.h"
#include "ConfigCode/config.h"
#include "ArchiverCode/arc_interface.h"

//A[JCut@C
bool GetArchiveName(CString &,std::list<CString> &,const PARAMETER_TYPE,const int,CConfigManager &,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir);
//A[JCuΏۃt@C܂Ƃ߂fBNgpX擾
void GetBaseDirectory(CString &,std::list<CString> &);

//kΏۂ̃t@CT;߂l
//0:t@C͊܂܂ĂȂ
//1:Pt@Ĉ݂܂܂Ă
//2:t@C܂܂Ă
int CountFileToCompress(LPCTSTR Path,CString &);

//ksBɂ͕KtpXn
bool Compress(std::list<CString>&,const PARAMETER_TYPE,CConfigManager&,const int,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir);

//B2EpĈksBɂ͕KtpXn
bool B2ECompress(std::list<CString> &ParamList,CConfigManager &Config,LPCTSTR lpszSpecificOutputFileName,LPCTSTR lpszSpecificOutputDir,LPCTSTR lpszFormat,LPCTSTR lpszMethod,bool bSFX);

const LPCTSTR LHAFORGE_COMPRESS_SEMAPHORE_NAME=_T("LhaForgeCompressLimitSemaphore");

//R}hCp[^Compressɓnp[^̑Ή\
const struct COMPRESS_COMMANDLINE_PARAMETER{
	LPCTSTR Param;
	LPCTSTR Ext;
	PARAMETER_TYPE Type;
	int Options;
	WORD FormatName;
}CompressParameterArray[]={
	{_T("/c:lzh"),		_T(".lzh"),	PARAMETER_LZH,		0					,IDS_FORMAT_NAME_LZH},
	{_T("/c:lzhsfx"),	_T(".exe"),	PARAMETER_LZH,		COMPRESS_SFX		,IDS_FORMAT_NAME_LZH_SFX},
	{_T("/c:zip"),		_T(".zip"),	PARAMETER_ZIP,		0					,IDS_FORMAT_NAME_ZIP},
	{_T("/c:zippass"),	_T(".zip"),	PARAMETER_ZIP,		COMPRESS_PASSWORD	,IDS_FORMAT_NAME_ZIP_PASS},
	{_T("/c:zipsfx"),	_T(".exe"),	PARAMETER_ZIP,		COMPRESS_SFX		,IDS_FORMAT_NAME_ZIP_SFX},
	{_T("/c:zippasssfx"),_T(".exe"),PARAMETER_ZIP,		COMPRESS_PASSWORD|COMPRESS_SFX,IDS_FORMAT_NAME_ZIP_PASS_SFX},
	{_T("/c:zipsplit"),	_T(".zip"),	PARAMETER_ZIP,		COMPRESS_SPLIT		,IDS_FORMAT_NAME_ZIP_SPLIT},
	{_T("/c:zippasssplit"),_T(".zip"),PARAMETER_ZIP,	COMPRESS_PASSWORD|COMPRESS_SPLIT,IDS_FORMAT_NAME_ZIP_PASS_SPLIT},
	{_T("/c:cab"),		_T(".cab"),	PARAMETER_CAB,		0					,IDS_FORMAT_NAME_CAB},
	{_T("/c:cabsfx"),	_T(".exe"),	PARAMETER_CAB,		COMPRESS_SFX		,IDS_FORMAT_NAME_CAB_SFX},
	{_T("/c:7z"),		_T(".7z"),	PARAMETER_7Z,		0					,IDS_FORMAT_NAME_7Z},
	{_T("/c:7zpass"),	_T(".7z"),	PARAMETER_7Z,		COMPRESS_PASSWORD	,IDS_FORMAT_NAME_7Z_PASS},
	{_T("/c:7zsfx"),	_T(".exe"),	PARAMETER_7Z,		COMPRESS_SFX		,IDS_FORMAT_NAME_7Z_SFX},
	{_T("/c:7zsplit"),	_T(".7z"),	PARAMETER_7Z,		COMPRESS_SPLIT		,IDS_FORMAT_NAME_7Z_SPLIT},
	{_T("/c:7zpasssplit"),_T(".7z"),PARAMETER_7Z,		COMPRESS_PASSWORD|COMPRESS_SPLIT,IDS_FORMAT_NAME_7Z_PASS_SPLIT},
	{_T("/c:tar"),		_T(".tar"),	PARAMETER_TAR,		0					,IDS_FORMAT_NAME_TAR},
	{_T("/c:gz"),		_T(".gz"),	PARAMETER_GZ,		0					,IDS_FORMAT_NAME_GZ},
	{_T("/c:bz2"),		_T(".bz2"),	PARAMETER_BZ2,		0					,IDS_FORMAT_NAME_BZ2},
	{_T("/c:tgz"),		_T(".tgz"),	PARAMETER_TAR_GZ,	0					,IDS_FORMAT_NAME_TGZ},
	{_T("/c:tbz"),		_T(".tbz"),	PARAMETER_TAR_BZ2,	0					,IDS_FORMAT_NAME_TBZ},
	{_T("/c:jak"),		_T(".jak"),	PARAMETER_JACK,		0					,IDS_FORMAT_NAME_JACK},
	{_T("/c:jaksfx"),	_T(".exe"),	PARAMETER_JACK,		COMPRESS_SFX		,IDS_FORMAT_NAME_JACK_SFX},
//	{_T("/c:bh"),		_T(".bh"),	PARAMETER_BH,		0					,IDS_FORMAT_NAME_BH},
//	{_T("/c:bhsfx"),	_T(".exe"),	PARAMETER_BH,		COMPRESS_SFX		,IDS_FORMAT_NAME_BH_SFX},
//	{_T("/c:bhpass"),	_T(".bh"),	PARAMETER_BH,		COMPRESS_PASSWORD	,IDS_FORMAT_NAME_BH_PASS},
//	{_T("/c:bhpasssfx"),_T(".exe"),	PARAMETER_BH,		COMPRESS_PASSWORD|COMPRESS_SFX,IDS_FORMAT_NAME_BH_PASS_SFX},
	{_T("/c:yz1"),		_T(".yz1"),	PARAMETER_YZ1,		0					,IDS_FORMAT_NAME_YZ1},
	{_T("/c:yz1sfx"),	_T(".exe"),	PARAMETER_YZ1,		COMPRESS_SFX		,IDS_FORMAT_NAME_YZ1_SFX},
	{_T("/c:yz1pass"),	_T(".yz1"),	PARAMETER_YZ1,		COMPRESS_PASSWORD	,IDS_FORMAT_NAME_YZ1_PASS},
	{_T("/c:yz1passsfx"),_T(".exe"),PARAMETER_YZ1,		COMPRESS_PASSWORD|COMPRESS_SFX,IDS_FORMAT_NAME_YZ1_PASS_SFX},
	{_T("/c:yz1pubpass"),_T(".yz1"),PARAMETER_YZ1,		COMPRESS_PUBLIC_PASSWORD,IDS_FORMAT_NAME_YZ1_PUB_PASS},
	{_T("/c:yz1pubpasssfx"),_T(".exe"),PARAMETER_YZ1,	COMPRESS_PUBLIC_PASSWORD|COMPRESS_SFX,IDS_FORMAT_NAME_YZ1_PUB_PASS_SFX},
	{_T("/c:hki"),		_T(".hki"),	PARAMETER_HKI,		0					,IDS_FORMAT_NAME_HKI},
	{_T("/c:hkipass"),	_T(".hki"),	PARAMETER_HKI,		COMPRESS_PASSWORD	,IDS_FORMAT_NAME_HKI_PASS},
	{_T("/c:hkisfx"),	_T(".exe"),	PARAMETER_HKI,		COMPRESS_SFX		,IDS_FORMAT_NAME_HKI_SFX},
//	{_T("/c:hkipasssfx"),_T(".exe"),PARAMETER_HKI,		COMPRESS_PASSWORD|COMPRESS_SFX,IDS_FORMAT_NAME_HKI}, Not Supported by WinHKI v 1.61
	{_T("/c:bza"),		_T(".bza"),	PARAMETER_BZA,		0					,IDS_FORMAT_NAME_BZA},
	{_T("/c:bzasfx"),	_T(".exe"),	PARAMETER_BZA,		COMPRESS_SFX		,IDS_FORMAT_NAME_BZA_SFX},
	{_T("/c:gza"),		_T(".gza"),	PARAMETER_GZA,		0					,IDS_FORMAT_NAME_GZA},
	{_T("/c:gzasfx"),	_T(".exe"),	PARAMETER_GZA,		COMPRESS_SFX		,IDS_FORMAT_NAME_GZA_SFX},
	{_T("/c:ish"),		_T(".ish"),	PARAMETER_ISH,		0					,IDS_FORMAT_NAME_ISH},
	{_T("/c:uue"),		_T(".uue"),	PARAMETER_UUE,		0					,IDS_FORMAT_NAME_UUE},

//---B2Ëׂ̓ʈ
	{_T(""),			_T(".archive"),	PARAMETER_B2E,	0					,0},
	{_T(""),			_T(".exe"),	PARAMETER_B2E,		COMPRESS_SFX		,0},
};
const int COMPRESS_PARAM_COUNT=sizeof(CompressParameterArray)/sizeof(COMPRESS_COMMANDLINE_PARAMETER);

