#include "common.h"
#include "extract.h"
#include "util.h"
#include "ArchiverManager.h"
#include "resource.h"
#include "ConfigCode/config.h"
#include "Semaphore.h"

bool Extract(std::list<CString> &ParamList,CConfigManager &Config,DLL_ID ForceDLL,LPCTSTR lpSpecificOutputDir)
{
	TRACE("Function ::Extract() started.\n");
	CArchiverDLLManager &ArchiverManager=CArchiverDLLManager::GetInstance();
	Config.LoadConfig(CONFIG_COMMON);
	Config.LoadConfig(CONFIG_XACRETT);
	Config.LoadConfig(CONFIG_B2E);
	CString strOutputDir;	//𓀂t@C̏o͐

	//Z}tHɂr
	CSemaphoreLocker SemaphoreLock;
	if(Config.Common.Extract.LimitExtractFileCount){
		SemaphoreLock.Lock(LHAFORGE_EXTRACT_SEMAPHORE_NAME,Config.Common.Extract.MaxExtractFileCount);
	}

	//𓀏
	std::list<CString>::iterator ite_param;
	for(ite_param=ParamList.begin();ite_param!=ParamList.end();ite_param++){
		//A[JConh擾
		CArchiverDLL *lpArchiver=ArchiverManager.GetArchiver(*ite_param,ForceDLL);

		if(!lpArchiver){
			//ΉnhȂꍇAbZ[W\Ď̃t@Cɐi
			CString msg;
			msg.Format(IDS_ERROR_ILLEGAL_HANDLER,*ite_param);
			ErrorMessage(msg);
			continue;
		}

		//o͐ƂăJgfBNgݒ

		//SȃA[JCuǂA
		//dɃtH_Ȃ悤AɃtH_Kvǂ𔻒肷
		bool bInFolder,bSafeArchive;
		bool bSkipDirCheck=(CREATE_OUTPUT_DIR_SINGLE!=Config.Common.Extract.CreateDir);

		CString BaseDir;	//dtH_`FbN̂ƂɓASẴt@CtH_̖O()
		if(!lpArchiver->ExamineArchive(*ite_param,bSkipDirCheck,bInFolder,bSafeArchive,BaseDir)){
			bInFolder=false;
			bSafeArchive=false;
		}

		//A[JCũt@CEtH_̐𒲂ׂ
		int ItemCount=-1;
		if(Config.Common.Extract.CreateNoFolderIfSingleFileOnly){
			//ut@CEtH_̎tH_쐬Ȃvݒ̎ɂ̂ݒ
			ItemCount=lpArchiver->GetFileCount(*ite_param);
		}

		CString strOpenDir;	//𓀐JƂAۂɊJpX
		bool bRet=false;
		{
			bool bUseRest=false;
			if(!GetAndSetExtractToDir(*ite_param,Config,lpSpecificOutputDir,bInFolder,strOutputDir,ItemCount,BaseDir,strOpenDir,bUseRest))return false;
			if(bUseRest){
				lpSpecificOutputDir=strOutputDir;
			}

			TRACE("Archive Handler Ăяo\n");
			//------------
			// 𓀂s
			//------------
			bRet=lpArchiver->Extract(*ite_param,Config,bSafeArchive,strOutputDir);
		}

		//o͐tH_J
		if(Config.Common.Extract.OpenDir){
			if(!Config.Common.Filer.UseFiler){
				//ExplorerŊJ
				TCHAR ExplorerPath[_MAX_PATH+1];
				FILL_ZERO(ExplorerPath);
				GetWindowsDirectory(ExplorerPath,_MAX_PATH);
				PathAppend(ExplorerPath,_T("Explorer.exe"));
				ShellExecute(NULL, _T("open"), ExplorerPath, strOpenDir, NULL, SW_SHOWNORMAL);
			}
			else{
				CString Param=Config.Common.Filer.Param;
				Param.Replace(_T("{dir}"),strOpenDir);
				ShellExecute(NULL, _T("open"), Config.Common.Filer.FilerPath,Param, NULL, SW_SHOWNORMAL);
			}
		}

		//ɉ𓀂łkt@C폜orݔɈړ
		if(bRet&&Config.Common.Extract.DeleteArchiveAfterExtract){
			if(lpArchiver->IsWeakErrorCheck()){
				//G[`FbN@\nȂ߁A𓀎sɂƔfĂ܂悤
				//DLLgƂɂ͍폜Ȃ
				MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_MESSAGE_EXTRACT_DELETE_SKIPPED)),UtilGetMessageCaption(),MB_OK|MB_ICONINFORMATION);
			}
			else{
				//폜
				if(Config.Common.Extract.MoveToRecycleBin){
					//--------------
					// ݔɈړ
					//--------------
					if(Config.Common.Extract.DeleteNoConfirm){
						//mFɍ폜
						UtilMoveFileToRecycleBin(*ite_param);
					}
					else{
						CString Message;
						Message.Format(IDS_ASK_MOVE_ARCHIVE_TO_RECYCLE_BIN,*ite_param);
						if(IDYES==MessageBox(NULL,Message,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)){
							UtilMoveFileToRecycleBin(*ite_param);
						}
					}
				}
				else{
					//------
					// 폜
					//------
					if(Config.Common.Extract.DeleteNoConfirm){
						//mFɍ폜
						DeleteFile(*ite_param);
					}
					else{
						CString Message;
						Message.Format(IDS_ASK_DELETE_ARCHIVE,*ite_param);
						if(IDYES==MessageBox(NULL,Message,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)){
							DeleteFile(*ite_param);
						}
					}
				}
			}
		}
	}

	TRACE("Exit Extract()\n");
	return true;
}


/*************************************************************
o͐tH_肵AJgfBNgɐݒ肷B
o͐tH_dɍ쐬Ȃ悤AbInFolderłׂ
tH_ɓĂ邩ǂmF

 o͐tH_pX̒_MAX_PATH𒴂Ă܂
ꍇɂ́At@C|̃bZ[WoAfalseԂB
*************************************************************/
bool GetAndSetExtractToDir(LPCTSTR ArcFileName,CConfigManager &Config,LPCTSTR lpSpecificOutputDir,bool bInFolder,CString &retOutputDir,const int ItemCount,LPCTSTR BaseDir,CString &retOpenDir,bool &bUseRest/*ȍ~̃tH_ɉ𓀂ȂtrueԂ*/)
{
	CString OutputDir;

	if(NULL!=lpSpecificOutputDir&&0!=_tcslen(lpSpecificOutputDir)){
		//fBNgo͐ƂĎw肳Ăꍇ
		OutputDir=lpSpecificOutputDir;
		TRACE("OutputDir Specified:%s\n",OutputDir);
	}
	else{
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		//ݒ肩ǂݍޏꍇ
		switch(Config.Common.Extract.OutputDirType){
		case EXTRACT_TO_DESKTOP:	//Desktop
			if(!SHGetSpecialFolderPath(NULL,Buffer,CSIDL_DESKTOPDIRECTORY,FALSE)){
				ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
				return false;
			}
			OutputDir=Buffer;
			break;
		case EXTRACT_TO_SAME_DIR:	//Same Directory
			_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
			PathRemoveFileSpec(Buffer);
			OutputDir=Buffer;
			break;
		case EXTRACT_TO_SPECIFIC_DIR:	//Specific Directory
			TRACE("Specific Dir:%s\n",Config.Common.Extract.OutputDir);
			if(0>=_tcslen(Config.Common.Extract.OutputDir)){
				//o͐悪ĂȂ΁AfXNgbvɏo͂
				if(!SHGetSpecialFolderPath(NULL,Buffer,CSIDL_DESKTOPDIRECTORY,FALSE)){
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_GET_DESKTOP)));
					return false;
				}
				OutputDir=Buffer;
			}
			else{
				OutputDir=Config.Common.Extract.OutputDir;
			}
			break;
		case EXTRACT_TO_ALWAYS_ASK_WHERE:	//o͐𖈉񕷂
			TRACE("Always ask\n");
			{
				CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER_WITH_SHIFT));
				CFolderDialog dlg(NULL,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
				if(IDOK==dlg.DoModal()){
					bUseRest=(GetKeyState(VK_SHIFT)<0);
					OutputDir=dlg.GetFolderPath();
				}
				else{
					return false;
				}
			}
			break;
		default:	//ɂ͗Ȃ͂GɃ`FbNς
			return false;
		}
	}

	PathAddBackslash(OutputDir.GetBuffer(_MAX_PATH+1));
	OutputDir.ReleaseBuffer();

//******************************************************************************
//                  tH_̐
//******************************************************************************
	enum{
		STATUS_NOT_CHECKED,				//`FbNO;ftHg
		STATUS_OK,						//t@C͎gp\
		STATUS_NETWORK,					//o͐̓lbg[NhCuł
		STATUS_REMOVABLE,				//o͐̓[oufBXNł
		STATUS_CANNOT_DECIDE_FILENAME	//t@CłȂ
	};

	int Status=STATUS_NOT_CHECKED;

//=================================================================================
// o͐悪lbg[NhCu/[oufBXNłȂAo͐I
//=================================================================================
	if(Config.Common.WarnNetwork||Config.Common.WarnRemovable){
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);
		_tcsncpy(Buffer,OutputDir,_MAX_PATH);
		//[ghCupX擾
		PathStripToRoot(Buffer);

		switch(GetDriveType(Buffer)){
		case DRIVE_REMOVABLE://hCufBXN𔲂Ƃł܂B
		case DRIVE_CDROM://CD-ROM
			if(Config.Common.WarnRemovable){
				if(IDNO==MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_ISOK_REMOVABLE)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					Status=STATUS_REMOVABLE;
				}
			}
			break;

		case DRIVE_REMOTE://[g (lbg[N) hCułB
		case DRIVE_NO_ROOT_DIR:
			if(Config.Common.WarnNetwork){
				if(IDNO==MessageBox(NULL,CString(MAKEINTRESOURCE(IDS_ASK_ISOK_NETWORK)),UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
					Status=STATUS_NETWORK;
				}
			}
			break;
		}
	}
	if(STATUS_NOT_CHECKED==Status&&!PathIsDirectory(OutputDir)){
		CString msg;
		//pX݂Ȃꍇ
		switch(Config.Common.OnDirNotFound){
		case LOSTDIR_ASK_TO_CREATE:	//쐬邩ǂ
			TRACE("fBNg%s쐬mF\n",OutputDir);
			msg.Format(IDS_ASK_CREATE_DIR,OutputDir);
			if(IDNO==MessageBox(NULL,msg,UtilGetMessageCaption(),MB_YESNO|MB_ICONQUESTION)){
				TRACE("-->쐬\n");
				return false;
			}
			TRACE("-->쐬\n");
			//FALLTHROUGH
		case LOSTDIR_FORCE_CREATE:	//fBNg쐬
			TRACE("fBNg%s쐬\n",OutputDir);
			if(!MakeSureDirectoryPathExists(OutputDir)){
				msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,OutputDir);
				ErrorMessage(msg);
				return false;
			}
			break;
		default://G[ƌȂ
			TRACE("fBNg%s݂\n",OutputDir);
			msg.Format(IDS_ERROR_DIR_NOTFOUND,OutputDir);
			ErrorMessage(msg);
			return false;
		}
	}


//******************************************************************************

	//--------------------------------------
	// tH_쐬ĂKvꍇ
	//--------------------------------------
	bool bCreateDir=false;	//tH_쐬ꍇɂtrue
	if(
		(!Config.Common.Extract.CreateNoFolderIfSingleFileOnly||ItemCount!=1)&&
			(
				((CREATE_OUTPUT_DIR_SINGLE==Config.Common.Extract.CreateDir)&&!bInFolder)||
				(CREATE_OUTPUT_DIR_ALWAYS==Config.Common.Extract.CreateDir)
			)
	){
		TCHAR Buffer[_MAX_PATH+1];
		FILL_ZERO(Buffer);

		_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
		PathStripPath(Buffer);	//pXt@C擾
		PathRemoveExtension(Buffer);	//A[JCut@Cgq폜

		//tH_̐ƋL菜
		if(Config.Common.Extract.RemoveSymbolAndNumber){
			for(int i=_tcslen(Buffer)-1;i>=0;i--){
				if(UtilIsSBSymbolorNumber(Buffer,i)){
					Buffer[i]=_T('\0');
				}else{
					break;
				}
			}
			//ƋL菜ʁA񂪋ɂȂĂ܂ĂƂɂǂ
			if(0==_tcslen(Buffer)){
				_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
				PathStripPath(Buffer);	//pXt@C擾
				PathRemoveExtension(Buffer);	//A[JCut@Cgq폜
			}
		}

		PathAddBackslash(Buffer);
		OutputDir+=Buffer;
		bCreateDir=true;
	}
	//======================
	// pXƂ
	//======================
	if(STATUS_NOT_CHECKED==Status){
		if(_tcslen(OutputDir)>=_MAX_PATH){
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_MAX_PATH)));
			Status=STATUS_CANNOT_DECIDE_FILENAME;
		}
	}

	//============================================================
	// ܂ł̃`FbNɂt@CłȂƂꂽꍇ
	//============================================================
	if(STATUS_NOT_CHECKED==Status){
		// ɃN[tȂOKƂƁB
		Status=STATUS_OK;
	}
	if(STATUS_OK!=Status){
	//==================
	// Otĕۑ
	//==================
		CString title(MAKEINTRESOURCE(IDS_INPUT_TARGET_FOLDER_WITH_SHIFT));
		CFolderDialog dlg(NULL,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
		if(IDOK==dlg.DoModal()){
			bUseRest=(GetKeyState(VK_SHIFT)<0);
			OutputDir=dlg.GetFolderPath();
			PathAddBackslash(OutputDir.GetBuffer(_MAX_PATH+1));
			OutputDir.ReleaseBuffer();
			if(
				((CREATE_OUTPUT_DIR_SINGLE==Config.Common.Extract.CreateDir)&&!bInFolder)||
				(CREATE_OUTPUT_DIR_ALWAYS==Config.Common.Extract.CreateDir)
			){
				TCHAR Buffer[_MAX_PATH+1];
				FILL_ZERO(Buffer);

				_tcsncpy(Buffer,ArcFileName,_MAX_PATH);
				PathStripPath(Buffer);	//pXt@C擾
				PathRemoveExtension(Buffer);	//t@Cgq폜
				PathAddBackslash(Buffer);
				OutputDir+=Buffer;
			}
		}
		else{
			return false;
		}
	}

//******************************************************************************

	//o͐(A[JCuƓ̃tH_܂߂)tH_݂邱Ƃۏ؂
	if(!MakeSureDirectoryPathExists(OutputDir)){
		CString msg;
		msg.Format(IDS_ERROR_CANNOT_MAKE_DIR,OutputDir);
		ErrorMessage(msg);
		return false;
	}
	//o͐fBNgJgfBNgɐݒ
	if(!SetCurrentDirectory(OutputDir)){
		CString msg;
		msg.Format(IDS_ERROR_CANNOT_SET_CURRENT_DIR,OutputDir);
		ErrorMessage(msg);
		return false;
	}
	TRACE("CurrentDirectory is %s\n",OutputDir);

	//o͐tH_Ԃ
	retOutputDir=OutputDir;

	//JpX̑gݗ
	TCHAR OpenDir[_MAX_PATH+1]={0};
	_tcsncpy(OpenDir,OutputDir,_MAX_PATH);
	if(!bCreateDir){	//tH_쐬Ȃꍇ
		if(Config.Common.Extract.CreateNoFolderIfSingleFileOnly&&ItemCount==1){
			//t@CEtH_ł邽߃tH_쐬Ȃ
			//Nothing to do
		}
		else if(CREATE_OUTPUT_DIR_SINGLE==Config.Common.Extract.CreateDir&&bInFolder){
			//dɃtH_Ȃݒɏ]AtH_쐬Ȃ
			PathAppend(OpenDir,BaseDir);
			PathAddBackslash(OpenDir);
		}
	}
	PathQuoteSpaces(OpenDir);
	//JpXԂ
	retOpenDir=OpenDir;
	return true;
}

