/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2007/04/01 02:01:17 $ UTC
//   Revision   $Revision: 1.6 $
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// ShellExtClassFactory.cpp : VFg NXt@Ng[NX̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ShellExtClassFactory.h"
#include "MenuData.h"
#include "MenuExtension.h"
#include "Main.h"

/*-------------------------------------------------------------------------*/
// CShellExtClassFactory	RXgN^EfXgN^
/*-------------------------------------------------------------------------*/

// CShellExtClassFactory
CShellExtClassFactory::CShellExtClassFactory(bool bRightDrag)
	: m_cRef(0L),IsRightDrag(bRightDrag)
{
	dprintf("CShellExtClassFactory::CShellExtClassFactory\n");

	InterlockedIncrement((long *)&g_cDllRef);	
}

// ~CShellExtClassFactory
CShellExtClassFactory::~CShellExtClassFactory()
{
	dprintf("CShellExtClassFactory::~CShellExtClassFactory\n");

	InterlockedDecrement((long *)&g_cDllRef);
}

/*-------------------------------------------------------------------------*/
// CShellExtClassFactory	
//
//			IUnknown C^[tFCX̃\bhQ
//
//				QueryInterface
//				AddRef
//				Release
//
/*-------------------------------------------------------------------------*/

// QueryInterface
STDMETHODIMP CShellExtClassFactory::QueryInterface(
	REFIID		riid,
	LPVOID FAR*	ppv)
{
	dprintf("CShellExtClassFactory::QueryInterface\n");

	HRESULT hr = E_NOINTERFACE;
	*ppv = NULL;
	if(IsEqualIID(riid, IID_IUnknown) || IsEqualIID(riid, IID_IClassFactory))	{
		*ppv = (LPCSHELLEXTCLASSFACTORY)this;
		static_cast<IUnknown*>(*ppv)->AddRef();
		hr = NOERROR;
	}
	return hr;
}

// AddRef
STDMETHODIMP_(ULONG) CShellExtClassFactory::AddRef()
{
	dprintf("CShellExtClassFactory::AddRef (m_cRef=%d)\n",m_cRef);

	InterlockedIncrement((long *)&m_cRef);
	return m_cRef;
}

// Release
STDMETHODIMP_(ULONG) CShellExtClassFactory::Release()
{
	dprintf("CShellExtClassFactory::Release (m_cRef=%d)\n",m_cRef);

	ULONG	theRef = InterlockedDecrement((long *)&m_cRef);
	if(theRef == 0L)	{
		delete this;
	}
	return theRef;	// [JϐgĂ̂ delete łlԂ悤
}

/*-------------------------------------------------------------------------*/
// CShellExtClassFactory	
//
//			IClassFactory C^[tFCX̃\bhQ
//
//				CreateInstance
//				LockServer
//
/*-------------------------------------------------------------------------*/

// CreateInstance
STDMETHODIMP CShellExtClassFactory::CreateInstance(
	LPUNKNOWN	pUnkOuter,
	REFIID		riid,
	LPVOID*		ppv)
{
 	dprintf("CShellExtClassFactory::CreateInstance\n");

	HRESULT hr = S_OK;
	LPCMENUEXTENSION pShellExt = (LPCMENUEXTENSION)NULL;

	*ppv = NULL;

	if(pUnkOuter != (LPUNKNOWN)NULL){
		// AOQ[VT|[gȂB
		hr = CLASS_E_NOAGGREGATION;
	}
	else{
		// R|[lg̍쐬ƏsB
		pShellExt = new CMenuExtension(IsRightDrag);
		if(NULL == pShellExt){
    		hr = E_OUTOFMEMORY;
			dprintf("\tCreateInstance: new CMenuExtension = NULL\n");
		}
		else{
			dprintf("\tCreateInstance: new CMenuExtension\n");
		}
	}

	if(hr == S_OK)	{
		// C^[tF[XvB
		hr = pShellExt->QueryInterface(riid, ppv);
	}
	return hr;
}

// LockServer
STDMETHODIMP CShellExtClassFactory::LockServer(
	BOOL	fLock)
{
	dprintf("CShellExtClassFactory::LockServer\n");

	UNREFERENCED_PARAMETER(fLock);
	return NOERROR;
}
