/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2007/04/01 02:01:39 $ UTC
//   Revision   $Revision: 1.7 $
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// registry.cpp :	WXgւ̓o^ƍ폜̒`
//					LhaForgegj[
//
//	Original File Information:
// registry.cpp :	WXgւ̓o^ƍ폜̒`
//					l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "registry.h"

#include "resource.h"

const int CLSID_STRING_SIZE=(39 + 1);
extern	HINSTANCE	g_hInstDLL;


// VFGNXeVo^gqꗗ
static const char	*g_ExtList[] =
{
	"*",	//ׂẴt@C
	"Directory",//tH_
	"Drive",	//hCu
	NULL
};


static void WINAPI CLSIDtoMBCS(REFCLSID, char *, long);
static BOOL WINAPI SetKeyAndValue(HKEY, const char *, const char *, const char *);
static LONG RecursiveDeleteKey(HKEY, const char *);
static BOOL DeleteNamedValue(HKEY, const char *, const char *);

STDAPI RegisterServer(
	HMODULE		inModuleH,
	REFCLSID	inClsid,
	bool IsRightDragHandler)
{
	char	theDllPath[_MAX_PATH];
	char	theCLSID[CLSID_STRING_SIZE];
	char	theKey[_MAX_PATH];
	int		i;

	// o^pDLL̃tpX擾B
	GetModuleFileName(inModuleH, theDllPath, sizeof(theDllPath));

	// nꂽNXIDAWXgL[쐬B
	//   "CLSID\xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx"
	CLSIDtoMBCS(inClsid, theCLSID, sizeof(theCLSID));
	sprintf(theKey, "CLSID\\%s", theCLSID);

	TCHAR AppName[256];
	::LoadString(g_hInstDLL,IDS_PROGRAM_NAME,AppName,256);

	// CLSIDƃR|[lgo^B
	SetKeyAndValue(HKEY_CLASSES_ROOT, theKey, NULL, AppName);

	// sW[o^B
	strcat(theKey, "\\InprocServer32");
	SetKeyAndValue(HKEY_CLASSES_ROOT, theKey, NULL, theDllPath);
	SetKeyAndValue(HKEY_CLASSES_ROOT, theKey, "ThreadingModel", "Apartment");

	if(IsRightDragHandler){
		//----------------------------------
		// EhbOj[nh̓o^
		//----------------------------------

		// Folder  hbO&hbvnh Ƃēo^
		char DnDHandlerKey[_MAX_PATH];
		sprintf(DnDHandlerKey, "Folder\\shellex\\DragDropHandlers\\%s", AppName);
		SetKeyAndValue(HKEY_CLASSES_ROOT,
			DnDHandlerKey,
			NULL,
			theCLSID);
		// Drive  hbO&hbvnh Ƃēo^
		sprintf(DnDHandlerKey, "Drive\\shellex\\DragDropHandlers\\%s", AppName);
		SetKeyAndValue(HKEY_CLASSES_ROOT,
			DnDHandlerKey,
			NULL,
			theCLSID);
	}
	else{
		//----------------------------------
		// ENbNj[nh̓o^
		//----------------------------------

		// egqContextMenuHandlersnho^B
		for(i = 0; g_ExtList[i]; i++)	{
			sprintf(theKey, "%s\\shellex\\ContextMenuHandlers\\%s", g_ExtList[i],AppName);
			SetKeyAndValue(HKEY_CLASSES_ROOT,
				theKey,
				NULL,
				theCLSID);
		}
	}


	// NT/2000p̏o^邪Aɂ́AAdministratorKvB
	// sꍇ́AB
	SetKeyAndValue(HKEY_LOCAL_MACHINE,
				   "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved",
				   theCLSID,
				   AppName);

	return S_OK;
}


STDAPI UnregisterServer(
	REFCLSID	inClsid,
	bool IsRightDragHandler)
{
	char	theCLSID[CLSID_STRING_SIZE];
	char	theKey[_MAX_PATH];
	int		i;

	// Convert the CLSID into a char.
	CLSIDtoMBCS(inClsid, theCLSID, sizeof(theCLSID)) ;

	// CLSID\{...}
	sprintf(theKey, "CLSID\\%s", theCLSID);

	// "HKEY_CLASSES_ROOT\CLSID"ANXID̃Gg폜B
	RecursiveDeleteKey(HKEY_CLASSES_ROOT, theKey);

	TCHAR AppName[256];
	::LoadString(g_hInstDLL,IDS_PROGRAM_NAME,AppName,256);

	if(IsRightDragHandler){
		//----------------------------------
		// EhbOj[nh̉
		//----------------------------------

		// Folder  hbO&hbvnh 
		char DnDHandlerKey[_MAX_PATH];
		sprintf(DnDHandlerKey, "Folder\\shellex\\DragDropHandlers\\%s", AppName);
		RecursiveDeleteKey(HKEY_CLASSES_ROOT,DnDHandlerKey);
		// Drive  hbO&hbvnh 
		sprintf(DnDHandlerKey, "Drive\\shellex\\DragDropHandlers\\%s", AppName);
		RecursiveDeleteKey(HKEY_CLASSES_ROOT,DnDHandlerKey);
	}
	else{
		//----------------------------------
		// ENbNj[nh̉
		//----------------------------------

		// egqContextMenuHandlersnh̓o^B
		for(i = 0; g_ExtList[i]; i++)	{
			sprintf(theKey, "%s\\shellex\\ContextMenuHandlers\\%s", g_ExtList[i],AppName);
			RecursiveDeleteKey(HKEY_CLASSES_ROOT,theKey);
		}
	}


	// NT/2000p̏폜Bɂ́AAdministratorKvB
	DeleteNamedValue(HKEY_LOCAL_MACHINE,
					 "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved",
					 theCLSID);

	return S_OK ;
}


// CLSIDSJISɕϊB
static void WINAPI CLSIDtoMBCS(
	REFCLSID	inClsid,
	char*		outCLSID,
	long		inSize)
{
	WCHAR	theCLSID[CLSID_STRING_SIZE];

	// NXID𕶎ɕϊB
	StringFromGUID2(inClsid, theCLSID, sizeof(theCLSID));

	// ChSJISɕϊB
	memset(outCLSID, 0, inSize);
	WideCharToMultiByte(CP_ACP, 0, theCLSID, -1, outCLSID, inSize, NULL, NULL);
}


static BOOL WINAPI SetKeyAndValue(
	HKEY		inKeyRootH,
	const char*	inKey,
	const char*	inValueName,
	const char*	inValue)
{
	HKEY	theKeyH;
	long	result;

	// 쐬L[ŃL[쐬or擾B
	result = RegCreateKeyEx(inKeyRootH,
							 inKey,
							 0,
							 NULL,
							 REG_OPTION_NON_VOLATILE,
							 KEY_ALL_ACCESS,
							 NULL,
							 &theKeyH,
							 NULL);
	if (result != ERROR_SUCCESS)	{
		return FALSE;
	}

	// lݒ肷B
	if (inValue != NULL)	{
		RegSetValueEx(theKeyH,
					  inValueName,
					  0,
					  REG_SZ,
					  (BYTE *)inValue,
					  strlen(inValue) + 1);
	}
	RegCloseKey(theKeyH);
	return TRUE;
}


// ċNIWXg폜
static LONG RecursiveDeleteKey(
	HKEY		inKeyParentH,
	const char*	inKeyChild)
{
	HKEY		theKeyChildH;
	long		theRes;
	FILETIME	theTime;
	char		theBuffer[256];
	DWORD		theSize;

	// Open the child.
	theRes = RegOpenKeyEx(inKeyParentH, inKeyChild, 0, KEY_ALL_ACCESS, &theKeyChildH);
	if (theRes != ERROR_SUCCESS)	{
		return theRes;
	}

	// Enumerate all of the decendents of this child.
	theSize = 256;
	while (RegEnumKeyEx(theKeyChildH, 0, theBuffer, &theSize, NULL, NULL, NULL, &theTime) == S_OK)	{
		// Delete the decendents of this child.
		theRes = RecursiveDeleteKey(theKeyChildH, theBuffer);
		if (theRes != ERROR_SUCCESS)	{
			// Cleanup before exiting.
			RegCloseKey(theKeyChildH) ;
			return theRes;
		}
		theSize = 256;
	}

	// Close the child.
	RegCloseKey(theKeyChildH) ;

	// Delete this child.
	return RegDeleteKey(inKeyParentH, inKeyChild) ;
}


// Otl̍폜
static BOOL DeleteNamedValue(
	HKEY		inKeyRootH,
	const char	*inSubKey,
	const char	*inValueName)
{
	HKEY	theKeyH;
	long	result;
	DWORD	theDisposition;

	// 
	result = RegCreateKeyEx(inKeyRootH,
							 inSubKey,
							 0,
							 NULL,
							 REG_OPTION_NON_VOLATILE,
							 KEY_ALL_ACCESS,
							 NULL,
							 &theKeyH,
							 &theDisposition);
	if(result != ERROR_SUCCESS)	{
		return FALSE;
	}

	if(theDisposition == REG_CREATED_NEW_KEY)	{
		// VL[쐬Ă܂ꍇ́A
		// ̃L[폜āAIB
		RegCloseKey(theKeyH);
		RegDeleteKey(inKeyRootH, inSubKey);
		return FALSE;
	}

	// Otl̍폜B
	RegDeleteValue(theKeyH, inValueName);
	RegCloseKey(theKeyH);
	return TRUE;
}
